#include "../../pmu-events/pmu-events.h"
struct pmu_event pme_power8[] = {
{
	.name = "pm_derat_miss_16g",
	.event = "event=0x4c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 16G",
	.topic = "translation",
},
{
	.name = "pm_derat_miss_16m",
	.event = "event=0x3c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 16M",
	.topic = "translation",
},
{
	.name = "pm_derat_miss_4k",
	.event = "event=0x1c056",
	.desc = "Data ERAT Miss (Data TLB Access) page size 4K",
	.topic = "translation",
},
{
	.name = "pm_derat_miss_64k",
	.event = "event=0x2c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 64K",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dl2l3_mod",
	.event = "event=0x4e048",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dl2l3_shr",
	.event = "event=0x3e048",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l2",
	.event = "event=0x1e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l2miss",
	.event = "event=0x1e04e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L2 due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l2_mepf",
	.event = "event=0x2e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l2_no_conflict",
	.event = "event=0x1e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l3",
	.event = "event=0x4e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l3_disp_conflict",
	.event = "event=0x3e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l3_mepf",
	.event = "event=0x2e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_l3_no_conflict",
	.event = "event=0x1e044",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_ll4",
	.event = "event=0x1e04c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_lmem",
	.event = "event=0x2e048",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_memory",
	.event = "event=0x2e04c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_off_chip_cache",
	.event = "event=0x4e04a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_on_chip_cache",
	.event = "event=0x1e048",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_rl2l3_mod",
	.event = "event=0x2e046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_rl2l3_shr",
	.event = "event=0x1e04a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_rl4",
	.event = "event=0x2e04a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a data side request",
	.topic = "translation",
},
{
	.name = "pm_dtlb_miss",
	.event = "event=0x300fc",
	.desc = "Data PTEG reload",
	.topic = "translation",
	.long_desc = "Data PTEG Reloaded (DTLB Miss)",
},
{
	.name = "pm_dtlb_miss_16g",
	.event = "event=0x1c058",
	.desc = "Data TLB Miss page size 16G",
	.topic = "translation",
},
{
	.name = "pm_dtlb_miss_16m",
	.event = "event=0x4c056",
	.desc = "Data TLB Miss page size 16M",
	.topic = "translation",
},
{
	.name = "pm_dtlb_miss_4k",
	.event = "event=0x2c056",
	.desc = "Data TLB Miss page size 4k",
	.topic = "translation",
},
{
	.name = "pm_dtlb_miss_64k",
	.event = "event=0x3c056",
	.desc = "Data TLB Miss page size 64K",
	.topic = "translation",
},
{
	.name = "pm_lsu_derat_miss",
	.event = "event=0x200f6",
	.desc = "DERAT Reloaded due to a DERAT miss",
	.topic = "translation",
	.long_desc = "DERAT Reloaded (Miss)",
},
{
	.name = "pm_tlb_miss",
	.event = "event=0x20066",
	.desc = "TLB Miss (I + D)",
	.topic = "translation",
},
{
	.name = "pm_chip_pump_cpred",
	.event = "event=0x10050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for all data types ( demand load,data,inst prefetch,inst fetch,xlate (I or d)",
},
{
	.name = "pm_data_chip_pump_cpred",
	.event = "event=0x1c050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for a demand load",
	.topic = "memory",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for a demand load",
},
{
	.name = "pm_data_from_dmem",
	.event = "event=0x4c04c",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to a demand load",
	.topic = "memory",
	.long_desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_lmem",
	.event = "event=0x2c048",
	.desc = "The processor's data cache was reloaded from the local chip's Memory due to a demand load",
	.topic = "memory",
	.long_desc = "The processor's data cache was reloaded from the local chip's Memory due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_memory",
	.event = "event=0x2c04c",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a demand load",
	.topic = "memory",
	.long_desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_rl4",
	.event = "event=0x2c04a",
	.desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to a demand load",
	.topic = "memory",
	.long_desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_rmem",
	.event = "event=0x3c04a",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to a demand load",
	.topic = "memory",
	.long_desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_grp_pump_cpred",
	.event = "event=0x2c050",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for a demand load",
	.topic = "memory",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for a demand load",
},
{
	.name = "pm_data_grp_pump_mpred",
	.event = "event=0x2c052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for a demand load",
	.topic = "memory",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_data_grp_pump_mpred_rty",
	.event = "event=0x1c052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for a demand load",
	.topic = "memory",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor a demand load",
},
{
	.name = "pm_data_pump_cpred",
	.event = "event=0x1c054",
	.desc = "Pump prediction correct. Counts across all types of pumps for a demand load",
	.topic = "memory",
},
{
	.name = "pm_data_pump_mpred",
	.event = "event=0x4c052",
	.desc = "Pump misprediction. Counts across all types of pumps for a demand load",
	.topic = "memory",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor a demand load",
},
{
	.name = "pm_data_sys_pump_cpred",
	.event = "event=0x3c050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for a demand load",
	.topic = "memory",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for a demand load",
},
{
	.name = "pm_data_sys_pump_mpred",
	.event = "event=0x3c052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for a demand load",
	.topic = "memory",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_data_sys_pump_mpred_rty",
	.event = "event=0x4c050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for a demand load",
	.topic = "memory",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for a demand load",
},
{
	.name = "pm_dpteg_from_dl4",
	.event = "event=0x3e04c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a data side request",
	.topic = "memory",
},
{
	.name = "pm_dpteg_from_dmem",
	.event = "event=0x4e04c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a data side request",
	.topic = "memory",
},
{
	.name = "pm_dpteg_from_rmem",
	.event = "event=0x3e04a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a data side request",
	.topic = "memory",
},
{
	.name = "pm_grp_pump_cpred",
	.event = "event=0x20050",
	.desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
},
{
	.name = "pm_grp_pump_mpred",
	.event = "event=0x20052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_grp_pump_mpred_rty",
	.event = "event=0x10052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_l3_co_mepf",
	.event = "event=0x18082",
	.desc = "L3 CO of line in Mep state ( includes casthrough",
	.topic = "memory",
},
{
	.name = "pm_mem_co",
	.event = "event=0x4c058",
	.desc = "Memory castouts from this lpar",
	.topic = "memory",
},
{
	.name = "pm_mem_loc_thresh_ifu",
	.event = "event=0x10058",
	.desc = "Local Memory above threshold for IFU speculation control",
	.topic = "memory",
},
{
	.name = "pm_mem_loc_thresh_lsu_high",
	.event = "event=0x40056",
	.desc = "Local memory above threshold for LSU medium",
	.topic = "memory",
},
{
	.name = "pm_mem_loc_thresh_lsu_med",
	.event = "event=0x1c05e",
	.desc = "Local memory above theshold for data prefetch",
	.topic = "memory",
},
{
	.name = "pm_mem_pref",
	.event = "event=0x2c058",
	.desc = "Memory prefetch for this lpar. Includes L4",
	.topic = "memory",
},
{
	.name = "pm_mem_read",
	.event = "event=0x10056",
	.desc = "Reads from Memory from this lpar (includes data/inst/xlate/l1prefetch/inst prefetch). Includes L4",
	.topic = "memory",
},
{
	.name = "pm_mem_rwitm",
	.event = "event=0x3c05e",
	.desc = "Memory rwitm for this lpar",
	.topic = "memory",
},
{
	.name = "pm_nest_ref_clk",
	.event = "event=0x3006e",
	.desc = "Multiply by 4 to obtain the number of PB cycles",
	.topic = "memory",
	.long_desc = "Nest reference clocks",
},
{
	.name = "pm_pump_cpred",
	.event = "event=0x10054",
	.desc = "Pump prediction correct. Counts across all types of pumps for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Pump prediction correct. Counts across all types of pumpsfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_pump_mpred",
	.event = "event=0x40052",
	.desc = "Pump misprediction. Counts across all types of pumps for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_sys_pump_cpred",
	.event = "event=0x30050",
	.desc = "Initial and Final Pump Scope was system pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_sys_pump_mpred",
	.event = "event=0x30052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_sys_pump_mpred_rty",
	.event = "event=0x40050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "memory",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_data_from_dl2l3_mod",
	.event = "event=0x4c048",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_dl2l3_shr",
	.event = "event=0x3c048",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_dl4",
	.event = "event=0x3c04c",
	.desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2",
	.event = "event=0x1c042",
	.desc = "The processor's data cache was reloaded from local core's L2 due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L2 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2miss",
	.event = "event=0x200fe",
	.desc = "Demand LD - L2 Miss (not L2 hit)",
	.topic = "cache",
},
{
	.name = "pm_data_from_l2miss_mod",
	.event = "event=0x1c04e",
	.desc = "The processor's data cache was reloaded from a localtion other than the local core's L2 due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from a localtion other than the local core's L2 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2_disp_conflict_ldhitst",
	.event = "event=0x3c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2_disp_conflict_other",
	.event = "event=0x4c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2_mepf",
	.event = "event=0x2c040",
	.desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l2_no_conflict",
	.event = "event=0x1c040",
	.desc = "The processor's data cache was reloaded from local core's L2 without conflict due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L2 without conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l3",
	.event = "event=0x4c042",
	.desc = "The processor's data cache was reloaded from local core's L3 due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L3 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l3miss",
	.event = "event=0x300fe",
	.desc = "Demand LD - L3 Miss (not L2 hit and not L3 hit)",
	.topic = "cache",
},
{
	.name = "pm_data_from_l3miss_mod",
	.event = "event=0x4c04e",
	.desc = "The processor's data cache was reloaded from a localtion other than the local core's L3 due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from a localtion other than the local core's L3 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l3_disp_conflict",
	.event = "event=0x3c042",
	.desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l3_mepf",
	.event = "event=0x2c042",
	.desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l3_no_conflict",
	.event = "event=0x1c044",
	.desc = "The processor's data cache was reloaded from local core's L3 without conflict due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from local core's L3 without conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_ll4",
	.event = "event=0x1c04c",
	.desc = "The processor's data cache was reloaded from the local chip's L4 cache due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded from the local chip's L4 cache due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_off_chip_cache",
	.event = "event=0x4c04a",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_on_chip_cache",
	.event = "event=0x1c048",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_rl2l3_mod",
	.event = "event=0x2c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_rl2l3_shr",
	.event = "event=0x1c04a",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a demand load",
	.topic = "cache",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_tablewalk_cyc",
	.event = "event=0x3001a",
	.desc = "Tablwalk Cycles (could be 1 or 2 active)",
	.topic = "cache",
	.long_desc = "Data Tablewalk Active",
},
{
	.name = "pm_dpteg_from_l3miss",
	.event = "event=0x4e04e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L3 due to a data side request",
	.topic = "cache",
},
{
	.name = "pm_dslb_miss",
	.event = "event=0xd094",
	.desc = "Data SLB Miss - Total of all segment sizes",
	.topic = "cache",
	.long_desc = "Data SLB Miss - Total of all segment sizesData SLB misses",
},
{
	.name = "pm_l1_dcache_reloaded_all",
	.event = "event=0x1002c",
	.desc = "L1 data cache reloaded for demand or prefetch",
	.topic = "cache",
},
{
	.name = "pm_l1_dcache_reload_valid",
	.event = "event=0x300f6",
	.desc = "DL1 reloaded due to Demand Load",
	.topic = "cache",
},
{
	.name = "pm_ld_miss_l1",
	.event = "event=0x3e054",
	.desc = "Load Missed L1",
	.topic = "cache",
},
{
	.name = "pm_ld_ref_l1",
	.event = "event=0x100ee",
	.desc = "All L1 D cache load references counted at finish, gated by reject",
	.topic = "cache",
	.long_desc = "Load Ref count combined for all units",
},
{
	.name = "pm_st_miss_l1",
	.event = "event=0x300f0",
	.desc = "Store Missed L1",
	.topic = "cache",
},
{
	.name = "pm_mrk_back_br_cmpl",
	.event = "event=0x3515e",
	.desc = "Marked branch instruction completed with a target address less than current instruction address",
	.topic = "marked",
},
{
	.name = "pm_mrk_bru_fin",
	.event = "event=0x2013a",
	.desc = "bru marked instr finish",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_cmpl",
	.event = "event=0x1016e",
	.desc = "Branch Instruction completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_mpred_cmpl",
	.event = "event=0x301e4",
	.desc = "Marked Branch Mispredicted",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_taken_cmpl",
	.event = "event=0x101e2",
	.desc = "Marked Branch Taken completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl2l3_mod",
	.event = "event=0x4d148",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl2l3_mod_cyc",
	.event = "event=0x2d128",
	.desc = "Duration in cycles to reload with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl2l3_shr",
	.event = "event=0x3d148",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl2l3_shr_cyc",
	.event = "event=0x2c128",
	.desc = "Duration in cycles to reload with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl4",
	.event = "event=0x3d14c",
	.desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl4_cyc",
	.event = "event=0x2c12c",
	.desc = "Duration in cycles to reload from another chip's L4 on a different Node or Group (Distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dmem",
	.event = "event=0x4d14c",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dmem_cyc",
	.event = "event=0x2d12c",
	.desc = "Duration in cycles to reload from another chip's memory on the same Node or Group (Distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2",
	.event = "event=0x1d142",
	.desc = "The processor's data cache was reloaded from local core's L2 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2miss",
	.event = "event=0x1d14e",
	.desc = "Data cache reload L2 miss",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2miss_cyc",
	.event = "event=0x4c12e",
	.desc = "Duration in cycles to reload from a localtion other than the local core's L2 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_cyc",
	.event = "event=0x4c122",
	.desc = "Duration in cycles to reload from local core's L2 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_ldhitst",
	.event = "event=0x3d140",
	.desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_ldhitst_cyc",
	.event = "event=0x2c120",
	.desc = "Duration in cycles to reload from local core's L2 with load hit store conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_other",
	.event = "event=0x4d140",
	.desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_other_cyc",
	.event = "event=0x2d120",
	.desc = "Duration in cycles to reload from local core's L2 with dispatch conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_mepf",
	.event = "event=0x2d140",
	.desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_mepf_cyc",
	.event = "event=0x4d120",
	.desc = "Duration in cycles to reload from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_no_conflict",
	.event = "event=0x1d140",
	.desc = "The processor's data cache was reloaded from local core's L2 without conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_no_conflict_cyc",
	.event = "event=0x4c120",
	.desc = "Duration in cycles to reload from local core's L2 without conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3",
	.event = "event=0x4d142",
	.desc = "The processor's data cache was reloaded from local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3miss",
	.event = "event=0x201e4",
	.desc = "The processor's data cache was reloaded from a localtion other than the local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3miss_cyc",
	.event = "event=0x2d12e",
	.desc = "Duration in cycles to reload from a localtion other than the local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_cyc",
	.event = "event=0x2d122",
	.desc = "Duration in cycles to reload from local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_disp_conflict",
	.event = "event=0x3d142",
	.desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_disp_conflict_cyc",
	.event = "event=0x2c122",
	.desc = "Duration in cycles to reload from local core's L3 with dispatch conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_mepf",
	.event = "event=0x2d142",
	.desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_mepf_cyc",
	.event = "event=0x4d122",
	.desc = "Duration in cycles to reload from local core's L3 without dispatch conflicts hit on Mepf state. due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_no_conflict",
	.event = "event=0x1d144",
	.desc = "The processor's data cache was reloaded from local core's L3 without conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3_no_conflict_cyc",
	.event = "event=0x4c124",
	.desc = "Duration in cycles to reload from local core's L3 without conflict due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_ll4",
	.event = "event=0x1d14c",
	.desc = "The processor's data cache was reloaded from the local chip's L4 cache due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_ll4_cyc",
	.event = "event=0x4c12c",
	.desc = "Duration in cycles to reload from the local chip's L4 cache due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_lmem",
	.event = "event=0x2d148",
	.desc = "The processor's data cache was reloaded from the local chip's Memory due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_lmem_cyc",
	.event = "event=0x4d128",
	.desc = "Duration in cycles to reload from the local chip's Memory due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_memory",
	.event = "event=0x2d14c",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_memory_cyc",
	.event = "event=0x4d12c",
	.desc = "Duration in cycles to reload from a memory location including L4 from local remote or distant due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_off_chip_cache",
	.event = "event=0x4d14a",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_off_chip_cache_cyc",
	.event = "event=0x2d12a",
	.desc = "Duration in cycles to reload either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_on_chip_cache",
	.event = "event=0x1d148",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_on_chip_cache_cyc",
	.event = "event=0x4c128",
	.desc = "Duration in cycles to reload either shared or modified data from another core's L2/L3 on the same chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl2l3_mod",
	.event = "event=0x2d146",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl2l3_mod_cyc",
	.event = "event=0x4d126",
	.desc = "Duration in cycles to reload with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl2l3_shr",
	.event = "event=0x1d14a",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl2l3_shr_cyc",
	.event = "event=0x4c12a",
	.desc = "Duration in cycles to reload with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl4",
	.event = "event=0x2d14a",
	.desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rl4_cyc",
	.event = "event=0x4d12a",
	.desc = "Duration in cycles to reload from another chip's L4 on the same Node or Group ( Remote) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rmem",
	.event = "event=0x3d14a",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_rmem_cyc",
	.event = "event=0x2c12a",
	.desc = "Duration in cycles to reload from another chip's memory on the same Node or Group ( Remote) due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mrk_dcache_reload_intv",
	.event = "event=0x40118",
	.desc = "Combined Intervention event",
	.topic = "marked",
},
{
	.name = "pm_mrk_derat_miss",
	.event = "event=0x301e6",
	.desc = "Erat Miss (TLB Access) All page sizes",
	.topic = "marked",
},
{
	.name = "pm_mrk_derat_miss_16g",
	.event = "event=0x4d154",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 16G",
	.topic = "marked",
},
{
	.name = "pm_mrk_derat_miss_16m",
	.event = "event=0x3d154",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 16M",
	.topic = "marked",
},
{
	.name = "pm_mrk_derat_miss_4k",
	.event = "event=0x1d156",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 4K",
	.topic = "marked",
},
{
	.name = "pm_mrk_derat_miss_64k",
	.event = "event=0x2d154",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 64K",
	.topic = "marked",
},
{
	.name = "pm_mrk_dfu_fin",
	.event = "event=0x20132",
	.desc = "Decimal Unit marked Instruction Finish",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_dl2l3_mod",
	.event = "event=0x4f148",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_dl2l3_shr",
	.event = "event=0x3f148",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_dl4",
	.event = "event=0x3f14c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_dmem",
	.event = "event=0x4f14c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l2",
	.event = "event=0x1f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l2miss",
	.event = "event=0x1f14e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L2 due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l2_mepf",
	.event = "event=0x2f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l2_no_conflict",
	.event = "event=0x1f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3",
	.event = "event=0x4f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3miss",
	.event = "event=0x4f14e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L3 due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3_disp_conflict",
	.event = "event=0x3f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3_mepf",
	.event = "event=0x2f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3_no_conflict",
	.event = "event=0x1f144",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_ll4",
	.event = "event=0x1f14c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_lmem",
	.event = "event=0x2f148",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_memory",
	.event = "event=0x2f14c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_off_chip_cache",
	.event = "event=0x4f14a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_on_chip_cache",
	.event = "event=0x1f148",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_rl2l3_mod",
	.event = "event=0x2f146",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_rl2l3_shr",
	.event = "event=0x1f14a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_rl4",
	.event = "event=0x2f14a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_rmem",
	.event = "event=0x3f14a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a marked data side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_dtlb_miss",
	.event = "event=0x401e4",
	.desc = "Marked dtlb miss",
	.topic = "marked",
},
{
	.name = "pm_mrk_dtlb_miss_16g",
	.event = "event=0x1d158",
	.desc = "Marked Data TLB Miss page size 16G",
	.topic = "marked",
},
{
	.name = "pm_mrk_dtlb_miss_16m",
	.event = "event=0x4d156",
	.desc = "Marked Data TLB Miss page size 16M",
	.topic = "marked",
},
{
	.name = "pm_mrk_dtlb_miss_4k",
	.event = "event=0x2d156",
	.desc = "Marked Data TLB Miss page size 4k",
	.topic = "marked",
},
{
	.name = "pm_mrk_dtlb_miss_64k",
	.event = "event=0x3d156",
	.desc = "Marked Data TLB Miss page size 64K",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_bkill",
	.event = "event=0x40154",
	.desc = "Marked store had to do a bkill",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_bkill_cyc",
	.event = "event=0x2f150",
	.desc = "cycles L2 RC took for a bkill",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_claim_rty",
	.event = "event=0x3015e",
	.desc = "Sampled store did a rwitm and got a rty",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_dclaim",
	.event = "event=0x30154",
	.desc = "Marked store had to do a dclaim",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_dclaim_cyc",
	.event = "event=0x2f152",
	.desc = "cycles L2 RC took for a dclaim",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_rd_rty",
	.event = "event=0x4015e",
	.desc = "Sampled L2 reads retry count",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_rd_t_intv",
	.event = "event=0x1015e",
	.desc = "Sampled Read got a T intervention",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_rwitm_cyc",
	.event = "event=0x4f150",
	.desc = "cycles L2 RC took for a rwitm",
	.topic = "marked",
},
{
	.name = "pm_mrk_fab_rsp_rwitm_rty",
	.event = "event=0x2015e",
	.desc = "Sampled store did a rwitm and got a rty",
	.topic = "marked",
},
{
	.name = "pm_mrk_fxu_fin",
	.event = "event=0x20134",
	.desc = "fxu marked instr finish",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_cmpl",
	.event = "event=0x401e0",
	.desc = "marked instruction completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_decoded",
	.event = "event=0x20130",
	.desc = "marked instruction decoded",
	.topic = "marked",
	.long_desc = "marked instruction decoded. Name from ISU?",
},
{
	.name = "pm_mrk_inst_disp",
	.event = "event=0x101e0",
	.desc = "The thread has dispatched a randomly sampled marked instruction",
	.topic = "marked",
	.long_desc = "Marked Instruction dispatched",
},
{
	.name = "pm_mrk_inst_fin",
	.event = "event=0x30130",
	.desc = "marked instruction finished",
	.topic = "marked",
	.long_desc = "marked instr finish any unit",
},
{
	.name = "pm_mrk_inst_from_l3miss",
	.event = "event=0x401e6",
	.desc = "Marked instruction was reloaded from a location beyond the local chiplet",
	.topic = "marked",
	.long_desc = "n/a",
},
{
	.name = "pm_mrk_inst_issued",
	.event = "event=0x10132",
	.desc = "Marked instruction issued",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_timeo",
	.event = "event=0x40134",
	.desc = "marked Instruction finish timeout (instruction lost)",
	.topic = "marked",
},
{
	.name = "pm_mrk_l1_icache_miss",
	.event = "event=0x101e4",
	.desc = "sampled Instruction suffered an icache Miss",
	.topic = "marked",
	.long_desc = "Marked L1 Icache Miss",
},
{
	.name = "pm_mrk_l1_reload_valid",
	.event = "event=0x101ea",
	.desc = "Marked demand reload",
	.topic = "marked",
},
{
	.name = "pm_mrk_l2_rc_disp",
	.event = "event=0x20114",
	.desc = "Marked Instruction RC dispatched in L2",
	.topic = "marked",
},
{
	.name = "pm_mrk_l2_rc_done",
	.event = "event=0x3012a",
	.desc = "Marked RC done",
	.topic = "marked",
},
{
	.name = "pm_mrk_larx_fin",
	.event = "event=0x40116",
	.desc = "Larx finished",
	.topic = "marked",
},
{
	.name = "pm_mrk_ld_miss_exposed_cyc",
	.event = "event=0x1013e",
	.desc = "Marked Load exposed Miss cycles",
	.topic = "marked",
	.long_desc = "Marked Load exposed Miss (use edge detect to count #)",
},
{
	.name = "pm_mrk_ld_miss_l1",
	.event = "event=0x201e2",
	.desc = "Marked DL1 Demand Miss counted at exec time",
	.topic = "marked",
},
{
	.name = "pm_mrk_ld_miss_l1_cyc",
	.event = "event=0x4013e",
	.desc = "Marked ld latency",
	.topic = "marked",
},
{
	.name = "pm_mrk_lsu_fin",
	.event = "event=0x40132",
	.desc = "lsu marked instr finish",
	.topic = "marked",
},
{
	.name = "pm_mrk_ntf_fin",
	.event = "event=0x20112",
	.desc = "Marked next to finish instruction finished",
	.topic = "marked",
},
{
	.name = "pm_mrk_run_cyc",
	.event = "event=0x1d15e",
	.desc = "Marked run cycles",
	.topic = "marked",
},
{
	.name = "pm_mrk_stall_cmplu_cyc",
	.event = "event=0x3013e",
	.desc = "Marked Group completion Stall",
	.topic = "marked",
	.long_desc = "Marked Group Completion Stall cycles (use edge detect to count #)",
},
{
	.name = "pm_mrk_stcx_fail",
	.event = "event=0x3e158",
	.desc = "marked stcx failed",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_cmpl",
	.event = "event=0x10134",
	.desc = "marked store completed and sent to nest",
	.topic = "marked",
	.long_desc = "Marked store completed",
},
{
	.name = "pm_mrk_st_cmpl_int",
	.event = "event=0x30134",
	.desc = "marked store finished with intervention",
	.topic = "marked",
	.long_desc = "marked store complete (data home) with intervention",
},
{
	.name = "pm_mrk_st_drain_to_l2disp_cyc",
	.event = "event=0x3f150",
	.desc = "cycles to drain st from core to L2",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_fwd",
	.event = "event=0x3012c",
	.desc = "Marked st forwards",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_l2disp_to_cmpl_cyc",
	.event = "event=0x1f150",
	.desc = "cycles from L2 rc disp to l2 rc completion",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_nest",
	.event = "event=0x20138",
	.desc = "Marked store sent to nest",
	.topic = "marked",
},
{
	.name = "pm_mrk_vsu_fin",
	.event = "event=0x30132",
	.desc = "VSU marked instr finish",
	.topic = "marked",
	.long_desc = "vsu (fpu) marked instr finish",
},
{
	.name = "pm_mult_mrk",
	.event = "event=0x3d15e",
	.desc = "mult marked instr",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_br_link",
	.event = "event=0x15152",
	.desc = "Marked Branch and link branch that can cause a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_br_mpred",
	.event = "event=0x1515c",
	.desc = "Marked Branch mispredict that can cause a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_fx_divide",
	.event = "event=0x15156",
	.desc = "Marked fixed point divide that can cause a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_l2hit",
	.event = "event=0x15158",
	.desc = "Marked L2 Hits that can throw a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_l2miss",
	.event = "event=0x1515a",
	.desc = "Marked L2 Miss that can throw a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_l3miss",
	.event = "event=0x15154",
	.desc = "Marked L3 misses that can throw a synchronous interrupt",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_probe_nop",
	.event = "event=0x15150",
	.desc = "Marked probeNops which can cause synchronous interrupts",
	.topic = "marked",
},
{
	.name = "pm_fxu_busy",
	.event = "event=0x2000e",
	.desc = "fxu0 busy and fxu1 busy",
	.topic = "floating point",
},
{
	.name = "pm_fxu_idle",
	.event = "event=0x1000e",
	.desc = "fxu0 idle and fxu1 idle",
	.topic = "floating point",
},
{
	.name = "pm_pmc1_overflow",
	.event = "event=0x20010",
	.desc = "Overflow from counter 1",
	.topic = "pmc",
},
{
	.name = "pm_pmc2_overflow",
	.event = "event=0x30010",
	.desc = "Overflow from counter 2",
	.topic = "pmc",
},
{
	.name = "pm_pmc2_rewind",
	.event = "event=0x30020",
	.desc = "PMC2 Rewind Event (did not match condition)",
	.topic = "pmc",
},
{
	.name = "pm_pmc2_saved",
	.event = "event=0x10022",
	.desc = "PMC2 Rewind Value saved",
	.topic = "pmc",
	.long_desc = "PMC2 Rewind Value saved (matched condition)",
},
{
	.name = "pm_pmc3_overflow",
	.event = "event=0x40010",
	.desc = "Overflow from counter 3",
	.topic = "pmc",
},
{
	.name = "pm_pmc4_overflow",
	.event = "event=0x10010",
	.desc = "Overflow from counter 4",
	.topic = "pmc",
},
{
	.name = "pm_pmc4_rewind",
	.event = "event=0x10020",
	.desc = "PMC4 Rewind Event",
	.topic = "pmc",
	.long_desc = "PMC4 Rewind Event (did not match condition)",
},
{
	.name = "pm_pmc4_saved",
	.event = "event=0x30022",
	.desc = "PMC4 Rewind Value saved (matched condition)",
	.topic = "pmc",
},
{
	.name = "pm_pmc5_overflow",
	.event = "event=0x10024",
	.desc = "Overflow from counter 5",
	.topic = "pmc",
},
{
	.name = "pm_pmc6_overflow",
	.event = "event=0x30024",
	.desc = "Overflow from counter 6",
	.topic = "pmc",
},
{
	.name = "pm_run_purr",
	.event = "event=0x400f4",
	.desc = "Run_PURR",
	.topic = "pmc",
},
{
	.name = "pm_run_spurr",
	.event = "event=0x10008",
	.desc = "Run SPURR",
	.topic = "pmc",
},
{
	.name = "pm_suspended",
	.event = "event=0",
	.desc = "Counter OFF",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_1024",
	.event = "event=0x301ea",
	.desc = "Threshold counter exceeded a value of 1024",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_128",
	.event = "event=0x401ea",
	.desc = "Threshold counter exceeded a value of 128",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_2048",
	.event = "event=0x401ec",
	.desc = "Threshold counter exceeded a value of 2048",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_256",
	.event = "event=0x101e8",
	.desc = "Threshold counter exceed a count of 256",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_32",
	.event = "event=0x201e6",
	.desc = "Threshold counter exceeded a value of 32",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_4096",
	.event = "event=0x101e6",
	.desc = "Threshold counter exceed a count of 4096",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_512",
	.event = "event=0x201e8",
	.desc = "Threshold counter exceeded a value of 512",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_64",
	.event = "event=0x301e8",
	.desc = "IFU non-branch finished",
	.topic = "pmc",
	.long_desc = "Threshold counter exceeded a value of 64",
},
{
	.name = "pm_thresh_met",
	.event = "event=0x101ec",
	.desc = "threshold exceeded",
	.topic = "pmc",
},
{
	.name = "pm_thresh_not_met",
	.event = "event=0x4016e",
	.desc = "Threshold counter did not meet threshold",
	.topic = "pmc",
},
{
	.name = "pm_back_br_cmpl",
	.event = "event=0x2505e",
	.desc = "Branch instruction completed with a target address less than current instruction address",
	.topic = "frontend",
},
{
	.name = "pm_bru_fin",
	.event = "event=0x10068",
	.desc = "Branch Instruction Finished",
	.topic = "frontend",
},
{
	.name = "pm_br_2path",
	.event = "event=0x20036",
	.desc = "two path branch",
	.topic = "frontend",
},
{
	.name = "pm_br_cmpl",
	.event = "event=0x40060",
	.desc = "Branch Instruction completed",
	.topic = "frontend",
},
{
	.name = "pm_br_mpred_cmpl",
	.event = "event=0x400f6",
	.desc = "Number of Branch Mispredicts",
	.topic = "frontend",
},
{
	.name = "pm_br_taken_cmpl",
	.event = "event=0x200fa",
	.desc = "New event for Branch Taken",
	.topic = "frontend",
},
{
	.name = "pm_ic_demand_cyc",
	.event = "event=0x10018",
	.desc = "Cycles when a demand ifetch was pending",
	.topic = "frontend",
	.long_desc = "Demand ifetch pending",
},
{
	.name = "pm_ierat_reload",
	.event = "event=0x100f6",
	.desc = "Number of I-ERAT reloads",
	.topic = "frontend",
	.long_desc = "IERAT Reloaded (Miss)",
},
{
	.name = "pm_ierat_reload_16m",
	.event = "event=0x4006a",
	.desc = "IERAT Reloaded (Miss) for a 16M page",
	.topic = "frontend",
},
{
	.name = "pm_ierat_reload_4k",
	.event = "event=0x20064",
	.desc = "IERAT Miss (Not implemented as DI on POWER6)",
	.topic = "frontend",
	.long_desc = "IERAT Reloaded (Miss) for a 4k page",
},
{
	.name = "pm_ierat_reload_64k",
	.event = "event=0x3006a",
	.desc = "IERAT Reloaded (Miss) for a 64k page",
	.topic = "frontend",
},
{
	.name = "pm_inst_chip_pump_cpred",
	.event = "event=0x14050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for an instruction fetch",
},
{
	.name = "pm_inst_cmpl",
	.event = "event=0x2",
	.desc = "Number of PowerPC Instructions that completed",
	.topic = "frontend",
	.long_desc = "PPC Instructions Finished (completed)",
},
{
	.name = "pm_inst_disp",
	.event = "event=0x200f2",
	.desc = "PPC Dispatched",
	.topic = "frontend",
},
{
	.name = "pm_inst_from_dl2l3_mod",
	.event = "event=0x44048",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_dl2l3_shr",
	.event = "event=0x34048",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_dl4",
	.event = "event=0x3404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_dmem",
	.event = "event=0x4404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group (Distant) due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group (Distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2",
	.event = "event=0x14042",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2miss",
	.event = "event=0x1404e",
	.desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L2 due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L2 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2_disp_conflict_ldhitst",
	.event = "event=0x34040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with load hit store conflict due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 with load hit store conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2_disp_conflict_other",
	.event = "event=0x44040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with dispatch conflict due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 with dispatch conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2_mepf",
	.event = "event=0x24040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l2_no_conflict",
	.event = "event=0x14040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 without conflict due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 without conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l3",
	.event = "event=0x44042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l3miss",
	.event = "event=0x300fa",
	.desc = "Marked instruction was reloaded from a location beyond the local chiplet",
	.topic = "frontend",
	.long_desc = "Inst from L3 miss",
},
{
	.name = "pm_inst_from_l3miss_mod",
	.event = "event=0x4404e",
	.desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L3 due to a instruction fetch",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L3 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l3_disp_conflict",
	.event = "event=0x34042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 with dispatch conflict due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 with dispatch conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l3_mepf",
	.event = "event=0x24042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l3_no_conflict",
	.event = "event=0x14044",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without conflict due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 without conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_ll4",
	.event = "event=0x1404c",
	.desc = "The processor's Instruction cache was reloaded from the local chip's L4 cache due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from the local chip's L4 cache due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_lmem",
	.event = "event=0x24048",
	.desc = "The processor's Instruction cache was reloaded from the local chip's Memory due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from the local chip's Memory due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_memory",
	.event = "event=0x2404c",
	.desc = "The processor's Instruction cache was reloaded from a memory location including L4 from local remote or distant due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from a memory location including L4 from local remote or distant due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_off_chip_cache",
	.event = "event=0x4404a",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_on_chip_cache",
	.event = "event=0x14048",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_rl2l3_mod",
	.event = "event=0x24046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_rl2l3_shr",
	.event = "event=0x1404a",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_rl4",
	.event = "event=0x2404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_rmem",
	.event = "event=0x3404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to an instruction fetch (not prefetch)",
	.topic = "frontend",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_grp_pump_cpred",
	.event = "event=0x24050",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for an instruction fetch",
},
{
	.name = "pm_inst_grp_pump_mpred",
	.event = "event=0x24052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_inst_grp_pump_mpred_rty",
	.event = "event=0x14052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor an instruction fetch",
},
{
	.name = "pm_inst_imc_match_cmpl",
	.event = "event=0x1003a",
	.desc = "IMC Match Count ( Not architected in P8)",
	.topic = "frontend",
},
{
	.name = "pm_inst_pump_cpred",
	.event = "event=0x14054",
	.desc = "Pump prediction correct. Counts across all types of pumps for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Pump prediction correct. Counts across all types of pumpsfor an instruction fetch",
},
{
	.name = "pm_inst_pump_mpred",
	.event = "event=0x44052",
	.desc = "Pump misprediction. Counts across all types of pumps for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor an instruction fetch",
},
{
	.name = "pm_inst_sys_pump_cpred",
	.event = "event=0x34050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for an instruction fetch",
},
{
	.name = "pm_inst_sys_pump_mpred",
	.event = "event=0x34052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_inst_sys_pump_mpred_rty",
	.event = "event=0x44050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for an instruction fetch",
	.topic = "frontend",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for an instruction fetch",
},
{
	.name = "pm_ipteg_from_dl2l3_mod",
	.event = "event=0x45048",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_dl2l3_shr",
	.event = "event=0x35048",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_dl4",
	.event = "event=0x3504c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_dmem",
	.event = "event=0x4504c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l2",
	.event = "event=0x15042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l2miss",
	.event = "event=0x1504e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L2 due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l2_mepf",
	.event = "event=0x25040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l2_no_conflict",
	.event = "event=0x15040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3",
	.event = "event=0x45042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3miss",
	.event = "event=0x4504e",
	.desc = "A Page Table Entry was loaded into the TLB from a localtion other than the local core's L3 due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3_disp_conflict",
	.event = "event=0x35042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3_mepf",
	.event = "event=0x25042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3_no_conflict",
	.event = "event=0x15044",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_ll4",
	.event = "event=0x1504c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_lmem",
	.event = "event=0x25048",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_memory",
	.event = "event=0x2504c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_off_chip_cache",
	.event = "event=0x4504a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_on_chip_cache",
	.event = "event=0x15048",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_rl2l3_mod",
	.event = "event=0x25046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_rl2l3_shr",
	.event = "event=0x1504a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_rl4",
	.event = "event=0x2504a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_rmem",
	.event = "event=0x3504a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_islb_miss",
	.event = "event=0xd096",
	.desc = "I SLB Miss",
	.topic = "frontend",
},
{
	.name = "pm_itlb_miss",
	.event = "event=0x400fc",
	.desc = "ITLB Reloaded (always zero on POWER6)",
	.topic = "frontend",
},
{
	.name = "pm_l1_icache_miss",
	.event = "event=0x200fd",
	.desc = "Demand iCache Miss",
	.topic = "frontend",
},
{
	.name = "pm_l1_icache_reloaded_all",
	.event = "event=0x40012",
	.desc = "Counts all Icache reloads includes demand, prefetchm prefetch turned into demand and demand turned into prefetch",
	.topic = "frontend",
},
{
	.name = "pm_l1_icache_reloaded_pref",
	.event = "event=0x30068",
	.desc = "Counts all Icache prefetch reloads ( includes demand turned into prefetch)",
	.topic = "frontend",
},
{
	.name = "pm_thrd_conc_run_inst",
	.event = "event=0x300f4",
	.desc = "PPC Instructions Finished when both threads in run_cycles",
	.topic = "frontend",
	.long_desc = "Concurrent Run Instructions",
},
{
	.name = "pm_tm_trans_run_inst",
	.event = "event=0x30060",
	.desc = "Instructions completed in transactional state",
	.topic = "frontend",
},
{
	.name = "pm_tm_tx_pass_run_inst",
	.event = "event=0x4e014",
	.desc = "run instructions spent in successful transactions",
	.topic = "frontend",
},
{
	.name = "pm_1plus_ppc_cmpl",
	.event = "event=0x100f2",
	.desc = "1 or more ppc insts finished",
	.topic = "pipeline",
	.long_desc = "1 or more ppc insts finished (completed)",
},
{
	.name = "pm_1plus_ppc_disp",
	.event = "event=0x400f2",
	.desc = "Cycles at least one Instr Dispatched",
	.topic = "pipeline",
	.long_desc = "Cycles at least one Instr Dispatched. Could be a group with only microcode. Issue HW016521",
},
{
	.name = "pm_any_thrd_run_cyc",
	.event = "event=0x100fa",
	.desc = "One of threads in run_cycles",
	.topic = "pipeline",
	.long_desc = "Any thread in run_cycles (was one thread in run_cycles)",
},
{
	.name = "pm_cmplu_stall",
	.event = "event=0x4000a",
	.desc = "Completion stall",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_bru",
	.event = "event=0x4d018",
	.desc = "Completion stall due to a Branch Unit",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dcache_miss",
	.event = "event=0x2c012",
	.desc = "Completion stall by Dcache miss",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dmiss_l21_l31",
	.event = "event=0x2c018",
	.desc = "Completion stall by Dcache miss which resolved on chip ( excluding local L2/L3)",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dmiss_l2l3",
	.event = "event=0x2c016",
	.desc = "Completion stall by Dcache miss which resolved in L2/L3",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dmiss_l2l3_conflict",
	.event = "event=0x4c016",
	.desc = "Completion stall due to cache miss that resolves in the L2 or L3 with a conflict",
	.topic = "pipeline",
	.long_desc = "Completion stall due to cache miss resolving in core's L2/L3 with a conflict",
},
{
	.name = "pm_cmplu_stall_dmiss_l3miss",
	.event = "event=0x4c01a",
	.desc = "Completion stall due to cache miss resolving missed the L3",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dmiss_lmem",
	.event = "event=0x4c018",
	.desc = "Completion stall due to cache miss that resolves in local memory",
	.topic = "pipeline",
	.long_desc = "Completion stall due to cache miss resolving in core's Local Memory",
},
{
	.name = "pm_cmplu_stall_dmiss_remote",
	.event = "event=0x2c01c",
	.desc = "Completion stall by Dcache miss which resolved from remote chip (cache or memory)",
	.topic = "pipeline",
	.long_desc = "Completion stall by Dcache miss which resolved on chip ( excluding local L2/L3)",
},
{
	.name = "pm_cmplu_stall_erat_miss",
	.event = "event=0x4c012",
	.desc = "Completion stall due to LSU reject ERAT miss",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_fxlong",
	.event = "event=0x4d016",
	.desc = "Completion stall due to a long latency fixed point instruction",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_fxu",
	.event = "event=0x2d016",
	.desc = "Completion stall due to FXU",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_hwsync",
	.event = "event=0x30036",
	.desc = "completion stall due to hwsync",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_load_finish",
	.event = "event=0x4d014",
	.desc = "Completion stall due to a Load finish",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_lsu",
	.event = "event=0x2c010",
	.desc = "Completion stall by LSU instruction",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_lwsync",
	.event = "event=0x10036",
	.desc = "completion stall due to isync/lwsync",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_other_cmpl",
	.event = "event=0x30006",
	.desc = "Instructions core completed while this tread was stalled",
	.topic = "pipeline",
	.long_desc = "Instructions core completed while this thread was stalled",
},
{
	.name = "pm_cmplu_stall_st_fwd",
	.event = "event=0x4c01c",
	.desc = "Completion stall due to store forward",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_thrd",
	.event = "event=0x1001c",
	.desc = "Completion Stalled due to thread conflict. Group ready to complete but it was another thread's turn",
	.topic = "pipeline",
	.long_desc = "Completion stall due to thread conflict",
},
{
	.name = "pm_cyc",
	.event = "event=0x1e",
	.desc = "Cycles",
	.topic = "pipeline",
},
{
	.name = "pm_disp_held",
	.event = "event=0x10006",
	.desc = "Dispatch Held",
	.topic = "pipeline",
},
{
	.name = "pm_disp_held_sync_hold",
	.event = "event=0x4003c",
	.desc = "Dispatch held due to SYNC hold",
	.topic = "pipeline",
},
{
	.name = "pm_ext_int",
	.event = "event=0x200f8",
	.desc = "external interrupt",
	.topic = "pipeline",
},
{
	.name = "pm_flush",
	.event = "event=0x400f8",
	.desc = "Flush (any type)",
	.topic = "pipeline",
},
{
	.name = "pm_flush_completion",
	.event = "event=0x30012",
	.desc = "Completion Flush",
	.topic = "pipeline",
},
{
	.name = "pm_freq_down",
	.event = "event=0x3000c",
	.desc = "Power Management: Below Threshold B",
	.topic = "pipeline",
	.long_desc = "Frequency is being slewed down due to Power Management",
},
{
	.name = "pm_freq_up",
	.event = "event=0x4000c",
	.desc = "Power Management: Above Threshold A",
	.topic = "pipeline",
	.long_desc = "Frequency is being slewed up due to Power Management",
},
{
	.name = "pm_hv_cyc",
	.event = "event=0x2000a",
	.desc = "Cycles in which msr_hv is high. Note that this event does not take msr_pr into consideration",
	.topic = "pipeline",
	.long_desc = "cycles in hypervisor mode",
},
{
	.name = "pm_ifetch_throttle",
	.event = "event=0x3405e",
	.desc = "Cycles in which Instruction fetch throttle was active",
	.topic = "pipeline",
	.long_desc = "Cycles instruction fecth was throttled in IFU",
},
{
	.name = "pm_iops_cmpl",
	.event = "event=0x10014",
	.desc = "Internal Operations completed",
	.topic = "pipeline",
	.long_desc = "IOPS Completed",
},
{
	.name = "pm_larx_fin",
	.event = "event=0x3c058",
	.desc = "Larx finished",
	.topic = "pipeline",
},
{
	.name = "pm_ld_cmpl",
	.event = "event=0x1002e",
	.desc = "count of Loads completed",
	.topic = "pipeline",
},
{
	.name = "pm_ld_l3miss_pend_cyc",
	.event = "event=0x10062",
	.desc = "Cycles L3 miss was pending for this thread",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_fin",
	.event = "event=0x30066",
	.desc = "LSU Finished an instruction (up to 2 per cycle)",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_lmq_srq_empty_cyc",
	.event = "event=0x2003e",
	.desc = "LSU empty (lmq and srq empty)",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_reject_erat_miss",
	.event = "event=0x2e05c",
	.desc = "LSU Reject due to ERAT (up to 4 per cycles)",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_reject_lhs",
	.event = "event=0x4e05c",
	.desc = "LSU Reject due to LHS (up to 4 per cycle)",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_reject_lmq_full",
	.event = "event=0x1e05c",
	.desc = "LSU reject due to LMQ full ( 4 per cycle)",
	.topic = "pipeline",
},
{
	.name = "pm_lsu_srq_full_cyc",
	.event = "event=0x1001a",
	.desc = "Storage Queue is full and is blocking dispatch",
	.topic = "pipeline",
	.long_desc = "SRQ is Full",
},
{
	.name = "pm_probe_nop_disp",
	.event = "event=0x40014",
	.desc = "ProbeNops dispatched",
	.topic = "pipeline",
},
{
	.name = "pm_run_cyc",
	.event = "event=0x600f4",
	.desc = "Run_cycles",
	.topic = "pipeline",
},
{
	.name = "pm_run_cyc_smt2_mode",
	.event = "event=0x3006c",
	.desc = "Cycles run latch is set and core is in SMT2 mode",
	.topic = "pipeline",
},
{
	.name = "pm_run_cyc_smt4_mode",
	.event = "event=0x2006c",
	.desc = "cycles this threads run latch is set and the core is in SMT4 mode",
	.topic = "pipeline",
	.long_desc = "Cycles run latch is set and core is in SMT4 mode",
},
{
	.name = "pm_run_cyc_st_mode",
	.event = "event=0x1006c",
	.desc = "Cycles run latch is set and core is in ST mode",
	.topic = "pipeline",
},
{
	.name = "pm_run_inst_cmpl",
	.event = "event=0x500fa",
	.desc = "Run_Instructions",
	.topic = "pipeline",
},
{
	.name = "pm_stcx_fail",
	.event = "event=0x1e058",
	.desc = "stcx failed",
	.topic = "pipeline",
},
{
	.name = "pm_st_cmpl",
	.event = "event=0x20016",
	.desc = "Store completion count",
	.topic = "pipeline",
},
{
	.name = "pm_st_fin",
	.event = "event=0x200f0",
	.desc = "Store Instructions Finished",
	.topic = "pipeline",
	.long_desc = "Store Instructions Finished (store sent to nest)",
},
{
	.name = "pm_st_fwd",
	.event = "event=0x20018",
	.desc = "Store forwards that finished",
	.topic = "pipeline",
},
{
	.name = "pm_tablewalk_cyc",
	.event = "event=0x10026",
	.desc = "Cycles when a tablewalk (I or D) is active",
	.topic = "pipeline",
	.long_desc = "Tablewalk Active",
},
{
	.name = "pm_tb_bit_trans",
	.event = "event=0x300f8",
	.desc = "timebase event",
	.topic = "pipeline",
},
{
	.name = "pm_thrd_all_run_cyc",
	.event = "event=0x2000c",
	.desc = "All Threads in Run_cycles (was both threads in run_cycles)",
	.topic = "pipeline",
},
{
	.name = "pm_tlbie_fin",
	.event = "event=0x30058",
	.desc = "tlbie finished",
	.topic = "pipeline",
},
{
	.name = "pm_tm_trans_run_cyc",
	.event = "event=0x10060",
	.desc = "run cycles in transactional state",
	.topic = "pipeline",
},
{
	.name = "pm_tm_tx_pass_run_cyc",
	.event = "event=0x2e012",
	.desc = "cycles spent in successful transactions",
	.topic = "pipeline",
	.long_desc = "run cycles spent in successful transactions",
},
{
	.name = "pm_1lpar_cyc",
	.event = "event=0x1f05e",
	.desc = "Number of cycles in single lpar mode. All threads in the core are assigned to the same lpar",
	.topic = "other",
},
{
	.name = "pm_2lpar_cyc",
	.event = "event=0x2006e",
	.desc = "Cycles in 2-lpar mode. Threads 0-3 belong to Lpar0 and threads 4-7 belong to Lpar1",
	.topic = "other",
	.long_desc = "Number of cycles in 2 lpar mode",
},
{
	.name = "pm_4lpar_cyc",
	.event = "event=0x4e05e",
	.desc = "Number of cycles in 4 LPAR mode. Threads 0-1 belong to lpar0, threads 2-3 belong to lpar1, threads 4-5 belong to lpar2, and threads 6-7 belong to lpar3",
	.topic = "other",
},
{
	.name = "pm_all_chip_pump_cpred",
	.event = "event=0x610050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for all data types ( demand load,data,inst prefetch,inst fetch,xlate (I or d)",
},
{
	.name = "pm_all_grp_pump_cpred",
	.event = "event=0x520050",
	.desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_all_grp_pump_mpred",
	.event = "event=0x620052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_all_grp_pump_mpred_rty",
	.event = "event=0x610052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_all_pump_cpred",
	.event = "event=0x610054",
	.desc = "Pump prediction correct. Counts across all types of pumps for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Pump prediction correct. Counts across all types of pumpsfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_all_pump_mpred",
	.event = "event=0x640052",
	.desc = "Pump misprediction. Counts across all types of pumps for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_all_sys_pump_cpred",
	.event = "event=0x630050",
	.desc = "Initial and Final Pump Scope was system pump for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_all_sys_pump_mpred",
	.event = "event=0x630052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_all_sys_pump_mpred_rty",
	.event = "event=0x640050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for all data types (demand load,data prefetch,inst prefetch,inst fetch,xlate)",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
},
{
	.name = "pm_bank_conflict",
	.event = "event=0x4082",
	.desc = "Read blocked due to interleave conflict. The ifar logic will detect an interleave conflict and kill the data that was read that cycle",
	.topic = "other",
},
{
	.name = "pm_br_bc_8",
	.event = "event=0x5086",
	.desc = "Pairable BC+8 branch that has not been converted to a Resolve Finished in the BRU pipeline",
	.topic = "other",
},
{
	.name = "pm_br_bc_8_conv",
	.event = "event=0x5084",
	.desc = "Pairable BC+8 branch that was converted to a Resolve Finished in the BRU pipeline",
	.topic = "other",
},
{
	.name = "pm_br_mpred_ccache",
	.event = "event=0x40ac",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Count Cache Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_mpred_cr",
	.event = "event=0x40b8",
	.desc = "Conditional Branch Completed that was Mispredicted due to the BHT Direction Prediction (taken/not taken)",
	.topic = "other",
},
{
	.name = "pm_br_mpred_lstack",
	.event = "event=0x40ae",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Link Stack Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_mpred_ta",
	.event = "event=0x40ba",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Target Address Prediction from the Count Cache or Link Stack. Only XL-form branches that resolved Taken set this event",
	.topic = "other",
},
{
	.name = "pm_br_mrk_2path",
	.event = "event=0x10138",
	.desc = "marked two path branch",
	.topic = "other",
},
{
	.name = "pm_br_pred_br0",
	.event = "event=0x409c",
	.desc = "Conditional Branch Completed on BR0 (1st branch in group) in which the HW predicted the Direction or Target",
	.topic = "other",
},
{
	.name = "pm_br_pred_br1",
	.event = "event=0x409e",
	.desc = "Conditional Branch Completed on BR1 (2nd branch in group) in which the HW predicted the Direction or Target. Note: BR1 can only be used in Single Thread Mode. In all of the SMT modes, only one branch can complete, thus BR1 is unused",
	.topic = "other",
},
{
	.name = "pm_br_pred_br_cmpl",
	.event = "event=0x489c",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred(0) OR if_pc_br0_br_pred(1)",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_br_pred_ccache_br0",
	.event = "event=0x40a4",
	.desc = "Conditional Branch Completed on BR0 that used the Count Cache for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_pred_ccache_br1",
	.event = "event=0x40a6",
	.desc = "Conditional Branch Completed on BR1 that used the Count Cache for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_pred_ccache_cmpl",
	.event = "event=0x48a4",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred(0) AND if_pc_br0_pred_type",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_br_pred_cr_br0",
	.event = "event=0x40b0",
	.desc = "Conditional Branch Completed on BR0 that had its direction predicted. I-form branches do not set this event. In addition, B-form branches which do not use the BHT do not set this event - these are branches with BO-field set to 'always taken' and branches",
	.topic = "other",
},
{
	.name = "pm_br_pred_cr_br1",
	.event = "event=0x40b2",
	.desc = "Conditional Branch Completed on BR1 that had its direction predicted. I-form branches do not set this event. In addition, B-form branches which do not use the BHT do not set this event - these are branches with BO-field set to 'always taken' and branches",
	.topic = "other",
},
{
	.name = "pm_br_pred_cr_cmpl",
	.event = "event=0x48b0",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred(1)='1'",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_br_pred_lstack_br0",
	.event = "event=0x40a8",
	.desc = "Conditional Branch Completed on BR0 that used the Link Stack for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_pred_lstack_br1",
	.event = "event=0x40aa",
	.desc = "Conditional Branch Completed on BR1 that used the Link Stack for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_br_pred_lstack_cmpl",
	.event = "event=0x48a8",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred(0) AND (not if_pc_br0_pred_type)",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_br_pred_ta_br0",
	.event = "event=0x40b4",
	.desc = "Conditional Branch Completed on BR0 that had its target address predicted. Only XL-form branches set this event",
	.topic = "other",
},
{
	.name = "pm_br_pred_ta_br1",
	.event = "event=0x40b6",
	.desc = "Conditional Branch Completed on BR1 that had its target address predicted. Only XL-form branches set this event",
	.topic = "other",
},
{
	.name = "pm_br_pred_ta_cmpl",
	.event = "event=0x48b4",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred(0)='1'",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_br_uncond_br0",
	.event = "event=0x40a0",
	.desc = "Unconditional Branch Completed on BR0. HW branch prediction was not used for this branch. This can be an I-form branch, a B-form branch with BO-field set to branch always, or a B-form branch which was coverted to a Resolve",
	.topic = "other",
},
{
	.name = "pm_br_uncond_br1",
	.event = "event=0x40a2",
	.desc = "Unconditional Branch Completed on BR1. HW branch prediction was not used for this branch. This can be an I-form branch, a B-form branch with BO-field set to branch always, or a B-form branch which was coverted to a Resolve",
	.topic = "other",
},
{
	.name = "pm_br_uncond_cmpl",
	.event = "event=0x48a0",
	.desc = "Completion Time Event. This event can also be calculated from the direct bus as follows: if_pc_br0_br_pred=00 AND if_pc_br0_completed",
	.topic = "other",
	.long_desc = "IFU",
},
{
	.name = "pm_castout_issued",
	.event = "event=0x3094",
	.desc = "Castouts issued",
	.topic = "other",
},
{
	.name = "pm_castout_issued_gpr",
	.event = "event=0x3096",
	.desc = "Castouts issued GPR",
	.topic = "other",
},
{
	.name = "pm_clb_held",
	.event = "event=0x2090",
	.desc = "CLB Hold: Any Reason",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_bru_cru",
	.event = "event=0x2d018",
	.desc = "Completion stall due to IFU",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_coq_full",
	.event = "event=0x30026",
	.desc = "Completion stall due to CO q full",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_flush",
	.event = "event=0x30038",
	.desc = "completion stall due to flush by own thread",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_mem_ecc_delay",
	.event = "event=0x30028",
	.desc = "Completion stall due to mem ECC delay",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_no_ntf",
	.event = "event=0x2e01c",
	.desc = "Completion stall due to nop",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_ntcg_flush",
	.event = "event=0x2e01e",
	.desc = "Completion stall due to ntcg flush",
	.topic = "other",
	.long_desc = "Completion stall due to reject (load hit store)",
},
{
	.name = "pm_cmplu_stall_reject",
	.event = "event=0x4c010",
	.desc = "Completion stall due to LSU reject",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_reject_lhs",
	.event = "event=0x2c01a",
	.desc = "Completion stall due to reject (load hit store)",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_rej_lmq_full",
	.event = "event=0x4c014",
	.desc = "Completion stall due to LSU reject LMQ full",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_scalar",
	.event = "event=0x4d010",
	.desc = "Completion stall due to VSU scalar instruction",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_scalar_long",
	.event = "event=0x2d010",
	.desc = "Completion stall due to VSU scalar long latency instruction",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_store",
	.event = "event=0x2c014",
	.desc = "Completion stall by stores this includes store agen finishes in pipe LS0/LS1 and store data finishes in LS2/LS3",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_vector",
	.event = "event=0x2d014",
	.desc = "Completion stall due to VSU vector instruction",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_vector_long",
	.event = "event=0x4d012",
	.desc = "Completion stall due to VSU vector long instruction",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_vsu",
	.event = "event=0x2d012",
	.desc = "Completion stall due to VSU instruction",
	.topic = "other",
},
{
	.name = "pm_co0_alloc",
	.event = "event=0x16083",
	.desc = "CO mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_co0_busy",
	.event = "event=0x16082",
	.desc = "CO mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_co_disp_fail",
	.event = "event=0x517082",
	.desc = "CO dispatch failed due to all CO machines being busy",
	.topic = "other",
},
{
	.name = "pm_co_tm_sc_footprint",
	.event = "event=0x527084",
	.desc = "L2 did a cleanifdirty CO to the L3 (ie created an SC line in the L3)",
	.topic = "other",
},
{
	.name = "pm_co_usage",
	.event = "event=0x3608a",
	.desc = "Continuous 16 cycle(2to1) window where this signals rotates thru sampling each L2 CO machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_cru_fin",
	.event = "event=0x40066",
	.desc = "IFU Finished a (non-branch) instruction",
	.topic = "other",
},
{
	.name = "pm_data_all_chip_pump_cpred",
	.event = "event=0x61c050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for a demand load",
},
{
	.name = "pm_data_all_from_dl2l3_mod",
	.event = "event=0x64c048",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_dl2l3_shr",
	.event = "event=0x63c048",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_dl4",
	.event = "event=0x63c04c",
	.desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_dmem",
	.event = "event=0x64c04c",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2",
	.event = "event=0x61c042",
	.desc = "The processor's data cache was reloaded from local core's L2 due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L2 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l21_mod",
	.event = "event=0x64c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l21_shr",
	.event = "event=0x63c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2miss_mod",
	.event = "event=0x61c04e",
	.desc = "The processor's data cache was reloaded from a localtion other than the local core's L2 due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from a localtion other than the local core's L2 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2_disp_conflict_ldhitst",
	.event = "event=0x63c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2_disp_conflict_other",
	.event = "event=0x64c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2_mepf",
	.event = "event=0x62c040",
	.desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l2_no_conflict",
	.event = "event=0x61c040",
	.desc = "The processor's data cache was reloaded from local core's L2 without conflict due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L2 without conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l3",
	.event = "event=0x64c042",
	.desc = "The processor's data cache was reloaded from local core's L3 due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L3 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l31_eco_mod",
	.event = "event=0x64c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l31_eco_shr",
	.event = "event=0x63c044",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l31_mod",
	.event = "event=0x62c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l31_shr",
	.event = "event=0x61c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l3miss_mod",
	.event = "event=0x64c04e",
	.desc = "The processor's data cache was reloaded from a localtion other than the local core's L3 due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from a localtion other than the local core's L3 due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l3_disp_conflict",
	.event = "event=0x63c042",
	.desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l3_mepf",
	.event = "event=0x62c042",
	.desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_l3_no_conflict",
	.event = "event=0x61c044",
	.desc = "The processor's data cache was reloaded from local core's L3 without conflict due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from local core's L3 without conflict due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_ll4",
	.event = "event=0x61c04c",
	.desc = "The processor's data cache was reloaded from the local chip's L4 cache due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from the local chip's L4 cache due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_lmem",
	.event = "event=0x62c048",
	.desc = "The processor's data cache was reloaded from the local chip's Memory due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from the local chip's Memory due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_memory",
	.event = "event=0x62c04c",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_off_chip_cache",
	.event = "event=0x64c04a",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_on_chip_cache",
	.event = "event=0x61c048",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_rl2l3_mod",
	.event = "event=0x62c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_rl2l3_shr",
	.event = "event=0x61c04a",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_rl4",
	.event = "event=0x62c04a",
	.desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_from_rmem",
	.event = "event=0x63c04a",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_all_grp_pump_cpred",
	.event = "event=0x62c050",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for a demand load",
},
{
	.name = "pm_data_all_grp_pump_mpred",
	.event = "event=0x62c052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_data_all_grp_pump_mpred_rty",
	.event = "event=0x61c052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor a demand load",
},
{
	.name = "pm_data_all_pump_cpred",
	.event = "event=0x61c054",
	.desc = "Pump prediction correct. Counts across all types of pumps for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Pump prediction correct. Counts across all types of pumps for a demand load",
},
{
	.name = "pm_data_all_pump_mpred",
	.event = "event=0x64c052",
	.desc = "Pump misprediction. Counts across all types of pumps for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor a demand load",
},
{
	.name = "pm_data_all_sys_pump_cpred",
	.event = "event=0x63c050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for a demand load",
},
{
	.name = "pm_data_all_sys_pump_mpred",
	.event = "event=0x63c052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_data_all_sys_pump_mpred_rty",
	.event = "event=0x64c050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for either demand loads or data prefetch",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for a demand load",
},
{
	.name = "pm_data_from_l21_mod",
	.event = "event=0x4c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l21_shr",
	.event = "event=0x3c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l31_eco_mod",
	.event = "event=0x4c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l31_eco_shr",
	.event = "event=0x3c044",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l31_mod",
	.event = "event=0x2c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_l31_shr",
	.event = "event=0x1c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to a demand load",
	.topic = "other",
	.long_desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to either only demand loads or demand loads plus prefetches if MMCR1[16] is 1",
},
{
	.name = "pm_data_from_mem",
	.event = "event=0x400fe",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a demand load",
	.topic = "other",
	.long_desc = "Data cache reload from memory (including L4)",
},
{
	.name = "pm_dc_collisions",
	.event = "event=0xe0bc",
	.desc = "DATA Cache collisions",
	.topic = "other",
	.long_desc = "DATA Cache collisions42",
},
{
	.name = "pm_dc_pref_stream_alloc",
	.event = "event=0x1e050",
	.desc = "Stream marked valid. The stream could have been allocated through the hardware prefetch mechanism or through software. This is combined ls0 and ls1",
	.topic = "other",
},
{
	.name = "pm_dc_pref_stream_conf",
	.event = "event=0x2e050",
	.desc = "A demand load referenced a line in an active prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software. Combine up + down",
	.topic = "other",
},
{
	.name = "pm_dc_pref_stream_fuzzy_conf",
	.event = "event=0x4e050",
	.desc = "A demand load referenced a line in an active fuzzy prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software.Fuzzy stream confirm (out of order effects, or pf cant keep up)",
	.topic = "other",
},
{
	.name = "pm_dc_pref_stream_strided_conf",
	.event = "event=0x3e050",
	.desc = "A demand load referenced a line in an active strided prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software",
	.topic = "other",
},
{
	.name = "pm_dfu",
	.event = "event=0xb0ba",
	.desc = "Finish DFU (all finish)",
	.topic = "other",
},
{
	.name = "pm_dfu_dcffix",
	.event = "event=0xb0be",
	.desc = "Convert from fixed opcode finish (dcffix,dcffixq)",
	.topic = "other",
},
{
	.name = "pm_dfu_denbcd",
	.event = "event=0xb0bc",
	.desc = "BCD->DPD opcode finish (denbcd, denbcdq)",
	.topic = "other",
},
{
	.name = "pm_dfu_mc",
	.event = "event=0xb0b8",
	.desc = "Finish DFU multicycle",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_bal",
	.event = "event=0x2092",
	.desc = "Dispatch/CLB Hold: Balance",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_res",
	.event = "event=0x2094",
	.desc = "Dispatch/CLB Hold: Resource",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_sb",
	.event = "event=0x20a8",
	.desc = "Dispatch/CLB Hold: Scoreboard",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_sync",
	.event = "event=0x2098",
	.desc = "Dispatch/CLB Hold: Sync type instruction",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_tlbie",
	.event = "event=0x2096",
	.desc = "Dispatch Hold: Due to TLBIE",
	.topic = "other",
},
{
	.name = "pm_disp_held_iq_full",
	.event = "event=0x20006",
	.desc = "Dispatch held due to Issue q full",
	.topic = "other",
},
{
	.name = "pm_disp_held_map_full",
	.event = "event=0x1002a",
	.desc = "Dispatch for this thread was held because the Mappers were full",
	.topic = "other",
	.long_desc = "Dispatch held due to Mapper full",
},
{
	.name = "pm_disp_held_srq_full",
	.event = "event=0x30018",
	.desc = "Dispatch held due SRQ no room",
	.topic = "other",
},
{
	.name = "pm_disp_hold_gct_full",
	.event = "event=0x30a6",
	.desc = "Dispatch Hold Due to no space in the GCT",
	.topic = "other",
},
{
	.name = "pm_disp_wt",
	.event = "event=0x30008",
	.desc = "Dispatched Starved",
	.topic = "other",
	.long_desc = "Dispatched Starved (not held, nothing to dispatch)",
},
{
	.name = "pm_dpteg_from_l21_mod",
	.event = "event=0x4e046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l21_shr",
	.event = "event=0x3e046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l2_disp_conflict_ldhitst",
	.event = "event=0x3e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with load hit store conflict due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l2_disp_conflict_other",
	.event = "event=0x4e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with dispatch conflict due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l31_eco_mod",
	.event = "event=0x4e044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l31_eco_shr",
	.event = "event=0x3e044",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l31_mod",
	.event = "event=0x2e044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l31_shr",
	.event = "event=0x1e046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a data side request",
	.topic = "other",
},
{
	.name = "pm_eat_force_mispred",
	.event = "event=0x50a8",
	.desc = "XL-form branch was mispredicted due to the predicted target address missing from EAT. The EAT forces a mispredict in this case since there is no predicated target to validate. This is a rare case that may occur when the EAT is full and a branch is issue",
	.topic = "other",
},
{
	.name = "pm_eat_full_cyc",
	.event = "event=0x4084",
	.desc = "Cycles No room in EAT",
	.topic = "other",
	.long_desc = "Cycles No room in EATSet on bank conflict and case where no ibuffers available",
},
{
	.name = "pm_ee_off_ext_int",
	.event = "event=0x2080",
	.desc = "Ee off and external interrupt",
	.topic = "other",
},
{
	.name = "pm_fav_tbegin",
	.event = "event=0x20b4",
	.desc = "Dispatch time Favored tbegin",
	.topic = "other",
},
{
	.name = "pm_flop",
	.event = "event=0x100f4",
	.desc = "Floating Point Operation Finished",
	.topic = "other",
	.long_desc = "Floating Point Operations Finished",
},
{
	.name = "pm_flop_sum_scalar",
	.event = "event=0xa0ae",
	.desc = "flops summary scalar instructions",
	.topic = "other",
},
{
	.name = "pm_flop_sum_vec",
	.event = "event=0xa0ac",
	.desc = "flops summary vector instructions",
	.topic = "other",
},
{
	.name = "pm_flush_br_mpred",
	.event = "event=0x2084",
	.desc = "Flush caused by branch mispredict",
	.topic = "other",
},
{
	.name = "pm_flush_disp",
	.event = "event=0x2082",
	.desc = "Dispatch flush",
	.topic = "other",
},
{
	.name = "pm_flush_disp_sb",
	.event = "event=0x208c",
	.desc = "Dispatch Flush: Scoreboard",
	.topic = "other",
},
{
	.name = "pm_flush_disp_sync",
	.event = "event=0x2088",
	.desc = "Dispatch Flush: Sync",
	.topic = "other",
},
{
	.name = "pm_flush_disp_tlbie",
	.event = "event=0x208a",
	.desc = "Dispatch Flush: TLBIE",
	.topic = "other",
},
{
	.name = "pm_flush_lsu",
	.event = "event=0x208e",
	.desc = "Flush initiated by LSU",
	.topic = "other",
},
{
	.name = "pm_flush_partial",
	.event = "event=0x2086",
	.desc = "Partial flush",
	.topic = "other",
},
{
	.name = "pm_fpu0_fconv",
	.event = "event=0xa0b0",
	.desc = "Convert instruction executed",
	.topic = "other",
},
{
	.name = "pm_fpu0_fest",
	.event = "event=0xa0b8",
	.desc = "Estimate instruction executed",
	.topic = "other",
},
{
	.name = "pm_fpu0_frsp",
	.event = "event=0xa0b4",
	.desc = "Round to single precision instruction executed",
	.topic = "other",
},
{
	.name = "pm_fpu1_fconv",
	.event = "event=0xa0b2",
	.desc = "Convert instruction executed",
	.topic = "other",
},
{
	.name = "pm_fpu1_fest",
	.event = "event=0xa0ba",
	.desc = "Estimate instruction executed",
	.topic = "other",
},
{
	.name = "pm_fpu1_frsp",
	.event = "event=0xa0b6",
	.desc = "Round to single precision instruction executed",
	.topic = "other",
},
{
	.name = "pm_fusion_toc_grp0_1",
	.event = "event=0x50b0",
	.desc = "One pair of instructions fused with TOC in Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_toc_grp0_2",
	.event = "event=0x50ae",
	.desc = "Two pairs of instructions fused with TOCin Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_toc_grp0_3",
	.event = "event=0x50ac",
	.desc = "Three pairs of instructions fused with TOC in Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_toc_grp1_1",
	.event = "event=0x50b2",
	.desc = "One pair of instructions fused with TOX in Group1",
	.topic = "other",
},
{
	.name = "pm_fusion_vsx_grp0_1",
	.event = "event=0x50b8",
	.desc = "One pair of instructions fused with VSX in Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_vsx_grp0_2",
	.event = "event=0x50b6",
	.desc = "Two pairs of instructions fused with VSX in Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_vsx_grp0_3",
	.event = "event=0x50b4",
	.desc = "Three pairs of instructions fused with VSX in Group0",
	.topic = "other",
},
{
	.name = "pm_fusion_vsx_grp1_1",
	.event = "event=0x50ba",
	.desc = "One pair of instructions fused with VSX in Group1",
	.topic = "other",
},
{
	.name = "pm_fxu0_busy_fxu1_idle",
	.event = "event=0x3000e",
	.desc = "fxu0 busy and fxu1 idle",
	.topic = "other",
},
{
	.name = "pm_fxu0_fin",
	.event = "event=0x10004",
	.desc = "The fixed point unit Unit 0 finished an instruction. Instructions that finish may not necessary complete",
	.topic = "other",
	.long_desc = "FXU0 Finished",
},
{
	.name = "pm_fxu1_busy_fxu0_idle",
	.event = "event=0x4000e",
	.desc = "fxu0 idle and fxu1 busy",
	.topic = "other",
},
{
	.name = "pm_fxu1_fin",
	.event = "event=0x40004",
	.desc = "FXU1 Finished",
	.topic = "other",
},
{
	.name = "pm_gct_empty_cyc",
	.event = "event=0x20008",
	.desc = "No itags assigned either thread (GCT Empty)",
	.topic = "other",
},
{
	.name = "pm_gct_merge",
	.event = "event=0x30a4",
	.desc = "Group dispatched on a merged GCT empty. GCT entries can be merged only within the same thread",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_br_mpred",
	.event = "event=0x4d01e",
	.desc = "Gct empty for this thread due to branch mispred",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_br_mpred_icmiss",
	.event = "event=0x4d01a",
	.desc = "Gct empty for this thread due to Icache Miss and branch mispred",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_cyc",
	.event = "event=0x100f8",
	.desc = "No itags assigned",
	.topic = "other",
	.long_desc = "Pipeline empty (No itags assigned , no GCT slots used)",
},
{
	.name = "pm_gct_noslot_disp_held_issq",
	.event = "event=0x2d01e",
	.desc = "Gct empty for this thread due to dispatch hold on this thread due to Issue q full",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_disp_held_map",
	.event = "event=0x4d01c",
	.desc = "Gct empty for this thread due to dispatch hold on this thread due to Mapper full",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_disp_held_other",
	.event = "event=0x2e010",
	.desc = "Gct empty for this thread due to dispatch hold on this thread due to sync",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_disp_held_srq",
	.event = "event=0x2d01c",
	.desc = "Gct empty for this thread due to dispatch hold on this thread due to SRQ full",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_ic_l3miss",
	.event = "event=0x4e010",
	.desc = "Gct empty for this thread due to icach l3 miss",
	.topic = "other",
},
{
	.name = "pm_gct_noslot_ic_miss",
	.event = "event=0x2d01a",
	.desc = "Gct empty for this thread due to Icache Miss",
	.topic = "other",
},
{
	.name = "pm_gct_util_11_14_entries",
	.event = "event=0x20a2",
	.desc = "GCT Utilization 11-14 entries",
	.topic = "other",
},
{
	.name = "pm_gct_util_15_17_entries",
	.event = "event=0x20a4",
	.desc = "GCT Utilization 15-17 entries",
	.topic = "other",
},
{
	.name = "pm_gct_util_18_entries",
	.event = "event=0x20a6",
	.desc = "GCT Utilization 18+ entries",
	.topic = "other",
},
{
	.name = "pm_gct_util_1_2_entries",
	.event = "event=0x209c",
	.desc = "GCT Utilization 1-2 entries",
	.topic = "other",
},
{
	.name = "pm_gct_util_3_6_entries",
	.event = "event=0x209e",
	.desc = "GCT Utilization 3-6 entries",
	.topic = "other",
},
{
	.name = "pm_gct_util_7_10_entries",
	.event = "event=0x20a0",
	.desc = "GCT Utilization 7-10 entries",
	.topic = "other",
},
{
	.name = "pm_grp_br_mpred_nonspec",
	.event = "event=0x1000a",
	.desc = "Group experienced non-speculative branch redirect",
	.topic = "other",
	.long_desc = "Group experienced Non-speculative br mispredicct",
},
{
	.name = "pm_grp_cmpl",
	.event = "event=0x30004",
	.desc = "group completed",
	.topic = "other",
},
{
	.name = "pm_grp_disp",
	.event = "event=0x3000a",
	.desc = "group dispatch",
	.topic = "other",
	.long_desc = "dispatch_success (Group Dispatched)",
},
{
	.name = "pm_grp_ic_miss_nonspec",
	.event = "event=0x1000c",
	.desc = "Group experienced non-speculative I cache miss",
	.topic = "other",
	.long_desc = "Group experi enced Non-specu lative I cache miss",
},
{
	.name = "pm_grp_mrk",
	.event = "event=0x10130",
	.desc = "Instruction Marked",
	.topic = "other",
	.long_desc = "Instruction marked in idu",
},
{
	.name = "pm_grp_non_full_group",
	.event = "event=0x509c",
	.desc = "GROUPs where we did not have 6 non branch instructions in the group(ST mode), in SMT mode 3 non branches",
	.topic = "other",
},
{
	.name = "pm_grp_term_2nd_branch",
	.event = "event=0x50a4",
	.desc = "There were enough instructions in the Ibuffer, but 2nd branch ends group",
	.topic = "other",
},
{
	.name = "pm_grp_term_fpu_after_br",
	.event = "event=0x50a6",
	.desc = "There were enough instructions in the Ibuffer, but FPU OP IN same group after a branch terminates a group, cant do partial flushes",
	.topic = "other",
},
{
	.name = "pm_grp_term_noinst",
	.event = "event=0x509e",
	.desc = "Do not fill every slot in the group, Not enough instructions in the Ibuffer. This includes cases where the group started with enough instructions, but some got knocked out by a cache miss or branch redirect (which would also empty the Ibuffer)",
	.topic = "other",
},
{
	.name = "pm_grp_term_other",
	.event = "event=0x50a0",
	.desc = "There were enough instructions in the Ibuffer, but the group terminated early for some other reason, most likely due to a First or Last",
	.topic = "other",
},
{
	.name = "pm_grp_term_slot_limit",
	.event = "event=0x50a2",
	.desc = "There were enough instructions in the Ibuffer, but 3 src RA/RB/RC , 2 way crack caused a group termination",
	.topic = "other",
},
{
	.name = "pm_ibuf_full_cyc",
	.event = "event=0x4086",
	.desc = "Cycles No room in ibuff",
	.topic = "other",
	.long_desc = "Cycles No room in ibufffully qualified transfer (if5 valid)",
},
{
	.name = "pm_ic_demand_l2_bht_redirect",
	.event = "event=0x4098",
	.desc = "L2 I cache demand request due to BHT redirect, branch redirect ( 2 bubbles 3 cycles)",
	.topic = "other",
},
{
	.name = "pm_ic_demand_l2_br_redirect",
	.event = "event=0x409a",
	.desc = "L2 I cache demand request due to branch Mispredict ( 15 cycle path)",
	.topic = "other",
},
{
	.name = "pm_ic_demand_req",
	.event = "event=0x4088",
	.desc = "Demand Instruction fetch request",
	.topic = "other",
},
{
	.name = "pm_ic_invalidate",
	.event = "event=0x508a",
	.desc = "Ic line invalidated",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_hit",
	.event = "event=0x4092",
	.desc = "Prefetch Canceled due to icache hit",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_l2",
	.event = "event=0x4094",
	.desc = "L2 Squashed request",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_page",
	.event = "event=0x4090",
	.desc = "Prefetch Canceled due to page boundary",
	.topic = "other",
},
{
	.name = "pm_ic_pref_req",
	.event = "event=0x408a",
	.desc = "Instruction prefetch requests",
	.topic = "other",
},
{
	.name = "pm_ic_pref_write",
	.event = "event=0x408e",
	.desc = "Instruction prefetch written into IL1",
	.topic = "other",
},
{
	.name = "pm_ic_reload_private",
	.event = "event=0x4096",
	.desc = "Reloading line was brought in private for a specific thread. Most lines are brought in shared for all eight thrreads. If RA does not match then invalidates and then brings it shared to other thread. In P7 line brought in private , then line was invalidat",
	.topic = "other",
},
{
	.name = "pm_ifu_l2_touch",
	.event = "event=0x5088",
	.desc = "L2 touch to update MRU on a line",
	.topic = "other",
},
{
	.name = "pm_inst_all_chip_pump_cpred",
	.event = "event=0x514050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was chip pump (prediction=correct) for an instruction fetch",
},
{
	.name = "pm_inst_all_from_dl2l3_mod",
	.event = "event=0x544048",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_dl2l3_shr",
	.event = "event=0x534048",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_dl4",
	.event = "event=0x53404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_dmem",
	.event = "event=0x54404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group (Distant) due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group (Distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2",
	.event = "event=0x514042",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l21_mod",
	.event = "event=0x544046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L2 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L2 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l21_shr",
	.event = "event=0x534046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L2 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L2 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2miss",
	.event = "event=0x51404e",
	.desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L2 due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L2 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2_disp_conflict_ldhitst",
	.event = "event=0x534040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with load hit store conflict due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 with load hit store conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2_disp_conflict_other",
	.event = "event=0x544040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with dispatch conflict due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 with dispatch conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2_mepf",
	.event = "event=0x524040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l2_no_conflict",
	.event = "event=0x514040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 without conflict due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L2 without conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l3",
	.event = "event=0x544042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l31_eco_mod",
	.event = "event=0x544044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l31_eco_shr",
	.event = "event=0x534044",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l31_mod",
	.event = "event=0x524044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L3 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l31_shr",
	.event = "event=0x514046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L3 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l3miss_mod",
	.event = "event=0x54404e",
	.desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L3 due to a instruction fetch",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from a localtion other than the local core's L3 due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l3_disp_conflict",
	.event = "event=0x534042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 with dispatch conflict due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 with dispatch conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l3_mepf",
	.event = "event=0x524042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_l3_no_conflict",
	.event = "event=0x514044",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without conflict due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from local core's L3 without conflict due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_ll4",
	.event = "event=0x51404c",
	.desc = "The processor's Instruction cache was reloaded from the local chip's L4 cache due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from the local chip's L4 cache due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_lmem",
	.event = "event=0x524048",
	.desc = "The processor's Instruction cache was reloaded from the local chip's Memory due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from the local chip's Memory due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_memory",
	.event = "event=0x52404c",
	.desc = "The processor's Instruction cache was reloaded from a memory location including L4 from local remote or distant due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from a memory location including L4 from local remote or distant due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_off_chip_cache",
	.event = "event=0x54404a",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_on_chip_cache",
	.event = "event=0x514048",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_rl2l3_mod",
	.event = "event=0x524046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_rl2l3_shr",
	.event = "event=0x51404a",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_rl4",
	.event = "event=0x52404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_from_rmem",
	.event = "event=0x53404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_all_grp_pump_cpred",
	.event = "event=0x524050",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for an instruction fetch",
},
{
	.name = "pm_inst_all_grp_pump_mpred",
	.event = "event=0x524052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope OR Final Pump Scope(Group) got data from source that was at smaller scope(Chip) Final pump was group pump and initial pump was chip or final and initial pump was gro",
},
{
	.name = "pm_inst_all_grp_pump_mpred_rty",
	.event = "event=0x514052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Final Pump Scope(Group) to get data sourced, ended up larger than Initial Pump Scope (Chip) Final pump was group pump and initial pump was chip pumpfor an instruction fetch",
},
{
	.name = "pm_inst_all_pump_cpred",
	.event = "event=0x514054",
	.desc = "Pump prediction correct. Counts across all types of pumps for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Pump prediction correct. Counts across all types of pumpsfor an instruction fetch",
},
{
	.name = "pm_inst_all_pump_mpred",
	.event = "event=0x544052",
	.desc = "Pump misprediction. Counts across all types of pumps for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Pump Mis prediction Counts across all types of pumpsfor an instruction fetch",
},
{
	.name = "pm_inst_all_sys_pump_cpred",
	.event = "event=0x534050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Initial and Final Pump Scope and data sourced across this scope was system pump for an instruction fetch",
},
{
	.name = "pm_inst_all_sys_pump_mpred",
	.event = "event=0x534052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope(Chip/Group) OR Final Pump Scope(system) got data from source that was at smaller scope(Chip/group) Final pump was system pump and initial pump was chip or group or",
},
{
	.name = "pm_inst_all_sys_pump_mpred_rty",
	.event = "event=0x544050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for instruction fetches and prefetches",
	.topic = "other",
	.long_desc = "Final Pump Scope(system) to get data sourced, ended up larger than Initial Pump Scope (Chip or Group) for an instruction fetch",
},
{
	.name = "pm_inst_from_l1",
	.event = "event=0x4080",
	.desc = "Instruction fetches from L1",
	.topic = "other",
},
{
	.name = "pm_inst_from_l21_mod",
	.event = "event=0x44046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L2 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L2 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l21_shr",
	.event = "event=0x34046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L2 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L2 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l31_eco_mod",
	.event = "event=0x44044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l31_eco_shr",
	.event = "event=0x34044",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l31_mod",
	.event = "event=0x24044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_from_l31_shr",
	.event = "event=0x14046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
	.long_desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L3 on the same chip due to either an instruction fetch or instruction fetch plus prefetch if MMCR1[17] is 1",
},
{
	.name = "pm_inst_imc_match_disp",
	.event = "event=0x30016",
	.desc = "Matched Instructions Dispatched",
	.topic = "other",
	.long_desc = "IMC Matches dispatched",
},
{
	.name = "pm_iops_disp",
	.event = "event=0x30014",
	.desc = "Internal Operations dispatched",
	.topic = "other",
	.long_desc = "IOPS dispatched",
},
{
	.name = "pm_ipteg_from_l21_mod",
	.event = "event=0x45046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l21_shr",
	.event = "event=0x35046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l2_disp_conflict_ldhitst",
	.event = "event=0x35040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with load hit store conflict due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l2_disp_conflict_other",
	.event = "event=0x45040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with dispatch conflict due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l31_eco_mod",
	.event = "event=0x45044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l31_eco_shr",
	.event = "event=0x35044",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l31_mod",
	.event = "event=0x25044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l31_shr",
	.event = "event=0x15046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_iside_disp",
	.event = "event=0x617082",
	.desc = "All i-side dispatch attempts",
	.topic = "other",
},
{
	.name = "pm_iside_disp_fail",
	.event = "event=0x627084",
	.desc = "All i-side dispatch attempts that failed due to a addr collision with another machine",
	.topic = "other",
},
{
	.name = "pm_iside_disp_fail_other",
	.event = "event=0x627086",
	.desc = "All i-side dispatch attempts that failed due to a reason other than addrs collision",
	.topic = "other",
},
{
	.name = "pm_iside_l2memacc",
	.event = "event=0x4608e",
	.desc = "valid when first beat of data comes in for an i-side fetch where data came from mem(or L4)",
	.topic = "other",
},
{
	.name = "pm_iside_mru_touch",
	.event = "event=0x44608e",
	.desc = "Iside L2 MRU touch",
	.topic = "other",
},
{
	.name = "pm_isu_ref_fx0",
	.event = "event=0x30ac",
	.desc = "FX0 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_ref_fx1",
	.event = "event=0x30ae",
	.desc = "FX1 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_ref_fxu",
	.event = "event=0x38ac",
	.desc = "FXU ISU reject from either pipe",
	.topic = "other",
},
{
	.name = "pm_isu_ref_ls0",
	.event = "event=0x30b0",
	.desc = "LS0 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_ref_ls1",
	.event = "event=0x30b2",
	.desc = "LS1 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_ref_ls2",
	.event = "event=0x30b4",
	.desc = "LS2 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_ref_ls3",
	.event = "event=0x30b6",
	.desc = "LS3 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_rejects_all",
	.event = "event=0x309c",
	.desc = "All isu rejects could be more than 1 per cycle",
	.topic = "other",
},
{
	.name = "pm_isu_reject_res_na",
	.event = "event=0x30a2",
	.desc = "ISU reject due to resource not available",
	.topic = "other",
},
{
	.name = "pm_isu_reject_sar_bypass",
	.event = "event=0x309e",
	.desc = "Reject because of SAR bypass",
	.topic = "other",
},
{
	.name = "pm_isu_reject_src_na",
	.event = "event=0x30a0",
	.desc = "ISU reject due to source not available",
	.topic = "other",
},
{
	.name = "pm_isu_rej_vs0",
	.event = "event=0x30a8",
	.desc = "VS0 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_rej_vs1",
	.event = "event=0x30aa",
	.desc = "VS1 ISU reject",
	.topic = "other",
},
{
	.name = "pm_isu_rej_vsu",
	.event = "event=0x38a8",
	.desc = "VSU ISU reject from either pipe",
	.topic = "other",
},
{
	.name = "pm_isync",
	.event = "event=0x30b8",
	.desc = "Isync count per thread",
	.topic = "other",
},
{
	.name = "pm_l1miss_lat_exc_1024",
	.event = "event=0x200301ea",
	.desc = "L1 misses that took longer than 1024 cyles to resolve (miss to reload)",
	.topic = "other",
	.long_desc = "Reload latency exceeded 1024 cyc",
},
{
	.name = "pm_l1miss_lat_exc_2048",
	.event = "event=0x200401ec",
	.desc = "L1 misses that took longer than 2048 cyles to resolve (miss to reload)",
	.topic = "other",
	.long_desc = "Reload latency exceeded 2048 cyc",
},
{
	.name = "pm_l1miss_lat_exc_256",
	.event = "event=0x200101e8",
	.desc = "L1 misses that took longer than 256 cyles to resolve (miss to reload)",
	.topic = "other",
	.long_desc = "Reload latency exceeded 256 cyc",
},
{
	.name = "pm_l1miss_lat_exc_32",
	.event = "event=0x200201e6",
	.desc = "L1 misses that took longer than 32 cyles to resolve (miss to reload)",
	.topic = "other",
	.long_desc = "Reload latency exceeded 32 cyc",
},
{
	.name = "pm_l1pf_l2memacc",
	.event = "event=0x26086",
	.desc = "valid when first beat of data comes in for an L1pref where data came from mem(or L4)",
	.topic = "other",
},
{
	.name = "pm_l1_demand_write",
	.event = "event=0x408c",
	.desc = "Instruction Demand sectors wriittent into IL1",
	.topic = "other",
},
{
	.name = "pm_l2_castout_mod",
	.event = "event=0x417080",
	.desc = "L2 Castouts - Modified (M, Mu, Me)",
	.topic = "other",
},
{
	.name = "pm_l2_castout_shr",
	.event = "event=0x417082",
	.desc = "L2 Castouts - Shared (T, Te, Si, S)",
	.topic = "other",
},
{
	.name = "pm_l2_chip_pump",
	.event = "event=0x27084",
	.desc = "RC requests that were local on chip pump attempts",
	.topic = "other",
},
{
	.name = "pm_l2_dc_inv",
	.event = "event=0x427086",
	.desc = "Dcache invalidates from L2",
	.topic = "other",
},
{
	.name = "pm_l2_disp_all_l2miss",
	.event = "event=0x44608c",
	.desc = "All successful Ld/St dispatches for this thread that were an L2miss",
	.topic = "other",
},
{
	.name = "pm_l2_group_pump",
	.event = "event=0x27086",
	.desc = "RC requests that were on Node Pump attempts",
	.topic = "other",
},
{
	.name = "pm_l2_grp_guess_correct",
	.event = "event=0x626084",
	.desc = "L2 guess grp and guess was correct (data intra-6chip AND ^on-chip)",
	.topic = "other",
},
{
	.name = "pm_l2_grp_guess_wrong",
	.event = "event=0x626086",
	.desc = "L2 guess grp and guess was not correct (ie data on-chip OR beyond-6chip)",
	.topic = "other",
},
{
	.name = "pm_l2_ic_inv",
	.event = "event=0x427084",
	.desc = "Icache Invalidates from L2",
	.topic = "other",
},
{
	.name = "pm_l2_inst",
	.event = "event=0x436088",
	.desc = "All successful I-side dispatches for this thread (excludes i_l2mru_tch reqs)",
	.topic = "other",
},
{
	.name = "pm_l2_inst_miss",
	.event = "event=0x43608a",
	.desc = "All successful i-side dispatches that were an L2miss for this thread (excludes i_l2mru_tch reqs)",
	.topic = "other",
},
{
	.name = "pm_l2_ld",
	.event = "event=0x416080",
	.desc = "All successful D-side Load dispatches for this thread",
	.topic = "other",
},
{
	.name = "pm_l2_ld_disp",
	.event = "event=0x437088",
	.desc = "All successful load dispatches",
	.topic = "other",
},
{
	.name = "pm_l2_ld_hit",
	.event = "event=0x43708a",
	.desc = "All successful load dispatches that were L2 hits",
	.topic = "other",
},
{
	.name = "pm_l2_ld_miss",
	.event = "event=0x426084",
	.desc = "All successful D-Side Load dispatches that were an L2miss for this thread",
	.topic = "other",
},
{
	.name = "pm_l2_loc_guess_correct",
	.event = "event=0x616080",
	.desc = "L2 guess loc and guess was correct (ie data local)",
	.topic = "other",
},
{
	.name = "pm_l2_loc_guess_wrong",
	.event = "event=0x616082",
	.desc = "L2 guess loc and guess was not correct (ie data not on chip)",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp",
	.event = "event=0x516080",
	.desc = "L2 RC load dispatch attempt",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp_fail_addr",
	.event = "event=0x516082",
	.desc = "L2 RC load dispatch attempt failed due to address collision with RC/CO/SN/SQ",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp_fail_other",
	.event = "event=0x526084",
	.desc = "L2 RC load dispatch attempt failed due to other reasons",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp",
	.event = "event=0x536088",
	.desc = "L2 RC store dispatch attempt",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp_fail_addr",
	.event = "event=0x53608a",
	.desc = "L2 RC store dispatch attempt failed due to address collision with RC/CO/SN/SQ",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp_fail_other",
	.event = "event=0x54608c",
	.desc = "L2 RC store dispatch attempt failed due to other reasons",
	.topic = "other",
},
{
	.name = "pm_l2_rc_st_done",
	.event = "event=0x537088",
	.desc = "RC did st to line that was Tx or Sx",
	.topic = "other",
},
{
	.name = "pm_l2_rty_ld",
	.event = "event=0x63708a",
	.desc = "RC retries on PB for any load from core",
	.topic = "other",
},
{
	.name = "pm_l2_rty_st",
	.event = "event=0x3708a",
	.desc = "RC retries on PB for any store from core",
	.topic = "other",
},
{
	.name = "pm_l2_sn_m_rd_done",
	.event = "event=0x54708c",
	.desc = "SNP dispatched for a read and was M",
	.topic = "other",
},
{
	.name = "pm_l2_sn_m_wr_done",
	.event = "event=0x54708e",
	.desc = "SNP dispatched for a write and was M",
	.topic = "other",
},
{
	.name = "pm_l2_sn_sx_i_done",
	.event = "event=0x53708a",
	.desc = "SNP dispatched and went from Sx or Tx to Ix",
	.topic = "other",
},
{
	.name = "pm_l2_st",
	.event = "event=0x17080",
	.desc = "All successful D-side store dispatches for this thread",
	.topic = "other",
},
{
	.name = "pm_l2_st_disp",
	.event = "event=0x44708c",
	.desc = "All successful store dispatches",
	.topic = "other",
},
{
	.name = "pm_l2_st_hit",
	.event = "event=0x44708e",
	.desc = "All successful store dispatches that were L2Hits",
	.topic = "other",
},
{
	.name = "pm_l2_st_miss",
	.event = "event=0x17082",
	.desc = "All successful D-side store dispatches for this thread that were L2 Miss",
	.topic = "other",
},
{
	.name = "pm_l2_sys_guess_correct",
	.event = "event=0x636088",
	.desc = "L2 guess sys and guess was correct (ie data beyond-6chip)",
	.topic = "other",
},
{
	.name = "pm_l2_sys_guess_wrong",
	.event = "event=0x63608a",
	.desc = "L2 guess sys and guess was not correct (ie data ^beyond-6chip)",
	.topic = "other",
},
{
	.name = "pm_l2_sys_pump",
	.event = "event=0x617080",
	.desc = "RC requests that were system pump attempts",
	.topic = "other",
},
{
	.name = "pm_l2_tm_req_abort",
	.event = "event=0x1e05e",
	.desc = "TM abort",
	.topic = "other",
},
{
	.name = "pm_l2_tm_st_abort_sister",
	.event = "event=0x3e05c",
	.desc = "TM marked store abort",
	.topic = "other",
},
{
	.name = "pm_l3_cinj",
	.event = "event=0x23808a",
	.desc = "l3 ci of cache inject",
	.topic = "other",
},
{
	.name = "pm_l3_ci_hit",
	.event = "event=0x128084",
	.desc = "L3 Castins Hit (total count",
	.topic = "other",
},
{
	.name = "pm_l3_ci_miss",
	.event = "event=0x128086",
	.desc = "L3 castins miss (total count",
	.topic = "other",
},
{
	.name = "pm_l3_ci_usage",
	.event = "event=0x819082",
	.desc = "rotating sample of 16 CI or CO actives",
	.topic = "other",
},
{
	.name = "pm_l3_co",
	.event = "event=0x438088",
	.desc = "l3 castout occurring ( does not include casthrough or log writes (cinj/dmaw)",
	.topic = "other",
},
{
	.name = "pm_l3_co0_alloc",
	.event = "event=0x83908b",
	.desc = "lifetime, sample of CO machine 0 valid",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_l3_co0_busy",
	.event = "event=0x83908a",
	.desc = "lifetime, sample of CO machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_co_l31",
	.event = "event=0x28086",
	.desc = "L3 CO to L3.1 OR of port 0 and 1 ( lossy)",
	.topic = "other",
},
{
	.name = "pm_l3_co_lco",
	.event = "event=0x238088",
	.desc = "Total L3 castouts occurred on LCO",
	.topic = "other",
},
{
	.name = "pm_l3_co_mem",
	.event = "event=0x28084",
	.desc = "L3 CO to memory OR of port 0 and 1 ( lossy)",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_correct",
	.event = "event=0xb19082",
	.desc = "Initial scope=group and data from same group (near) (pred successful)",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_wrong_high",
	.event = "event=0xb3908a",
	.desc = "Initial scope=group but data from local node. Predition too high",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_wrong_low",
	.event = "event=0xb39088",
	.desc = "Initial scope=group but data from outside group (far or rem). Prediction too Low",
	.topic = "other",
},
{
	.name = "pm_l3_hit",
	.event = "event=0x218080",
	.desc = "L3 Hits",
	.topic = "other",
},
{
	.name = "pm_l3_l2_co_hit",
	.event = "event=0x138088",
	.desc = "L2 castout hits",
	.topic = "other",
},
{
	.name = "pm_l3_l2_co_miss",
	.event = "event=0x13808a",
	.desc = "L2 castout miss",
	.topic = "other",
},
{
	.name = "pm_l3_lat_ci_hit",
	.event = "event=0x14808c",
	.desc = "L3 Lateral Castins Hit",
	.topic = "other",
},
{
	.name = "pm_l3_lat_ci_miss",
	.event = "event=0x14808e",
	.desc = "L3 Lateral Castins Miss",
	.topic = "other",
},
{
	.name = "pm_l3_ld_hit",
	.event = "event=0x228084",
	.desc = "L3 demand LD Hits",
	.topic = "other",
},
{
	.name = "pm_l3_ld_miss",
	.event = "event=0x228086",
	.desc = "L3 demand LD Miss",
	.topic = "other",
},
{
	.name = "pm_l3_ld_pref",
	.event = "event=0x1e052",
	.desc = "L3 Load Prefetches",
	.topic = "other",
},
{
	.name = "pm_l3_loc_guess_correct",
	.event = "event=0xb19080",
	.desc = "initial scope=node/chip and data from local node (local) (pred successful)",
	.topic = "other",
},
{
	.name = "pm_l3_loc_guess_wrong",
	.event = "event=0xb29086",
	.desc = "Initial scope=node but data from out side local node (near or far or rem). Prediction too Low",
	.topic = "other",
},
{
	.name = "pm_l3_miss",
	.event = "event=0x218082",
	.desc = "L3 Misses",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_l31",
	.event = "event=0x54808c",
	.desc = "l3 CO to L3.1 (lco) port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_mem",
	.event = "event=0x538088",
	.desc = "l3 CO to memory port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_rty",
	.event = "event=0x929084",
	.desc = "L3 CO received retry port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_grp_pump",
	.event = "event=0xa29084",
	.desc = "L3 pf sent with grp scope port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_data",
	.event = "event=0x528084",
	.desc = "lco sent with data port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_no_data",
	.event = "event=0x518080",
	.desc = "dataless l3 lco sent port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_rty",
	.event = "event=0xa4908c",
	.desc = "L3 LCO received retry port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_node_pump",
	.event = "event=0xa19080",
	.desc = "L3 pf sent with nodal scope port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_pf_rty",
	.event = "event=0x919080",
	.desc = "L3 PF received retry port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_sn_hit",
	.event = "event=0x939088",
	.desc = "L3 snoop hit port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_sn_inv",
	.event = "event=0x118080",
	.desc = "Port0 snooper detects someone doing a store to a line thats Sx",
	.topic = "other",
},
{
	.name = "pm_l3_p0_sn_miss",
	.event = "event=0x94908c",
	.desc = "L3 snoop miss port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p0_sys_pump",
	.event = "event=0xa39088",
	.desc = "L3 pf sent with sys scope port 0",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_l31",
	.event = "event=0x54808e",
	.desc = "l3 CO to L3.1 (lco) port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_mem",
	.event = "event=0x53808a",
	.desc = "l3 CO to memory port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_rty",
	.event = "event=0x929086",
	.desc = "L3 CO received retry port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_grp_pump",
	.event = "event=0xa29086",
	.desc = "L3 pf sent with grp scope port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_data",
	.event = "event=0x528086",
	.desc = "lco sent with data port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_no_data",
	.event = "event=0x518082",
	.desc = "dataless l3 lco sent port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_rty",
	.event = "event=0xa4908e",
	.desc = "L3 LCO received retry port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_node_pump",
	.event = "event=0xa19082",
	.desc = "L3 pf sent with nodal scope port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_pf_rty",
	.event = "event=0x919082",
	.desc = "L3 PF received retry port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_sn_hit",
	.event = "event=0x93908a",
	.desc = "L3 snoop hit port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_sn_inv",
	.event = "event=0x118082",
	.desc = "Port1 snooper detects someone doing a store to a line thats Sx",
	.topic = "other",
},
{
	.name = "pm_l3_p1_sn_miss",
	.event = "event=0x94908e",
	.desc = "L3 snoop miss port 1",
	.topic = "other",
},
{
	.name = "pm_l3_p1_sys_pump",
	.event = "event=0xa3908a",
	.desc = "L3 pf sent with sys scope port 1",
	.topic = "other",
},
{
	.name = "pm_l3_pf0_alloc",
	.event = "event=0x84908d",
	.desc = "lifetime, sample of PF machine 0 valid",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_l3_pf0_busy",
	.event = "event=0x84908c",
	.desc = "lifetime, sample of PF machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_pf_hit_l3",
	.event = "event=0x428084",
	.desc = "l3 pf hit in l3",
	.topic = "other",
},
{
	.name = "pm_l3_pf_miss_l3",
	.event = "event=0x18080",
	.desc = "L3 Prefetch missed in L3",
	.topic = "other",
},
{
	.name = "pm_l3_pf_off_chip_cache",
	.event = "event=0x3808a",
	.desc = "L3 Prefetch from Off chip cache",
	.topic = "other",
},
{
	.name = "pm_l3_pf_off_chip_mem",
	.event = "event=0x4808e",
	.desc = "L3 Prefetch from Off chip memory",
	.topic = "other",
},
{
	.name = "pm_l3_pf_on_chip_cache",
	.event = "event=0x38088",
	.desc = "L3 Prefetch from On chip cache",
	.topic = "other",
},
{
	.name = "pm_l3_pf_on_chip_mem",
	.event = "event=0x4808c",
	.desc = "L3 Prefetch from On chip memory",
	.topic = "other",
},
{
	.name = "pm_l3_pf_usage",
	.event = "event=0x829084",
	.desc = "rotating sample of 32 PF actives",
	.topic = "other",
},
{
	.name = "pm_l3_pref_all",
	.event = "event=0x4e052",
	.desc = "Total HW L3 prefetches(Load+store)",
	.topic = "other",
},
{
	.name = "pm_l3_rd0_alloc",
	.event = "event=0x84908f",
	.desc = "lifetime, sample of RD machine 0 valid",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_l3_rd0_busy",
	.event = "event=0x84908e",
	.desc = "lifetime, sample of RD machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_rd_usage",
	.event = "event=0x829086",
	.desc = "rotating sample of 16 RD actives",
	.topic = "other",
},
{
	.name = "pm_l3_sn0_alloc",
	.event = "event=0x839089",
	.desc = "lifetime, sample of snooper machine 0 valid",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_l3_sn0_busy",
	.event = "event=0x839088",
	.desc = "lifetime, sample of snooper machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_sn_usage",
	.event = "event=0x819080",
	.desc = "rotating sample of 8 snoop valids",
	.topic = "other",
},
{
	.name = "pm_l3_st_pref",
	.event = "event=0x2e052",
	.desc = "L3 store Prefetches",
	.topic = "other",
},
{
	.name = "pm_l3_sw_pref",
	.event = "event=0x3e052",
	.desc = "Data stream touchto L3",
	.topic = "other",
},
{
	.name = "pm_l3_sys_guess_correct",
	.event = "event=0xb29084",
	.desc = "Initial scope=system and data from outside group (far or rem)(pred successful)",
	.topic = "other",
},
{
	.name = "pm_l3_sys_guess_wrong",
	.event = "event=0xb4908c",
	.desc = "Initial scope=system but data from local or near. Predction too high",
	.topic = "other",
},
{
	.name = "pm_l3_trans_pf",
	.event = "event=0x24808e",
	.desc = "L3 Transient prefetch",
	.topic = "other",
},
{
	.name = "pm_l3_wi0_alloc",
	.event = "event=0x18081",
	.desc = "lifetime, sample of Write Inject machine 0 valid",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_l3_wi0_busy",
	.event = "event=0x418080",
	.desc = "lifetime, sample of Write Inject machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_wi_usage",
	.event = "event=0x418082",
	.desc = "rotating sample of 8 WI actives",
	.topic = "other",
},
{
	.name = "pm_ld_ref_l1_lsu0",
	.event = "event=0xc080",
	.desc = "LS0 L1 D cache load references counted at finish, gated by reject",
	.topic = "other",
	.long_desc = "LS0 L1 D cache load references counted at finish, gated by rejectLSU0 L1 D cache load references",
},
{
	.name = "pm_ld_ref_l1_lsu1",
	.event = "event=0xc082",
	.desc = "LS1 L1 D cache load references counted at finish, gated by reject",
	.topic = "other",
	.long_desc = "LS1 L1 D cache load references counted at finish, gated by rejectLSU1 L1 D cache load references",
},
{
	.name = "pm_ld_ref_l1_lsu2",
	.event = "event=0xc094",
	.desc = "LS2 L1 D cache load references counted at finish, gated by reject",
	.topic = "other",
	.long_desc = "LS2 L1 D cache load references counted at finish, gated by reject42",
},
{
	.name = "pm_ld_ref_l1_lsu3",
	.event = "event=0xc096",
	.desc = "LS3 L1 D cache load references counted at finish, gated by reject",
	.topic = "other",
	.long_desc = "LS3 L1 D cache load references counted at finish, gated by reject42",
},
{
	.name = "pm_link_stack_invalid_ptr",
	.event = "event=0x509a",
	.desc = "A flush were LS ptr is invalid, results in a pop , A lot of interrupts between push and pops",
	.topic = "other",
},
{
	.name = "pm_link_stack_wrong_add_pred",
	.event = "event=0x5098",
	.desc = "Link stack predicts wrong address, because of link stack design limitation",
	.topic = "other",
},
{
	.name = "pm_ls0_erat_miss_pref",
	.event = "event=0xe080",
	.desc = "LS0 Erat miss due to prefetch",
	.topic = "other",
	.long_desc = "LS0 Erat miss due to prefetch42",
},
{
	.name = "pm_ls0_l1_pref",
	.event = "event=0xd0b8",
	.desc = "LS0 L1 cache data prefetches",
	.topic = "other",
	.long_desc = "LS0 L1 cache data prefetches42",
},
{
	.name = "pm_ls0_l1_sw_pref",
	.event = "event=0xc098",
	.desc = "Software L1 Prefetches, including SW Transient Prefetches",
	.topic = "other",
	.long_desc = "Software L1 Prefetches, including SW Transient Prefetches42",
},
{
	.name = "pm_ls1_erat_miss_pref",
	.event = "event=0xe082",
	.desc = "LS1 Erat miss due to prefetch",
	.topic = "other",
	.long_desc = "LS1 Erat miss due to prefetch42",
},
{
	.name = "pm_ls1_l1_pref",
	.event = "event=0xd0ba",
	.desc = "LS1 L1 cache data prefetches",
	.topic = "other",
	.long_desc = "LS1 L1 cache data prefetches42",
},
{
	.name = "pm_ls1_l1_sw_pref",
	.event = "event=0xc09a",
	.desc = "Software L1 Prefetches, including SW Transient Prefetches",
	.topic = "other",
	.long_desc = "Software L1 Prefetches, including SW Transient Prefetches42",
},
{
	.name = "pm_lsu0_flush_lrq",
	.event = "event=0xc0b0",
	.desc = "LS0 Flush: LRQ",
	.topic = "other",
	.long_desc = "LS0 Flush: LRQLSU0 LRQ flushes",
},
{
	.name = "pm_lsu0_flush_srq",
	.event = "event=0xc0b8",
	.desc = "LS0 Flush: SRQ",
	.topic = "other",
	.long_desc = "LS0 Flush: SRQLSU0 SRQ lhs flushes",
},
{
	.name = "pm_lsu0_flush_uld",
	.event = "event=0xc0a4",
	.desc = "LS0 Flush: Unaligned Load",
	.topic = "other",
	.long_desc = "LS0 Flush: Unaligned LoadLSU0 unaligned load flushes",
},
{
	.name = "pm_lsu0_flush_ust",
	.event = "event=0xc0ac",
	.desc = "LS0 Flush: Unaligned Store",
	.topic = "other",
	.long_desc = "LS0 Flush: Unaligned StoreLSU0 unaligned store flushes",
},
{
	.name = "pm_lsu0_l1_cam_cancel",
	.event = "event=0xf088",
	.desc = "ls0 l1 tm cam cancel",
	.topic = "other",
	.long_desc = "ls0 l1 tm cam cancel42",
},
{
	.name = "pm_lsu0_larx_fin",
	.event = "event=0x1e056",
	.desc = "Larx finished in LSU pipe0",
	.topic = "other",
},
{
	.name = "pm_lsu0_lmq_lhr_merge",
	.event = "event=0xd08c",
	.desc = "LS0 Load Merged with another cacheline request",
	.topic = "other",
	.long_desc = "LS0 Load Merged with another cacheline request42",
},
{
	.name = "pm_lsu0_ncld",
	.event = "event=0xc08c",
	.desc = "LS0 Non-cachable Loads counted at finish",
	.topic = "other",
	.long_desc = "LS0 Non-cachable Loads counted at finishLSU0 non-cacheable loads",
},
{
	.name = "pm_lsu0_primary_erat_hit",
	.event = "event=0xe090",
	.desc = "Primary ERAT hit",
	.topic = "other",
	.long_desc = "Primary ERAT hit42",
},
{
	.name = "pm_lsu0_reject",
	.event = "event=0x1e05a",
	.desc = "LSU0 reject",
	.topic = "other",
},
{
	.name = "pm_lsu0_srq_stfwd",
	.event = "event=0xc09c",
	.desc = "LS0 SRQ forwarded data to a load",
	.topic = "other",
	.long_desc = "LS0 SRQ forwarded data to a loadLSU0 SRQ store forwarded",
},
{
	.name = "pm_lsu0_store_reject",
	.event = "event=0xf084",
	.desc = "ls0 store reject",
	.topic = "other",
	.long_desc = "ls0 store reject42",
},
{
	.name = "pm_lsu0_tma_req_l2",
	.event = "event=0xe0a8",
	.desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding",
	.topic = "other",
	.long_desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding42",
},
{
	.name = "pm_lsu0_tm_l1_hit",
	.event = "event=0xe098",
	.desc = "Load tm hit in L1",
	.topic = "other",
	.long_desc = "Load tm hit in L142",
},
{
	.name = "pm_lsu0_tm_l1_miss",
	.event = "event=0xe0a0",
	.desc = "Load tm L1 miss",
	.topic = "other",
	.long_desc = "Load tm L1 miss42",
},
{
	.name = "pm_lsu1_flush_lrq",
	.event = "event=0xc0b2",
	.desc = "LS1 Flush: LRQ",
	.topic = "other",
	.long_desc = "LS1 Flush: LRQLSU1 LRQ flushes",
},
{
	.name = "pm_lsu1_flush_srq",
	.event = "event=0xc0ba",
	.desc = "LS1 Flush: SRQ",
	.topic = "other",
	.long_desc = "LS1 Flush: SRQLSU1 SRQ lhs flushes",
},
{
	.name = "pm_lsu1_flush_uld",
	.event = "event=0xc0a6",
	.desc = "LS 1 Flush: Unaligned Load",
	.topic = "other",
	.long_desc = "LS 1 Flush: Unaligned LoadLSU1 unaligned load flushes",
},
{
	.name = "pm_lsu1_flush_ust",
	.event = "event=0xc0ae",
	.desc = "LS1 Flush: Unaligned Store",
	.topic = "other",
	.long_desc = "LS1 Flush: Unaligned StoreLSU1 unaligned store flushes",
},
{
	.name = "pm_lsu1_l1_cam_cancel",
	.event = "event=0xf08a",
	.desc = "ls1 l1 tm cam cancel",
	.topic = "other",
	.long_desc = "ls1 l1 tm cam cancel42",
},
{
	.name = "pm_lsu1_larx_fin",
	.event = "event=0x2e056",
	.desc = "Larx finished in LSU pipe1",
	.topic = "other",
},
{
	.name = "pm_lsu1_lmq_lhr_merge",
	.event = "event=0xd08e",
	.desc = "LS1 Load Merge with another cacheline request",
	.topic = "other",
	.long_desc = "LS1 Load Merge with another cacheline request42",
},
{
	.name = "pm_lsu1_ncld",
	.event = "event=0xc08e",
	.desc = "LS1 Non-cachable Loads counted at finish",
	.topic = "other",
	.long_desc = "LS1 Non-cachable Loads counted at finishLSU1 non-cacheable loads",
},
{
	.name = "pm_lsu1_primary_erat_hit",
	.event = "event=0xe092",
	.desc = "Primary ERAT hit",
	.topic = "other",
	.long_desc = "Primary ERAT hit42",
},
{
	.name = "pm_lsu1_reject",
	.event = "event=0x2e05a",
	.desc = "LSU1 reject",
	.topic = "other",
},
{
	.name = "pm_lsu1_srq_stfwd",
	.event = "event=0xc09e",
	.desc = "LS1 SRQ forwarded data to a load",
	.topic = "other",
	.long_desc = "LS1 SRQ forwarded data to a loadLSU1 SRQ store forwarded",
},
{
	.name = "pm_lsu1_store_reject",
	.event = "event=0xf086",
	.desc = "ls1 store reject",
	.topic = "other",
	.long_desc = "ls1 store reject42",
},
{
	.name = "pm_lsu1_tma_req_l2",
	.event = "event=0xe0aa",
	.desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding",
	.topic = "other",
	.long_desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding42",
},
{
	.name = "pm_lsu1_tm_l1_hit",
	.event = "event=0xe09a",
	.desc = "Load tm hit in L1",
	.topic = "other",
	.long_desc = "Load tm hit in L142",
},
{
	.name = "pm_lsu1_tm_l1_miss",
	.event = "event=0xe0a2",
	.desc = "Load tm L1 miss",
	.topic = "other",
	.long_desc = "Load tm L1 miss42",
},
{
	.name = "pm_lsu2_flush_lrq",
	.event = "event=0xc0b4",
	.desc = "LS02Flush: LRQ",
	.topic = "other",
	.long_desc = "LS02Flush: LRQ42",
},
{
	.name = "pm_lsu2_flush_srq",
	.event = "event=0xc0bc",
	.desc = "LS2 Flush: SRQ",
	.topic = "other",
	.long_desc = "LS2 Flush: SRQ42",
},
{
	.name = "pm_lsu2_flush_uld",
	.event = "event=0xc0a8",
	.desc = "LS3 Flush: Unaligned Load",
	.topic = "other",
	.long_desc = "LS3 Flush: Unaligned Load42",
},
{
	.name = "pm_lsu2_l1_cam_cancel",
	.event = "event=0xf08c",
	.desc = "ls2 l1 tm cam cancel",
	.topic = "other",
	.long_desc = "ls2 l1 tm cam cancel42",
},
{
	.name = "pm_lsu2_larx_fin",
	.event = "event=0x3e056",
	.desc = "Larx finished in LSU pipe2",
	.topic = "other",
},
{
	.name = "pm_lsu2_ldf",
	.event = "event=0xc084",
	.desc = "LS2 Scalar Loads",
	.topic = "other",
	.long_desc = "LS2 Scalar Loads42",
},
{
	.name = "pm_lsu2_ldx",
	.event = "event=0xc088",
	.desc = "LS0 Vector Loads",
	.topic = "other",
	.long_desc = "LS0 Vector Loads42",
},
{
	.name = "pm_lsu2_lmq_lhr_merge",
	.event = "event=0xd090",
	.desc = "LS0 Load Merged with another cacheline request",
	.topic = "other",
	.long_desc = "LS0 Load Merged with another cacheline request42",
},
{
	.name = "pm_lsu2_primary_erat_hit",
	.event = "event=0xe094",
	.desc = "Primary ERAT hit",
	.topic = "other",
	.long_desc = "Primary ERAT hit42",
},
{
	.name = "pm_lsu2_reject",
	.event = "event=0x3e05a",
	.desc = "LSU2 reject",
	.topic = "other",
},
{
	.name = "pm_lsu2_srq_stfwd",
	.event = "event=0xc0a0",
	.desc = "LS2 SRQ forwarded data to a load",
	.topic = "other",
	.long_desc = "LS2 SRQ forwarded data to a load42",
},
{
	.name = "pm_lsu2_tma_req_l2",
	.event = "event=0xe0ac",
	.desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding",
	.topic = "other",
	.long_desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding42",
},
{
	.name = "pm_lsu2_tm_l1_hit",
	.event = "event=0xe09c",
	.desc = "Load tm hit in L1",
	.topic = "other",
	.long_desc = "Load tm hit in L142",
},
{
	.name = "pm_lsu2_tm_l1_miss",
	.event = "event=0xe0a4",
	.desc = "Load tm L1 miss",
	.topic = "other",
	.long_desc = "Load tm L1 miss42",
},
{
	.name = "pm_lsu3_flush_lrq",
	.event = "event=0xc0b6",
	.desc = "LS3 Flush: LRQ",
	.topic = "other",
	.long_desc = "LS3 Flush: LRQ42",
},
{
	.name = "pm_lsu3_flush_srq",
	.event = "event=0xc0be",
	.desc = "LS13 Flush: SRQ",
	.topic = "other",
	.long_desc = "LS13 Flush: SRQ42",
},
{
	.name = "pm_lsu3_flush_uld",
	.event = "event=0xc0aa",
	.desc = "LS 14Flush: Unaligned Load",
	.topic = "other",
	.long_desc = "LS 14Flush: Unaligned Load42",
},
{
	.name = "pm_lsu3_l1_cam_cancel",
	.event = "event=0xf08e",
	.desc = "ls3 l1 tm cam cancel",
	.topic = "other",
	.long_desc = "ls3 l1 tm cam cancel42",
},
{
	.name = "pm_lsu3_larx_fin",
	.event = "event=0x4e056",
	.desc = "Larx finished in LSU pipe3",
	.topic = "other",
},
{
	.name = "pm_lsu3_ldf",
	.event = "event=0xc086",
	.desc = "LS3 Scalar Loads",
	.topic = "other",
	.long_desc = "LS3 Scalar Loads 42",
},
{
	.name = "pm_lsu3_ldx",
	.event = "event=0xc08a",
	.desc = "LS1 Vector Loads",
	.topic = "other",
	.long_desc = "LS1 Vector Loads42",
},
{
	.name = "pm_lsu3_lmq_lhr_merge",
	.event = "event=0xd092",
	.desc = "LS1 Load Merge with another cacheline request",
	.topic = "other",
	.long_desc = "LS1 Load Merge with another cacheline request42",
},
{
	.name = "pm_lsu3_primary_erat_hit",
	.event = "event=0xe096",
	.desc = "Primary ERAT hit",
	.topic = "other",
	.long_desc = "Primary ERAT hit42",
},
{
	.name = "pm_lsu3_reject",
	.event = "event=0x4e05a",
	.desc = "LSU3 reject",
	.topic = "other",
},
{
	.name = "pm_lsu3_srq_stfwd",
	.event = "event=0xc0a2",
	.desc = "LS3 SRQ forwarded data to a load",
	.topic = "other",
	.long_desc = "LS3 SRQ forwarded data to a load42",
},
{
	.name = "pm_lsu3_tma_req_l2",
	.event = "event=0xe0ae",
	.desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding",
	.topic = "other",
	.long_desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding42",
},
{
	.name = "pm_lsu3_tm_l1_hit",
	.event = "event=0xe09e",
	.desc = "Load tm hit in L1",
	.topic = "other",
	.long_desc = "Load tm hit in L142",
},
{
	.name = "pm_lsu3_tm_l1_miss",
	.event = "event=0xe0a6",
	.desc = "Load tm L1 miss",
	.topic = "other",
	.long_desc = "Load tm L1 miss42",
},
{
	.name = "pm_lsu_erat_miss_pref",
	.event = "event=0xe880",
	.desc = "Erat miss due to prefetch, on either pipe",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_flush_ust",
	.event = "event=0xc8ac",
	.desc = "Unaligned Store Flush on either pipe",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_four_tablewalk_cyc",
	.event = "event=0xd0a4",
	.desc = "Cycles when four tablewalks pending on this thread",
	.topic = "other",
	.long_desc = "Cycles when four tablewalks pending on this thread42",
},
{
	.name = "pm_lsu_fx_fin",
	.event = "event=0x10066",
	.desc = "LSU Finished a FX operation (up to 2 per cycle",
	.topic = "other",
},
{
	.name = "pm_lsu_l1_pref",
	.event = "event=0xd8b8",
	.desc = "hw initiated , include sw streaming forms as well , include sw streams as a separate event",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_l1_sw_pref",
	.event = "event=0xc898",
	.desc = "Software L1 Prefetches, including SW Transient Prefetches, on both pipes",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_ldf",
	.event = "event=0xc884",
	.desc = "FPU loads only on LS2/LS3 ie LU0/LU1",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_ldx",
	.event = "event=0xc888",
	.desc = "Vector loads can issue only on LS2/LS3",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_lmq_full_cyc",
	.event = "event=0xd0a2",
	.desc = "LMQ full",
	.topic = "other",
	.long_desc = "LMQ fullCycles LMQ full",
},
{
	.name = "pm_lsu_lmq_s0_alloc",
	.event = "event=0xd0a1",
	.desc = "Per thread - use edge detect to count allocates On a per thread basis, level signal indicating Slot 0 is valid. By instrumenting a single slot we can calculate service time for that slot. Previous machines required a separate signal indicating the slot was allocated. Because any signal can be routed to any counter in P8, we can count level in one PMC and edge detect in another PMC using the same signal",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_lmq_s0_valid",
	.event = "event=0xd0a0",
	.desc = "Slot 0 of LMQ valid",
	.topic = "other",
	.long_desc = "Slot 0 of LMQ validLMQ slot 0 valid",
},
{
	.name = "pm_lsu_lmq_srq_empty_all_cyc",
	.event = "event=0x3001c",
	.desc = "ALL threads lsu empty (lmq and srq empty)",
	.topic = "other",
	.long_desc = "ALL threads lsu empty (lmq and srq empty). Issue HW016541",
},
{
	.name = "pm_lsu_lrq_s0_alloc",
	.event = "event=0xd09f",
	.desc = "Per thread - use edge detect to count allocates On a per thread basis, level signal indicating Slot 0 is valid. By instrumenting a single slot we can calculate service time for that slot. Previous machines required a separate signal indicating the slot was allocated. Because any signal can be routed to any counter in P8, we can count level in one PMC and edge detect in another PMC using the same signal",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_lrq_s0_valid",
	.event = "event=0xd09e",
	.desc = "Slot 0 of LRQ valid",
	.topic = "other",
	.long_desc = "Slot 0 of LRQ validLRQ slot 0 valid",
},
{
	.name = "pm_lsu_lrq_s43_alloc",
	.event = "event=0xf091",
	.desc = "LRQ slot 43 was released",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_lrq_s43_valid",
	.event = "event=0xf090",
	.desc = "LRQ slot 43 was busy",
	.topic = "other",
	.long_desc = "LRQ slot 43 was busy42",
},
{
	.name = "pm_lsu_mrk_derat_miss",
	.event = "event=0x30162",
	.desc = "DERAT Reloaded (Miss)",
	.topic = "other",
},
{
	.name = "pm_lsu_ncld",
	.event = "event=0xc88c",
	.desc = "count at finish so can return only on ls0 or ls1",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_ncst",
	.event = "event=0xc092",
	.desc = "Non-cachable Stores sent to nest",
	.topic = "other",
	.long_desc = "Non-cachable Stores sent to nest42",
},
{
	.name = "pm_lsu_reject",
	.event = "event=0x10064",
	.desc = "LSU Reject (up to 4 per cycle)",
	.topic = "other",
},
{
	.name = "pm_lsu_set_mpred",
	.event = "event=0xd082",
	.desc = "Line already in cache at reload time",
	.topic = "other",
	.long_desc = "Line already in cache at reload time42",
},
{
	.name = "pm_lsu_srq_empty_cyc",
	.event = "event=0x40008",
	.desc = "ALL threads srq empty",
	.topic = "other",
	.long_desc = "All threads srq empty",
},
{
	.name = "pm_lsu_srq_s0_alloc",
	.event = "event=0xd09d",
	.desc = "Per thread - use edge detect to count allocates On a per thread basis, level signal indicating Slot 0 is valid. By instrumenting a single slot we can calculate service time for that slot. Previous machines required a separate signal indicating the slot was allocated. Because any signal can be routed to any counter in P8, we can count level in one PMC and edge detect in another PMC using the same signal",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_srq_s0_valid",
	.event = "event=0xd09c",
	.desc = "Slot 0 of SRQ valid",
	.topic = "other",
	.long_desc = "Slot 0 of SRQ validSRQ slot 0 valid",
},
{
	.name = "pm_lsu_srq_s39_alloc",
	.event = "event=0xf093",
	.desc = "SRQ slot 39 was released",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_srq_s39_valid",
	.event = "event=0xf092",
	.desc = "SRQ slot 39 was busy",
	.topic = "other",
	.long_desc = "SRQ slot 39 was busy42",
},
{
	.name = "pm_lsu_srq_sync",
	.event = "event=0xd09b",
	.desc = "A sync in the SRQ ended",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_lsu_srq_sync_cyc",
	.event = "event=0xd09a",
	.desc = "A sync is in the SRQ (edge detect to count)",
	.topic = "other",
	.long_desc = "A sync is in the SRQ (edge detect to count)SRQ sync duration",
},
{
	.name = "pm_lsu_store_reject",
	.event = "event=0xf084",
	.desc = "Store reject on either pipe",
	.topic = "other",
	.long_desc = "LSU",
},
{
	.name = "pm_lsu_two_tablewalk_cyc",
	.event = "event=0xd0a6",
	.desc = "Cycles when two tablewalks pending on this thread",
	.topic = "other",
	.long_desc = "Cycles when two tablewalks pending on this thread42",
},
{
	.name = "pm_lwsync",
	.event = "event=0x5094",
	.desc = "threaded version, IC Misses where we got EA dir hit but no sector valids were on. ICBI took line out",
	.topic = "other",
},
{
	.name = "pm_lwsync_held",
	.event = "event=0x209a",
	.desc = "LWSYNC held at dispatch",
	.topic = "other",
},
{
	.name = "pm_mrk_cru_fin",
	.event = "event=0x3013a",
	.desc = "IFU non-branch finished",
	.topic = "other",
	.long_desc = "IFU non-branch marked instruction finished",
},
{
	.name = "pm_mrk_data_from_l21_mod",
	.event = "event=0x4d146",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l21_mod_cyc",
	.event = "event=0x2d126",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's L2 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l21_shr",
	.event = "event=0x3d146",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l21_shr_cyc",
	.event = "event=0x2c126",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's L2 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_mod",
	.event = "event=0x4d144",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_mod_cyc",
	.event = "event=0x2d124",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_shr",
	.event = "event=0x3d144",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_shr_cyc",
	.event = "event=0x2c124",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_mod",
	.event = "event=0x2d144",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_mod_cyc",
	.event = "event=0x4d124",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_shr",
	.event = "event=0x1d146",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_shr_cyc",
	.event = "event=0x4c126",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_mem",
	.event = "event=0x201e0",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l21_mod",
	.event = "event=0x4f146",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l21_shr",
	.event = "event=0x3f146",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l2_disp_conflict_ldhitst",
	.event = "event=0x3f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with load hit store conflict due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l2_disp_conflict_other",
	.event = "event=0x4f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 with dispatch conflict due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l31_eco_mod",
	.event = "event=0x4f144",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l31_eco_shr",
	.event = "event=0x3f144",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l31_mod",
	.event = "event=0x2f144",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l31_shr",
	.event = "event=0x1f146",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a marked data side request",
	.topic = "other",
},
{
	.name = "pm_mrk_fab_rsp_match",
	.event = "event=0x30156",
	.desc = "ttype and cresp matched as specified in MMCR1",
	.topic = "other",
},
{
	.name = "pm_mrk_fab_rsp_match_cyc",
	.event = "event=0x4f152",
	.desc = "cresp/ttype match cycles",
	.topic = "other",
},
{
	.name = "pm_mrk_filt_match",
	.event = "event=0x2013c",
	.desc = "Marked filter Match",
	.topic = "other",
},
{
	.name = "pm_mrk_fin_stall_cyc",
	.event = "event=0x1013c",
	.desc = "Marked instruction Finish Stall cycles (marked finish after NTC) (use edge detect to count )",
	.topic = "other",
	.long_desc = "Marked instruction Finish Stall cycles (marked finish after NTC) (use edge detect to count #)",
},
{
	.name = "pm_mrk_grp_cmpl",
	.event = "event=0x40130",
	.desc = "marked instruction finished (completed)",
	.topic = "other",
},
{
	.name = "pm_mrk_grp_ic_miss",
	.event = "event=0x4013a",
	.desc = "Marked Group experienced I cache miss",
	.topic = "other",
},
{
	.name = "pm_mrk_grp_ntc",
	.event = "event=0x3013c",
	.desc = "Marked group ntc cycles",
	.topic = "other",
},
{
	.name = "pm_mrk_ld_miss_exposed",
	.event = "event=0x1013f",
	.desc = "Marked Load exposed Miss (exposed period ended)",
	.topic = "other",
	.long_desc = "Marked Load exposed Miss (use edge detect to count #)",
},
{
	.name = "pm_mrk_lsu_flush",
	.event = "event=0xd180",
	.desc = "Flush: (marked) : All Cases",
	.topic = "other",
	.long_desc = "Flush: (marked) : All Cases42",
},
{
	.name = "pm_mrk_lsu_flush_lrq",
	.event = "event=0xd188",
	.desc = "Flush: (marked) LRQ",
	.topic = "other",
	.long_desc = "Flush: (marked) LRQMarked LRQ flushes",
},
{
	.name = "pm_mrk_lsu_flush_srq",
	.event = "event=0xd18a",
	.desc = "Flush: (marked) SRQ",
	.topic = "other",
	.long_desc = "Flush: (marked) SRQMarked SRQ lhs flushes",
},
{
	.name = "pm_mrk_lsu_flush_uld",
	.event = "event=0xd184",
	.desc = "Flush: (marked) Unaligned Load",
	.topic = "other",
	.long_desc = "Flush: (marked) Unaligned LoadMarked unaligned load flushes",
},
{
	.name = "pm_mrk_lsu_flush_ust",
	.event = "event=0xd186",
	.desc = "Flush: (marked) Unaligned Store",
	.topic = "other",
	.long_desc = "Flush: (marked) Unaligned StoreMarked unaligned store flushes",
},
{
	.name = "pm_mrk_lsu_reject",
	.event = "event=0x40164",
	.desc = "LSU marked reject (up to 2 per cycle)",
	.topic = "other",
},
{
	.name = "pm_mrk_lsu_reject_erat_miss",
	.event = "event=0x30164",
	.desc = "LSU marked reject due to ERAT (up to 2 per cycle)",
	.topic = "other",
},
{
	.name = "pm_mrk_src_pref_track_eff",
	.event = "event=0x1d15a",
	.desc = "Marked src pref track was effective",
	.topic = "other",
},
{
	.name = "pm_mrk_src_pref_track_ineff",
	.event = "event=0x3d15a",
	.desc = "Prefetch tracked was ineffective for marked src",
	.topic = "other",
},
{
	.name = "pm_mrk_src_pref_track_mod",
	.event = "event=0x4d15c",
	.desc = "Prefetch tracked was moderate for marked src",
	.topic = "other",
},
{
	.name = "pm_mrk_src_pref_track_mod_l2",
	.event = "event=0x1d15c",
	.desc = "Marked src Prefetch Tracked was moderate (source L2)",
	.topic = "other",
},
{
	.name = "pm_mrk_src_pref_track_mod_l3",
	.event = "event=0x3d15c",
	.desc = "Prefetch tracked was moderate (L3 hit) for marked src",
	.topic = "other",
},
{
	.name = "pm_mrk_tgt_pref_track_eff",
	.event = "event=0x1c15a",
	.desc = "Marked target pref track was effective",
	.topic = "other",
},
{
	.name = "pm_mrk_tgt_pref_track_ineff",
	.event = "event=0x3c15a",
	.desc = "Prefetch tracked was ineffective for marked target",
	.topic = "other",
},
{
	.name = "pm_mrk_tgt_pref_track_mod",
	.event = "event=0x4c15c",
	.desc = "Prefetch tracked was moderate for marked target",
	.topic = "other",
},
{
	.name = "pm_mrk_tgt_pref_track_mod_l2",
	.event = "event=0x1c15c",
	.desc = "Marked target Prefetch Tracked was moderate (source L2)",
	.topic = "other",
},
{
	.name = "pm_mrk_tgt_pref_track_mod_l3",
	.event = "event=0x3c15c",
	.desc = "Prefetch tracked was moderate (L3 hit) for marked target",
	.topic = "other",
},
{
	.name = "pm_nested_tend",
	.event = "event=0x20b0",
	.desc = "Completion time nested tend",
	.topic = "other",
},
{
	.name = "pm_non_fav_tbegin",
	.event = "event=0x20b6",
	.desc = "Dispatch time non favored tbegin",
	.topic = "other",
},
{
	.name = "pm_non_tm_rst_sc",
	.event = "event=0x328084",
	.desc = "non tm snp rst tm sc",
	.topic = "other",
},
{
	.name = "pm_ntcg_all_fin",
	.event = "event=0x2001a",
	.desc = "Cycles after all instructions have finished to group completed",
	.topic = "other",
	.long_desc = "Ccycles after all instructions have finished to group completed",
},
{
	.name = "pm_outer_tbegin",
	.event = "event=0x20ac",
	.desc = "Completion time outer tbegin",
	.topic = "other",
},
{
	.name = "pm_outer_tend",
	.event = "event=0x20ae",
	.desc = "Completion time outer tend",
	.topic = "other",
},
{
	.name = "pm_pref_tracked",
	.event = "event=0x2005a",
	.desc = "Total number of Prefetch Operations that were tracked",
	.topic = "other",
},
{
	.name = "pm_pref_track_eff",
	.event = "event=0x1005a",
	.desc = "Prefetch Tracked was effective",
	.topic = "other",
},
{
	.name = "pm_pref_track_ineff",
	.event = "event=0x3005a",
	.desc = "Prefetch tracked was ineffective",
	.topic = "other",
},
{
	.name = "pm_pref_track_mod",
	.event = "event=0x4005a",
	.desc = "Prefetch tracked was moderate",
	.topic = "other",
},
{
	.name = "pm_pref_track_mod_l2",
	.event = "event=0x1005c",
	.desc = "Prefetch Tracked was moderate (source L2)",
	.topic = "other",
},
{
	.name = "pm_pref_track_mod_l3",
	.event = "event=0x3005c",
	.desc = "Prefetch tracked was moderate (L3)",
	.topic = "other",
},
{
	.name = "pm_pte_prefetch",
	.event = "event=0xe084",
	.desc = "PTE prefetches",
	.topic = "other",
	.long_desc = "PTE prefetches42",
},
{
	.name = "pm_rc0_alloc",
	.event = "event=0x16081",
	.desc = "RC mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_rc0_busy",
	.event = "event=0x16080",
	.desc = "RC mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_rc_lifetime_exc_1024",
	.event = "event=0x200301ea",
	.desc = "Number of times the RC machine for a sampled instruction was active for more than 1024 cycles",
	.topic = "other",
	.long_desc = "Reload latency exceeded 1024 cyc",
},
{
	.name = "pm_rc_lifetime_exc_2048",
	.event = "event=0x200401ec",
	.desc = "Number of times the RC machine for a sampled instruction was active for more than 2048 cycles",
	.topic = "other",
	.long_desc = "Threshold counter exceeded a value of 2048",
},
{
	.name = "pm_rc_lifetime_exc_256",
	.event = "event=0x200101e8",
	.desc = "Number of times the RC machine for a sampled instruction was active for more than 256 cycles",
	.topic = "other",
	.long_desc = "Threshold counter exceed a count of 256",
},
{
	.name = "pm_rc_lifetime_exc_32",
	.event = "event=0x200201e6",
	.desc = "Number of times the RC machine for a sampled instruction was active for more than 32 cycles",
	.topic = "other",
	.long_desc = "Reload latency exceeded 32 cyc",
},
{
	.name = "pm_rc_usage",
	.event = "event=0x36088",
	.desc = "Continuous 16 cycle(2to1) window where this signals rotates thru sampling each L2 RC machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_rd_clearing_sc",
	.event = "event=0x34808e",
	.desc = "rd clearing sc",
	.topic = "other",
},
{
	.name = "pm_rd_forming_sc",
	.event = "event=0x34808c",
	.desc = "rd forming sc",
	.topic = "other",
},
{
	.name = "pm_rd_hit_pf",
	.event = "event=0x428086",
	.desc = "rd machine hit l3 pf machine",
	.topic = "other",
},
{
	.name = "pm_real_srq_full",
	.event = "event=0x20004",
	.desc = "Out of real srq entries",
	.topic = "other",
},
{
	.name = "pm_run_cyc_smt2_shrd_mode",
	.event = "event=0x2006a",
	.desc = "cycles this threads run latch is set and the core is in SMT2 shared mode",
	.topic = "other",
	.long_desc = "Cycles run latch is set and core is in SMT2-shared mode",
},
{
	.name = "pm_run_cyc_smt2_split_mode",
	.event = "event=0x1006a",
	.desc = "Cycles run latch is set and core is in SMT2-split mode",
	.topic = "other",
},
{
	.name = "pm_run_cyc_smt8_mode",
	.event = "event=0x4006c",
	.desc = "Cycles run latch is set and core is in SMT8 mode",
	.topic = "other",
},
{
	.name = "pm_sec_erat_hit",
	.event = "event=0xf082",
	.desc = "secondary ERAT Hit",
	.topic = "other",
	.long_desc = "secondary ERAT Hit42",
},
{
	.name = "pm_shl_created",
	.event = "event=0x508c",
	.desc = "Store-Hit-Load Table Entry Created",
	.topic = "other",
},
{
	.name = "pm_shl_st_convert",
	.event = "event=0x508e",
	.desc = "Store-Hit-Load Table Read Hit with entry Enabled",
	.topic = "other",
},
{
	.name = "pm_shl_st_disable",
	.event = "event=0x5090",
	.desc = "Store-Hit-Load Table Read Hit with entry Disabled (entry was disabled due to the entry shown to not prevent the flush)",
	.topic = "other",
},
{
	.name = "pm_sn0_alloc",
	.event = "event=0x26085",
	.desc = "SN mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
	.long_desc = "0.0",
},
{
	.name = "pm_sn0_busy",
	.event = "event=0x26084",
	.desc = "SN mach 0 Busy. Used by PMU to sample ave RC livetime(mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_snoop_tlbie",
	.event = "event=0xd0b2",
	.desc = "TLBIE snoop",
	.topic = "other",
	.long_desc = "TLBIE snoopSnoop TLBIE",
},
{
	.name = "pm_snp_tm_hit_m",
	.event = "event=0x338088",
	.desc = "snp tm st hit m mu",
	.topic = "other",
},
{
	.name = "pm_snp_tm_hit_t",
	.event = "event=0x33808a",
	.desc = "snp tm_st_hit t tn te",
	.topic = "other",
},
{
	.name = "pm_sn_usage",
	.event = "event=0x4608c",
	.desc = "Continuous 16 cycle(2to1) window where this signals rotates thru sampling each L2 SN machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_stall_end_gct_empty",
	.event = "event=0x10028",
	.desc = "Count ended because GCT went empty",
	.topic = "other",
},
{
	.name = "pm_stcx_lsu",
	.event = "event=0xc090",
	.desc = "STCX executed reported at sent to nest",
	.topic = "other",
	.long_desc = "STCX executed reported at sent to nest42",
},
{
	.name = "pm_st_caused_fail",
	.event = "event=0x717080",
	.desc = "Non TM St caused any thread to fail",
	.topic = "other",
},
{
	.name = "pm_swap_cancel",
	.event = "event=0x3090",
	.desc = "SWAP cancel , rtag not available",
	.topic = "other",
},
{
	.name = "pm_swap_cancel_gpr",
	.event = "event=0x3092",
	.desc = "SWAP cancel , rtag not available for gpr",
	.topic = "other",
},
{
	.name = "pm_swap_complete",
	.event = "event=0x308c",
	.desc = "swap cast in completed",
	.topic = "other",
},
{
	.name = "pm_swap_complete_gpr",
	.event = "event=0x308e",
	.desc = "swap cast in completed fpr gpr",
	.topic = "other",
},
{
	.name = "pm_tablewalk_cyc_pref",
	.event = "event=0xe086",
	.desc = "tablewalk qualified for pte prefetches",
	.topic = "other",
	.long_desc = "tablewalk qualified for pte prefetches42",
},
{
	.name = "pm_tabort_treclaim",
	.event = "event=0x20b2",
	.desc = "Completion time tabortnoncd, tabortcd, treclaim",
	.topic = "other",
},
{
	.name = "pm_tend_pend_cyc",
	.event = "event=0xe0ba",
	.desc = "TEND latency per thread",
	.topic = "other",
	.long_desc = "TEND latency per thread42",
},
{
	.name = "pm_thrd_grp_cmpl_both_cyc",
	.event = "event=0x10012",
	.desc = "Cycles group completed on both completion slots by any thread",
	.topic = "other",
	.long_desc = "Two threads finished same cycle (gated by run latch)",
},
{
	.name = "pm_thrd_prio_0_1_cyc",
	.event = "event=0x40bc",
	.desc = "Cycles thread running at priority level 0 or 1",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_2_3_cyc",
	.event = "event=0x40be",
	.desc = "Cycles thread running at priority level 2 or 3",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_4_5_cyc",
	.event = "event=0x5080",
	.desc = "Cycles thread running at priority level 4 or 5",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_6_7_cyc",
	.event = "event=0x5082",
	.desc = "Cycles thread running at priority level 6 or 7",
	.topic = "other",
},
{
	.name = "pm_thrd_rebal_cyc",
	.event = "event=0x3098",
	.desc = "cycles rebalance was active",
	.topic = "other",
},
{
	.name = "pm_tm_begin_all",
	.event = "event=0x20b8",
	.desc = "Tm any tbegin",
	.topic = "other",
},
{
	.name = "pm_tm_cam_overflow",
	.event = "event=0x318082",
	.desc = "l3 tm cam overflow during L2 co of SC",
	.topic = "other",
},
{
	.name = "pm_tm_cap_overflow",
	.event = "event=0x74708c",
	.desc = "TM Footprint Capactiy Overflow",
	.topic = "other",
},
{
	.name = "pm_tm_end_all",
	.event = "event=0x20ba",
	.desc = "Tm any tend",
	.topic = "other",
},
{
	.name = "pm_tm_fail_conf_non_tm",
	.event = "event=0x3086",
	.desc = "TEXAS fail reason @ completion",
	.topic = "other",
},
{
	.name = "pm_tm_fail_con_tm",
	.event = "event=0x3088",
	.desc = "TEXAS fail reason @ completion",
	.topic = "other",
},
{
	.name = "pm_tm_fail_disallow",
	.event = "event=0xe0b2",
	.desc = "TM fail disallow",
	.topic = "other",
	.long_desc = "TM fail disallow42",
},
{
	.name = "pm_tm_fail_footprint_overflow",
	.event = "event=0x3084",
	.desc = "TEXAS fail reason @ completion",
	.topic = "other",
},
{
	.name = "pm_tm_fail_non_tx_conflict",
	.event = "event=0xe0b8",
	.desc = "Non transactional conflict from LSU whtver gets repoted to texas",
	.topic = "other",
	.long_desc = "Non transactional conflict from LSU whtver gets repoted to texas42",
},
{
	.name = "pm_tm_fail_self",
	.event = "event=0x308a",
	.desc = "TEXAS fail reason @ completion",
	.topic = "other",
},
{
	.name = "pm_tm_fail_tlbie",
	.event = "event=0xe0b4",
	.desc = "TLBIE hit bloom filter",
	.topic = "other",
	.long_desc = "TLBIE hit bloom filter42",
},
{
	.name = "pm_tm_fail_tx_conflict",
	.event = "event=0xe0b6",
	.desc = "Transactional conflict from LSU, whatever gets reported to texas",
	.topic = "other",
	.long_desc = "Transactional conflict from LSU, whatever gets reported to texas 42",
},
{
	.name = "pm_tm_fav_caused_fail",
	.event = "event=0x727086",
	.desc = "TM Load (fav) caused another thread to fail",
	.topic = "other",
},
{
	.name = "pm_tm_ld_caused_fail",
	.event = "event=0x717082",
	.desc = "Non TM Ld caused any thread to fail",
	.topic = "other",
},
{
	.name = "pm_tm_ld_conf",
	.event = "event=0x727084",
	.desc = "TM Load (fav or non-fav) ran into conflict (failed)",
	.topic = "other",
},
{
	.name = "pm_tm_rst_sc",
	.event = "event=0x328086",
	.desc = "tm snp rst tm sc",
	.topic = "other",
},
{
	.name = "pm_tm_sc_co",
	.event = "event=0x318080",
	.desc = "l3 castout tm Sc line",
	.topic = "other",
},
{
	.name = "pm_tm_st_caused_fail",
	.event = "event=0x73708a",
	.desc = "TM Store (fav or non-fav) caused another thread to fail",
	.topic = "other",
},
{
	.name = "pm_tm_st_conf",
	.event = "event=0x737088",
	.desc = "TM Store (fav or non-fav) ran into conflict (failed)",
	.topic = "other",
},
{
	.name = "pm_tm_tbegin",
	.event = "event=0x20bc",
	.desc = "Tm nested tbegin",
	.topic = "other",
},
{
	.name = "pm_tm_tresume",
	.event = "event=0x3080",
	.desc = "Tm resume",
	.topic = "other",
},
{
	.name = "pm_tm_tsuspend",
	.event = "event=0x20be",
	.desc = "Tm suspend",
	.topic = "other",
},
{
	.name = "pm_up_pref_l3",
	.event = "event=0xe08c",
	.desc = "Micropartition prefetch",
	.topic = "other",
	.long_desc = "Micropartition prefetch42",
},
{
	.name = "pm_up_pref_pointer",
	.event = "event=0xe08e",
	.desc = "Micrpartition pointer prefetches",
	.topic = "other",
	.long_desc = "Micrpartition pointer prefetches42",
},
{
	.name = "pm_vsu0_16flop",
	.event = "event=0xa0a4",
	.desc = "Sixteen flops operation (SP vector versions of fdiv,fsqrt)",
	.topic = "other",
},
{
	.name = "pm_vsu0_1flop",
	.event = "event=0xa080",
	.desc = "one flop (fadd, fmul, fsub, fcmp, fsel, fabs, fnabs, fres, fsqrte, fneg) operation finished",
	.topic = "other",
	.long_desc = "one flop (fadd, fmul, fsub, fcmp, fsel, fabs, fnabs, fres, fsqrte, fneg) operation finishedDecode into 1,2,4 FLOP according to instr IOP, multiplied by #vector elements according to route( eg x1, x2, x4) Only if instr sends finish to ISU",
},
{
	.name = "pm_vsu0_2flop",
	.event = "event=0xa098",
	.desc = "two flops operation (scalar fmadd, fnmadd, fmsub, fnmsub and DP vector versions of single flop instructions)",
	.topic = "other",
},
{
	.name = "pm_vsu0_4flop",
	.event = "event=0xa09c",
	.desc = "four flops operation (scalar fdiv, fsqrt, DP vector version of fmadd, fnmadd, fmsub, fnmsub, SP vector versions of single flop instructions)",
	.topic = "other",
},
{
	.name = "pm_vsu0_8flop",
	.event = "event=0xa0a0",
	.desc = "eight flops operation (DP vector versions of fdiv,fsqrt and SP vector versions of fmadd,fnmadd,fmsub,fnmsub)",
	.topic = "other",
},
{
	.name = "pm_vsu0_complex_issued",
	.event = "event=0xb0a4",
	.desc = "Complex VMX instruction issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_cy_issued",
	.event = "event=0xb0b4",
	.desc = "Cryptographic instruction RFC02196 Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_dd_issued",
	.event = "event=0xb0a8",
	.desc = "64BIT Decimal Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_dp_2flop",
	.event = "event=0xa08c",
	.desc = "DP vector version of fmul, fsub, fcmp, fsel, fabs, fnabs, fres ,fsqrte, fneg",
	.topic = "other",
},
{
	.name = "pm_vsu0_dp_fma",
	.event = "event=0xa090",
	.desc = "DP vector version of fmadd,fnmadd,fmsub,fnmsub",
	.topic = "other",
},
{
	.name = "pm_vsu0_dp_fsqrt_fdiv",
	.event = "event=0xa094",
	.desc = "DP vector versions of fdiv,fsqrt",
	.topic = "other",
},
{
	.name = "pm_vsu0_dq_issued",
	.event = "event=0xb0ac",
	.desc = "128BIT Decimal Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_ex_issued",
	.event = "event=0xb0b0",
	.desc = "Direct move 32/64b VRFtoGPR RFC02206 Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_fin",
	.event = "event=0xa0bc",
	.desc = "VSU0 Finished an instruction",
	.topic = "other",
},
{
	.name = "pm_vsu0_fma",
	.event = "event=0xa084",
	.desc = "two flops operation (fmadd, fnmadd, fmsub, fnmsub) Scalar instructions only!",
	.topic = "other",
},
{
	.name = "pm_vsu0_fpscr",
	.event = "event=0xb098",
	.desc = "Move to/from FPSCR type instruction issued on Pipe 0",
	.topic = "other",
},
{
	.name = "pm_vsu0_fsqrt_fdiv",
	.event = "event=0xa088",
	.desc = "four flops operation (fdiv,fsqrt) Scalar Instructions only!",
	.topic = "other",
},
{
	.name = "pm_vsu0_permute_issued",
	.event = "event=0xb090",
	.desc = "Permute VMX Instruction Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_scalar_dp_issued",
	.event = "event=0xb088",
	.desc = "Double Precision scalar instruction issued on Pipe0",
	.topic = "other",
},
{
	.name = "pm_vsu0_simple_issued",
	.event = "event=0xb094",
	.desc = "Simple VMX instruction issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_single",
	.event = "event=0xa0a8",
	.desc = "FPU single precision",
	.topic = "other",
},
{
	.name = "pm_vsu0_sq",
	.event = "event=0xb09c",
	.desc = "Store Vector Issued",
	.topic = "other",
},
{
	.name = "pm_vsu0_stf",
	.event = "event=0xb08c",
	.desc = "FPU store (SP or DP) issued on Pipe0",
	.topic = "other",
},
{
	.name = "pm_vsu0_vector_dp_issued",
	.event = "event=0xb080",
	.desc = "Double Precision vector instruction issued on Pipe0",
	.topic = "other",
},
{
	.name = "pm_vsu0_vector_sp_issued",
	.event = "event=0xb084",
	.desc = "Single Precision vector instruction issued (executed)",
	.topic = "other",
},
{
	.name = "pm_vsu1_16flop",
	.event = "event=0xa0a6",
	.desc = "Sixteen flops operation (SP vector versions of fdiv,fsqrt)",
	.topic = "other",
},
{
	.name = "pm_vsu1_1flop",
	.event = "event=0xa082",
	.desc = "one flop (fadd, fmul, fsub, fcmp, fsel, fabs, fnabs, fres, fsqrte, fneg) operation finished",
	.topic = "other",
},
{
	.name = "pm_vsu1_2flop",
	.event = "event=0xa09a",
	.desc = "two flops operation (scalar fmadd, fnmadd, fmsub, fnmsub and DP vector versions of single flop instructions)",
	.topic = "other",
},
{
	.name = "pm_vsu1_4flop",
	.event = "event=0xa09e",
	.desc = "four flops operation (scalar fdiv, fsqrt, DP vector version of fmadd, fnmadd, fmsub, fnmsub, SP vector versions of single flop instructions)",
	.topic = "other",
},
{
	.name = "pm_vsu1_8flop",
	.event = "event=0xa0a2",
	.desc = "eight flops operation (DP vector versions of fdiv,fsqrt and SP vector versions of fmadd,fnmadd,fmsub,fnmsub)",
	.topic = "other",
},
{
	.name = "pm_vsu1_complex_issued",
	.event = "event=0xb0a6",
	.desc = "Complex VMX instruction issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_cy_issued",
	.event = "event=0xb0b6",
	.desc = "Cryptographic instruction RFC02196 Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_dd_issued",
	.event = "event=0xb0aa",
	.desc = "64BIT Decimal Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_dp_2flop",
	.event = "event=0xa08e",
	.desc = "DP vector version of fmul, fsub, fcmp, fsel, fabs, fnabs, fres ,fsqrte, fneg",
	.topic = "other",
},
{
	.name = "pm_vsu1_dp_fma",
	.event = "event=0xa092",
	.desc = "DP vector version of fmadd,fnmadd,fmsub,fnmsub",
	.topic = "other",
},
{
	.name = "pm_vsu1_dp_fsqrt_fdiv",
	.event = "event=0xa096",
	.desc = "DP vector versions of fdiv,fsqrt",
	.topic = "other",
},
{
	.name = "pm_vsu1_dq_issued",
	.event = "event=0xb0ae",
	.desc = "128BIT Decimal Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_ex_issued",
	.event = "event=0xb0b2",
	.desc = "Direct move 32/64b VRFtoGPR RFC02206 Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_fin",
	.event = "event=0xa0be",
	.desc = "VSU1 Finished an instruction",
	.topic = "other",
},
{
	.name = "pm_vsu1_fma",
	.event = "event=0xa086",
	.desc = "two flops operation (fmadd, fnmadd, fmsub, fnmsub) Scalar instructions only!",
	.topic = "other",
},
{
	.name = "pm_vsu1_fpscr",
	.event = "event=0xb09a",
	.desc = "Move to/from FPSCR type instruction issued on Pipe 0",
	.topic = "other",
},
{
	.name = "pm_vsu1_fsqrt_fdiv",
	.event = "event=0xa08a",
	.desc = "four flops operation (fdiv,fsqrt) Scalar Instructions only!",
	.topic = "other",
},
{
	.name = "pm_vsu1_permute_issued",
	.event = "event=0xb092",
	.desc = "Permute VMX Instruction Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_scalar_dp_issued",
	.event = "event=0xb08a",
	.desc = "Double Precision scalar instruction issued on Pipe1",
	.topic = "other",
},
{
	.name = "pm_vsu1_simple_issued",
	.event = "event=0xb096",
	.desc = "Simple VMX instruction issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_single",
	.event = "event=0xa0aa",
	.desc = "FPU single precision",
	.topic = "other",
},
{
	.name = "pm_vsu1_sq",
	.event = "event=0xb09e",
	.desc = "Store Vector Issued",
	.topic = "other",
},
{
	.name = "pm_vsu1_stf",
	.event = "event=0xb08e",
	.desc = "FPU store (SP or DP) issued on Pipe1",
	.topic = "other",
},
{
	.name = "pm_vsu1_vector_dp_issued",
	.event = "event=0xb082",
	.desc = "Double Precision vector instruction issued on Pipe1",
	.topic = "other",
},
{
	.name = "pm_vsu1_vector_sp_issued",
	.event = "event=0xb086",
	.desc = "Single Precision vector instruction issued (executed)",
	.topic = "other",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_power9[] = {
{
	.name = "pm_cyc",
	.event = "event=0x1e",
	.desc = "Processor cycles",
	.topic = "translation",
},
{
	.name = "pm_pmc2_overflow",
	.event = "event=0x30010",
	.desc = "Overflow from counter 2",
	.topic = "translation",
},
{
	.name = "pm_data_from_l21_shr",
	.event = "event=0x3c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to a demand load",
	.topic = "translation",
},
{
	.name = "pm_dp_qp_flop_cmpl",
	.event = "event=0x4d05c",
	.desc = "Double-Precion or Quad-Precision instruction completed",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dmem",
	.event = "event=0x4e04c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "translation",
},
{
	.name = "pm_st_fin",
	.event = "event=0x20016",
	.desc = "Store finish count. Includes speculative activity",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l3",
	.event = "event=0x44042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_rl2l3_shr",
	.event = "event=0x1504a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_mrk_lsu_fin",
	.event = "event=0x40132",
	.desc = "lsu marked instr PPC finish",
	.topic = "translation",
},
{
	.name = "pm_cmplu_stall_vfxu",
	.event = "event=0x3c05c",
	.desc = "Finish stall due to a vector fixed point instruction in the execution pipeline. These instructions get routed to the ALU, ALU2, and DIV pipes",
	.topic = "translation",
},
{
	.name = "pm_lsu_fin",
	.event = "event=0x30066",
	.desc = "LSU Finished a PPC instruction (up to 4 per cycle)",
	.topic = "translation",
},
{
	.name = "pm_mrk_ntc_cyc",
	.event = "event=0x2011c",
	.desc = "Cycles during which the marked instruction is next to complete (completion is held up because the marked instruction hasn't completed yet)",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dl2l3_shr",
	.event = "event=0x3e048",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "translation",
},
{
	.name = "pm_cmplu_stall_vfxlong",
	.event = "event=0x2e018",
	.desc = "Completion stall due to a long latency vector fixed point instruction (division, square root)",
	.topic = "translation",
},
{
	.name = "pm_data_from_l2miss_mod",
	.event = "event=0x1c04e",
	.desc = "The processor's data cache was reloaded from a location other than the local core's L2 due to a demand load",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_on_chip_cache",
	.event = "event=0x15048",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l21_shr",
	.event = "event=0x34046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L2 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_stcx_fail",
	.event = "event=0x1e058",
	.desc = "stcx failed",
	.topic = "translation",
},
{
	.name = "pm_st_miss_l1",
	.event = "event=0x300f0",
	.desc = "Store Missed L1",
	.topic = "translation",
},
{
	.name = "pm_data_from_l21_mod",
	.event = "event=0x4c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to a demand load",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_rl4",
	.event = "event=0x2504a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_lsu_lmq_srq_empty_cyc",
	.event = "event=0x2003e",
	.desc = "Cycles in which the LSU is empty for all threads (lmq and srq are completely empty)",
	.topic = "translation",
},
{
	.name = "pm_thresh_exc_32",
	.event = "event=0x201e6",
	.desc = "Threshold counter exceeded a value of 32",
	.topic = "translation",
},
{
	.name = "pm_cmplu_stall_vdp",
	.event = "event=0x4405c",
	.desc = "Finish stall because the NTF instruction was a vector instruction issued to the Double Precision execution pipe and waiting to finish. Includes binary floating point instructions in 32 and 64 bit binary floating point format. Not qualified multicycle. Qualified by vector",
	.topic = "translation",
},
{
	.name = "pm_pmc1_saved",
	.event = "event=0x4d010",
	.desc = "PMC1 Rewind Value saved",
	.topic = "translation",
},
{
	.name = "pm_data_from_l2miss",
	.event = "event=0x200fe",
	.desc = "Demand LD - L2 Miss (not L2 hit)",
	.topic = "translation",
},
{
	.name = "pm_mrk_data_from_rl2l3_mod_cyc",
	.event = "event=0x2d14a",
	.desc = "Duration in cycles to reload with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "translation",
},
{
	.name = "pm_stall_end_ict_empty",
	.event = "event=0x10028",
	.desc = "The number a times the core transitioned from a stall to ICT-empty for this thread",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_memory",
	.event = "event=0x2504c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_off_chip_cache",
	.event = "event=0x4504a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l2miss",
	.event = "event=0x1404e",
	.desc = "The processor's Instruction cache was reloaded from a location other than the local core's L2 due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l3_disp_conflict",
	.event = "event=0x34042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 with dispatch conflict due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dl2l3_mod",
	.event = "event=0x4e048",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "translation",
},
{
	.name = "pm_st_cmpl",
	.event = "event=0x200f0",
	.desc = "Stores completed from S2Q (2nd-level store queue)",
	.topic = "translation",
},
{
	.name = "pm_lsu_reject_lhs",
	.event = "event=0x4e05c",
	.desc = "LSU Reject due to LHS (up to 4 per cycle)",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l3_no_conflict",
	.event = "event=0x14044",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without conflict due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_dpteg_from_dl4",
	.event = "event=0x3e04c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "translation",
},
{
	.name = "pm_mrk_probe_nop_cmpl",
	.event = "event=0x1f15e",
	.desc = "Marked probeNops completed",
	.topic = "translation",
},
{
	.name = "pm_st_fwd",
	.event = "event=0x20018",
	.desc = "Store forwards that finished",
	.topic = "translation",
},
{
	.name = "pm_mrk_data_from_l31_eco_shr_cyc",
	.event = "event=0x1d142",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "translation",
},
{
	.name = "pm_inst_from_l3_mepf",
	.event = "event=0x24042",
	.desc = "The processor's Instruction cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to an instruction fetch (not prefetch)",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_rl2l3_mod",
	.event = "event=0x25046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_ipteg_from_rmem",
	.event = "event=0x3504a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a instruction side request",
	.topic = "translation",
},
{
	.name = "pm_cmplu_stall_vdplong",
	.event = "event=0x3c05a",
	.desc = "Finish stall because the NTF instruction was a scalar multi-cycle instruction issued to the Double Precision execution pipe and waiting to finish. Includes binary floating point instructions in 32 and 64 bit binary floating point format. Qualified by NOT vector AND multicycle",
	.topic = "translation",
},
{
	.name = "pm_cmplu_stall_tlbie",
	.event = "event=0x2e01c",
	.desc = "Finish stall because the NTF instruction was a tlbie waiting for response from L2",
	.topic = "translation",
},
{
	.name = "pm_nest_ref_clk",
	.event = "event=0x3006e",
	.desc = "Multiply by 4 to obtain the number of PB cycles",
	.topic = "memory",
},
{
	.name = "pm_pmc1_overflow",
	.event = "event=0x20010",
	.desc = "Overflow from counter 1",
	.topic = "memory",
},
{
	.name = "pm_darq1_7_9_entries",
	.event = "event=0x2005a",
	.desc = "Cycles in which 7 to 9 DARQ1 entries (out of 12) are in use",
	.topic = "memory",
},
{
	.name = "pm_data_from_dl2l3_shr",
	.event = "event=0x3c048",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_run_spurr",
	.event = "event=0x10008",
	.desc = "Run SPURR",
	.topic = "memory",
},
{
	.name = "pm_lsu_derat_miss",
	.event = "event=0x200f6",
	.desc = "DERAT Reloaded due to a DERAT miss",
	.topic = "memory",
},
{
	.name = "pm_data_from_dl2l3_mod",
	.event = "event=0x4c048",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_mrk_run_cyc",
	.event = "event=0x1d15e",
	.desc = "Run cycles in which a marked instruction is in the pipeline",
	.topic = "memory",
},
{
	.name = "pm_ld_cmpl",
	.event = "event=0x4003e",
	.desc = "count of Loads completed",
	.topic = "memory",
},
{
	.name = "pm_mrk_dtlb_miss_4k",
	.event = "event=0x2d156",
	.desc = "Marked Data TLB Miss page size 4k",
	.topic = "memory",
},
{
	.name = "pm_data_from_l3",
	.event = "event=0x4c042",
	.desc = "The processor's data cache was reloaded from local core's L3 due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_pmc1_rewind",
	.event = "event=0x4d02c",
	.desc = "",
	.topic = "memory",
},
{
	.name = "pm_sync_mrk_l2hit",
	.event = "event=0x15158",
	.desc = "Marked L2 Hits that can throw a synchronous interrupt",
	.topic = "memory",
},
{
	.name = "pm_inst_from_rmem",
	.event = "event=0x3404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to an instruction fetch (not prefetch)",
	.topic = "memory",
},
{
	.name = "pm_mrk_st_cmpl",
	.event = "event=0x301e2",
	.desc = "Marked store completed and sent to nest",
	.topic = "memory",
},
{
	.name = "pm_data_chip_pump_cpred",
	.event = "event=0x1c050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for a demand load",
	.topic = "memory",
},
{
	.name = "pm_data_from_l2_disp_conflict_other",
	.event = "event=0x4c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_lsu_reject_erat_miss",
	.event = "event=0x2e05c",
	.desc = "LSU Reject due to ERAT (up to 4 per cycles)",
	.topic = "memory",
},
{
	.name = "pm_pmc3_rewind",
	.event = "event=0x1000a",
	.desc = "PMC3 rewind event. A rewind happens when a speculative event (such as latency or CPI stack) is selected on PMC3 and the stall reason or reload source did not match the one programmed in PMC3. When this occurs, the count in PMC3 will not change",
	.topic = "memory",
},
{
	.name = "pm_larx_fin",
	.event = "event=0x3c058",
	.desc = "Larx finished",
	.topic = "memory",
},
{
	.name = "pm_data_from_l2_no_conflict",
	.event = "event=0x1c040",
	.desc = "The processor's data cache was reloaded from local core's L2 without conflict due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_data_from_l2_mepf",
	.event = "event=0x2c040",
	.desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state due to a demand load",
	.topic = "memory",
},
{
	.name = "pm_lrq_reject",
	.event = "event=0x2e05a",
	.desc = "Internal LSU reject from LRQ. Rejects cause the load to go back to LRQ, but it stays contained within the LSU once it gets issued. This event counts the number of times the LRQ attempts to relaunch an instruction after a reject. Any load can suffer multiple rejects",
	.topic = "memory",
},
{
	.name = "pm_inst_grp_pump_cpred",
	.event = "event=0x2c05c",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for an instruction fetch (demand only)",
	.topic = "memory",
},
{
	.name = "pm_non_fma_flop_cmpl",
	.event = "event=0x4d056",
	.desc = "Non FMA instruction completed",
	.topic = "memory",
},
{
	.name = "pm_darq1_4_6_entries",
	.event = "event=0x3e050",
	.desc = "Cycles in which 4, 5, or 6 DARQ1 entries (out of 12) are in use",
	.topic = "memory",
},
{
	.name = "pm_thrd_conc_run_inst",
	.event = "event=0x300f4",
	.desc = "PPC Instructions Finished by this thread when all threads in the core had the run-latch set",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_flush_any_thread",
	.event = "event=0x1e056",
	.desc = "Cycles in which the NTC instruction is not allowed to complete because any of the 4 threads in the same core suffered a flush, which blocks completion",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_fxlong",
	.event = "event=0x4d016",
	.desc = "Completion stall due to a long latency scalar fixed point instruction (division, square root)",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_fxu",
	.event = "event=0x2d016",
	.desc = "Finish stall due to a scalar fixed point or CR instruction in the execution pipeline. These instructions get routed to the ALU, ALU2, and DIV pipes",
	.topic = "cache",
},
{
	.name = "pm_mrk_dtlb_miss_1g",
	.event = "event=0x1d15c",
	.desc = "Marked Data TLB reload (after a miss) page size 2M. Implies radix translation was used",
	.topic = "cache",
},
{
	.name = "pm_mrk_data_from_rl4_cyc",
	.event = "event=0x4d12a",
	.desc = "Duration in cycles to reload from another chip's L4 on the same Node or Group ( Remote) due to a marked load",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_dmiss_l2l3",
	.event = "event=0x1003c",
	.desc = "Completion stall by Dcache miss which resolved in L2/L3",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_lmq_full",
	.event = "event=0x4c014",
	.desc = "Finish stall because the NTF instruction was a load that missed in the L1 and the LMQ was unable to accept this load miss request because it was full",
	.topic = "cache",
},
{
	.name = "pm_inst_from_on_chip_cache",
	.event = "event=0x14048",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_load_finish",
	.event = "event=0x4d014",
	.desc = "Finish stall because the NTF instruction was a load instruction with all its dependencies satisfied just going through the LSU pipe to finish",
	.topic = "cache",
},
{
	.name = "pm_inst_from_rl4",
	.event = "event=0x2404a",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to an instruction fetch (not prefetch)",
	.topic = "cache",
},
{
	.name = "pm_inst_from_rl2l3_shr",
	.event = "event=0x1404a",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to an instruction fetch (not prefetch)",
	.topic = "cache",
},
{
	.name = "pm_thresh_exc_128",
	.event = "event=0x401ea",
	.desc = "Threshold counter exceeded a value of 128",
	.topic = "cache",
},
{
	.name = "pm_br_mpred_cmpl",
	.event = "event=0x400f6",
	.desc = "Number of Branch Mispredicts",
	.topic = "cache",
},
{
	.name = "pm_mrk_dpteg_from_l2_mepf",
	.event = "event=0x2f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "cache",
},
{
	.name = "pm_thresh_exc_4096",
	.event = "event=0x101e6",
	.desc = "Threshold counter exceed a count of 4096",
	.topic = "cache",
},
{
	.name = "pm_mrk_dtlb_miss_64k",
	.event = "event=0x3d156",
	.desc = "Marked Data TLB Miss page size 64K",
	.topic = "cache",
},
{
	.name = "pm_mrk_dtlb_miss_16m",
	.event = "event=0x4c15e",
	.desc = "Marked Data TLB Miss page size 16M",
	.topic = "cache",
},
{
	.name = "pm_mrk_dtlb_miss_16g",
	.event = "event=0x2d15e",
	.desc = "Marked Data TLB Miss page size 16G",
	.topic = "cache",
},
{
	.name = "pm_mrk_dpteg_from_rmem",
	.event = "event=0x3f14a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_dmiss_l2l3_conflict",
	.event = "event=0x4c016",
	.desc = "Completion stall due to cache miss that resolves in the L2 or L3 with a conflict",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_lhs",
	.event = "event=0x2c01a",
	.desc = "Finish stall because the NTF instruction was a load that hit on an older store and it was waiting for store data",
	.topic = "cache",
},
{
	.name = "pm_mrk_dtlb_miss",
	.event = "event=0x401e4",
	.desc = "Marked dtlb miss",
	.topic = "cache",
},
{
	.name = "pm_inst_from_rl2l3_mod",
	.event = "event=0x24046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to an instruction fetch (not prefetch)",
	.topic = "cache",
},
{
	.name = "pm_cmplu_stall_larx",
	.event = "event=0x1002a",
	.desc = "Finish stall because the NTF instruction was a larx waiting to be satisfied",
	.topic = "cache",
},
{
	.name = "pm_dtlb_miss_16g",
	.event = "event=0x1c058",
	.desc = "Data TLB Miss page size 16G",
	.topic = "cache",
},
{
	.name = "pm_mrk_stall_cmplu_cyc",
	.event = "event=0x3013e",
	.desc = "Number of cycles the marked instruction is experiencing a stall while it is next to complete (NTC)",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l1_pde_from_l3miss",
	.event = "event=0x4f056",
	.desc = "A Page Directory Entry was reloaded to a level 1 page walk cache from beyond the core's L3 data cache. The source could be local/remote/distant memory or another core's cache",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst",
	.event = "event=0x24158",
	.desc = "An instruction was marked. Includes both Random Instruction Sampling (RIS) at decode time and Random Event Sampling (RES) at the time the configured event happens",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_l31_shr",
	.event = "event=0x1e046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_data_from_rmem",
	.event = "event=0x3c04a",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_dmiss_remote",
	.event = "event=0x2c01c",
	.desc = "Completion stall by Dcache miss which resolved from remote chip (cache or memory)",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l2_disp_conflict_other",
	.event = "event=0x44040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with dispatch conflict due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_darq0_7_9_entries",
	.event = "event=0x2e050",
	.desc = "Cycles in which 7,8, or 9 DARQ entries (out of 12) are in use",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l3_pte_from_l2",
	.event = "event=0x2d02e",
	.desc = "A Page Table Entry was reloaded to a level 3 page walk cache from the core's L2 data cache. This implies that a level 4 PWC access was not necessary for this translation",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l3_pte_from_l3",
	.event = "event=0x3f05e",
	.desc = "A Page Table Entry was reloaded to a level 3 page walk cache from the core's L3 data cache. This implies that a level 4 PWC access was not necessary for this translation",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_ntc_flush",
	.event = "event=0x2e01e",
	.desc = "Completion stall due to ntc flush",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_ll4",
	.event = "event=0x1f14c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a marked data side request.. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_decoded",
	.event = "event=0x20130",
	.desc = "An instruction was marked at decode time. Random Instruction Sampling (RIS) only",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l31_eco_shr",
	.event = "event=0x3f144",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_vector_flop_cmpl",
	.event = "event=0x4d058",
	.desc = "Vector FP instruction completed",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l2_no_conflict",
	.event = "event=0x14040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 without conflict due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l3miss_mod",
	.event = "event=0x4404e",
	.desc = "The processor's Instruction cache was reloaded from a location other than the local core's L3 due to a instruction fetch",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_exception",
	.event = "event=0x3003a",
	.desc = "Cycles in which the NTC instruction is not allowed to complete because it was interrupted by ANY exception, which has to be serviced before the instruction can complete",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l31_eco_mod",
	.event = "event=0x4f144",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_l31_eco_shr",
	.event = "event=0x3e044",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_l1_dcache_reload_valid",
	.event = "event=0x300f6",
	.desc = "DL1 reloaded due to Demand Load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3miss_cyc",
	.event = "event=0x1415e",
	.desc = "Duration in cycles to reload from a location other than the local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_slb",
	.event = "event=0x1e052",
	.desc = "Finish stall because the NTF instruction was awaiting L2 response for an SLB",
	.topic = "marked",
},
{
	.name = "pm_inst_from_dmem",
	.event = "event=0x4404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's memory on the same Node or Group (Distant) due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_fxu_1plus_busy",
	.event = "event=0x3000e",
	.desc = "At least one of the 4 FXU units is busy",
	.topic = "marked",
},
{
	.name = "pm_data_from_lmem",
	.event = "event=0x2c048",
	.desc = "The processor's data cache was reloaded from the local chip's Memory due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_pm",
	.event = "event=0x3000a",
	.desc = "Finish stall because the NTF instruction was issued to the Permute execution pipe and waiting to finish. Includes permute and decimal fixed point instructions (128 bit BCD arithmetic) + a few 128 bit fixpoint add/subtract instructions with carry. Not qualified by vector or multicycle",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l2miss",
	.event = "event=0x1504e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L2 due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_data_grp_pump_mpred_rty",
	.event = "event=0x1c052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for a demand load",
	.topic = "marked",
},
{
	.name = "pm_disp_starved",
	.event = "event=0x30008",
	.desc = "Dispatched Starved",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l2",
	.event = "event=0x14042",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_freq_up",
	.event = "event=0x4000c",
	.desc = "Power Management: Above Threshold A",
	.topic = "marked",
},
{
	.name = "pm_data_sys_pump_cpred",
	.event = "event=0x3c050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for a demand load",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l2_mepf",
	.event = "event=0x25040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_issued",
	.event = "event=0x10132",
	.desc = "Marked instruction issued",
	.topic = "marked",
},
{
	.name = "pm_data_from_l31_shr",
	.event = "event=0x1c046",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_from_l31_mod",
	.event = "event=0x2c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_from_rl4",
	.event = "event=0x2c04a",
	.desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l31_mod",
	.event = "event=0x24044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_data_sys_pump_mpred_rty",
	.event = "event=0x4c050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_grp_pump_mpred",
	.event = "event=0x2c052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for a demand load",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_lmem",
	.event = "event=0x2f148",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_eieio",
	.event = "event=0x4d01a",
	.desc = "Finish stall because the NTF instruction is an EIEIO waiting for response from L2",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_l3miss",
	.event = "event=0x4f14e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L3 due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l4_pte_from_l3",
	.event = "event=0x4f05a",
	.desc = "A Page Table Entry was reloaded to a level 4 page walk cache from the core's L3 data cache. This is the deepest level of PWC possible for a translation",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l4_pte_from_l2",
	.event = "event=0x1f05a",
	.desc = "A Page Table Entry was reloaded to a level 4 page walk cache from the core's L2 data cache. This is the deepest level of PWC possible for a translation",
	.topic = "marked",
},
{
	.name = "pm_l1_icache_reloaded_pref",
	.event = "event=0x30068",
	.desc = "Counts all Icache prefetch reloads ( includes demand turned into prefetch)",
	.topic = "marked",
},
{
	.name = "pm_data_from_off_chip_cache",
	.event = "event=0x4c04a",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_from_memory",
	.event = "event=0x400fe",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l1_pde_from_l3",
	.event = "event=0x3f058",
	.desc = "A Page Directory Entry was reloaded to a level 1 page walk cache from the core's L3 data cache",
	.topic = "marked",
},
{
	.name = "pm_data_sys_pump_mpred",
	.event = "event=0x3c052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for a demand load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l3",
	.event = "event=0x4d142",
	.desc = "The processor's data cache was reloaded from local core's L3 due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_sys_pump_cpred",
	.event = "event=0x30050",
	.desc = "Initial and Final Pump Scope was system pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_spec_finish",
	.event = "event=0x30028",
	.desc = "Finish stall while waiting for the non-speculative finish of either a stcx waiting for its result or a load waiting for non-critical sectors of data and ECC",
	.topic = "marked",
},
{
	.name = "pm_run_purr",
	.event = "event=0x400f4",
	.desc = "Run_PURR",
	.topic = "marked",
},
{
	.name = "pm_inst_from_dl4",
	.event = "event=0x3404c",
	.desc = "The processor's Instruction cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_ntc_issue_held_other",
	.event = "event=0x3d05a",
	.desc = "The NTC instruction is being held at dispatch during regular pipeline cycles, or because the VSU is busy with multi-cycle instructions, or because of a write-back collision with VSU",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_lmem",
	.event = "event=0x2e048",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l3_pde_from_l2",
	.event = "event=0x2d02a",
	.desc = "A Page Directory Entry was reloaded to a level 3 page walk cache from the core's L2 data cache",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l3_pde_from_l3",
	.event = "event=0x1f05c",
	.desc = "A Page Directory Entry was reloaded to a level 3 page walk cache from the core's L3 data cache",
	.topic = "marked",
},
{
	.name = "pm_darq0_0_3_entries",
	.event = "event=0x4d04a",
	.desc = "Cycles in which 3 or less DARQ entries (out of 12) are in use",
	.topic = "marked",
},
{
	.name = "pm_inst_from_ll4",
	.event = "event=0x1404c",
	.desc = "The processor's Instruction cache was reloaded from the local chip's L4 cache due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_l1_icache_miss",
	.event = "event=0x200fd",
	.desc = "Demand iCache Miss",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l2_disp_conflict_ldhitst",
	.event = "event=0x34040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 with load hit store conflict due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_nest",
	.event = "event=0x20138",
	.desc = "Marked store sent to nest",
	.topic = "marked",
},
{
	.name = "pm_inst_from_dl2l3_mod",
	.event = "event=0x44048",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l21_shr",
	.event = "event=0x35046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_data_from_l3miss_mod",
	.event = "event=0x4c04e",
	.desc = "The processor's data cache was reloaded from a location other than the local core's L3 due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_cmpl",
	.event = "event=0x401e0",
	.desc = "marked instruction completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_dl2l3_shr_cyc",
	.event = "event=0x2c128",
	.desc = "Duration in cycles to reload with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l31_eco_shr",
	.event = "event=0x34044",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_ntc_disp_fin",
	.event = "event=0x4e018",
	.desc = "Finish stall because the NTF instruction was one that must finish at dispatch",
	.topic = "marked",
},
{
	.name = "pm_lmq_empty_cyc",
	.event = "event=0x2e05e",
	.desc = "Cycles in which the LMQ has no pending load misses for this thread",
	.topic = "marked",
},
{
	.name = "pm_darq1_0_3_entries",
	.event = "event=0x4c122",
	.desc = "Cycles in which 3 or fewer DARQ1 entries (out of 12) are in use",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l2_pte_from_l3",
	.event = "event=0x4f058",
	.desc = "A Page Table Entry was reloaded to a level 2 page walk cache from the core's L3 data cache. This implies that level 3 and level 4 PWC accesses were not necessary for this translation",
	.topic = "marked",
},
{
	.name = "pm_inst_from_l31_shr",
	.event = "event=0x14046",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another core's L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_fwd",
	.event = "event=0x3012c",
	.desc = "Marked st forwards",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_disp",
	.event = "event=0x101e0",
	.desc = "The thread has dispatched a randomly sampled marked instruction",
	.topic = "marked",
},
{
	.name = "pm_darq0_10_12_entries",
	.event = "event=0x1d058",
	.desc = "Cycles in which 10 or more DARQ entries (out of 12) are in use",
	.topic = "marked",
},
{
	.name = "pm_data_from_l3miss",
	.event = "event=0x300fe",
	.desc = "Demand LD - L3 Miss (not L2 hit and not L3 hit)",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_other_cmpl",
	.event = "event=0x30006",
	.desc = "Instructions the core completed while this tread was stalled",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_dp",
	.event = "event=0x1005c",
	.desc = "Finish stall because the NTF instruction was a scalar instruction issued to the Double Precision execution pipe and waiting to finish. Includes binary floating point instructions in 32 and 64 bit binary floating point format. Not qualified multicycle. Qualified by NOT vector",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_l2",
	.event = "event=0x1e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_cmpl",
	.event = "event=0x1016e",
	.desc = "Branch Instruction completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_bru_fin",
	.event = "event=0x2013a",
	.desc = "bru marked instr finish",
	.topic = "marked",
},
{
	.name = "pm_radix_pwc_l3_pte_from_l3miss",
	.event = "event=0x4f05e",
	.desc = "A Page Table Entry was reloaded to a level 3 page walk cache from beyond the core's L3 data cache. This implies that a level 4 PWC access was not necessary for this translation. The source could be local/remote/distant memory or another core's cache",
	.topic = "marked",
},
{
	.name = "pm_itlb_miss",
	.event = "event=0x400fc",
	.desc = "ITLB Reloaded. Counts 1 per ITLB miss for HPT but multiple for radix depending on number of levels traveresed",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_l3_no_conflict",
	.event = "event=0x1e044",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_non_math_flop_cmpl",
	.event = "event=0x4d05a",
	.desc = "Non FLOP operation completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_taken_cmpl",
	.event = "event=0x101e2",
	.desc = "Marked Branch Taken completed",
	.topic = "marked",
},
{
	.name = "pm_mrk_stcx_fail",
	.event = "event=0x3e158",
	.desc = "marked stcx failed",
	.topic = "marked",
},
{
	.name = "pm_data_from_on_chip_cache",
	.event = "event=0x1c048",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_pump_cpred",
	.event = "event=0x1c054",
	.desc = "Pump prediction correct. Counts across all types of pumps for a demand load",
	.topic = "marked",
},
{
	.name = "pm_darq_store_reject",
	.event = "event=0x4405e",
	.desc = "The DARQ attempted to transmit a store into an LSAQ or SRQ entry but It was rejected. Divide by PM_DARQ_STORE_XMIT to get reject ratio",
	.topic = "marked",
},
{
	.name = "pm_data_from_l2",
	.event = "event=0x1c042",
	.desc = "The processor's data cache was reloaded from local core's L2 due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_ll4",
	.event = "event=0x1d14c",
	.desc = "The processor's data cache was reloaded from the local chip's L4 cache due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_run_cyc_st_mode",
	.event = "event=0x1006c",
	.desc = "Cycles run latch is set and core is in ST mode",
	.topic = "marked",
},
{
	.name = "pm_data_from_l31_eco_shr",
	.event = "event=0x3c044",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to a demand load",
	.topic = "marked",
},
{
	.name = "pm_data_pump_mpred",
	.event = "event=0x4c052",
	.desc = "Pump misprediction. Counts across all types of pumps for a demand load",
	.topic = "marked",
},
{
	.name = "pm_grp_pump_cpred",
	.event = "event=0x20050",
	.desc = "Initial and Final Pump Scope and data sourced across this scope was group pump for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "marked",
},
{
	.name = "pm_mrk_st_l2disp_to_cmpl_cyc",
	.event = "event=0x1f150",
	.desc = "cycles from L2 rc disp to l2 rc completion",
	.topic = "marked",
},
{
	.name = "pm_sp_flop_cmpl",
	.event = "event=0x4505a",
	.desc = "SP instruction completed",
	.topic = "marked",
},
{
	.name = "pm_isq_36_44_entries",
	.event = "event=0x4000a",
	.desc = "Cycles in which 36 or more Issue Queue entries are in use. This is a shared event, not per thread. There are 44 issue queue entries across 4 slices in the whole core",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_ll4_cyc",
	.event = "event=0x2c12e",
	.desc = "Duration in cycles to reload from the local chip's L4 cache due to a marked load",
	.topic = "marked",
},
{
	.name = "pm_mem_pref",
	.event = "event=0x2c058",
	.desc = "Memory prefetch for this thread. Includes L4",
	.topic = "marked",
},
{
	.name = "pm_l1_icache_reloaded_all",
	.event = "event=0x40012",
	.desc = "Counts all Icache reloads includes demand, prefetch, prefetch turned into demand and demand turned into prefetch",
	.topic = "marked",
},
{
	.name = "pm_disp_held_sync_hold",
	.event = "event=0x4003c",
	.desc = "Cycles in which dispatch is held because of a synchronizing instruction in the pipeline",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_nested_tend",
	.event = "event=0x3003c",
	.desc = "Completion stall because the ISU is updating the TEXASR to keep track of the nested tend and decrement the TEXASR nested level. This is a short delay",
	.topic = "marked",
},
{
	.name = "pm_disp_held_hb_full",
	.event = "event=0x3d05c",
	.desc = "Dispatch held due to History Buffer full. Could be GPR/VSR/VMR/FPR/CR/XVF; CR; XVF (XER/VSCR/FPSCR)",
	.topic = "marked",
},
{
	.name = "pm_sys_pump_mpred",
	.event = "event=0x30052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "marked",
},
{
	.name = "pm_dpteg_from_l31_mod",
	.event = "event=0x2e044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_inst_from_dl2l3_shr",
	.event = "event=0x34048",
	.desc = "The processor's Instruction cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to an instruction fetch (not prefetch)",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l3",
	.event = "event=0x45042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l2",
	.event = "event=0x15042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_mem_loc_thresh_lsu_med",
	.event = "event=0x1c05e",
	.desc = "Local memory above threshold for data prefetch",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_timeo",
	.event = "event=0x40134",
	.desc = "marked Instruction finish timeout (instruction lost)",
	.topic = "marked",
},
{
	.name = "pm_l1_dcache_reloaded_all",
	.event = "event=0x1002c",
	.desc = "L1 data cache reloaded for demand. If MMCR1[16] is 1, prefetches will be included as well",
	.topic = "marked",
},
{
	.name = "pm_mrk_inst_fin",
	.event = "event=0x30130",
	.desc = "marked instruction finished",
	.topic = "marked",
},
{
	.name = "pm_mrk_dpteg_from_rl2l3_shr",
	.event = "event=0x1f14a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked data side request.. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "marked",
},
{
	.name = "pm_darq0_4_6_entries",
	.event = "event=0x3504e",
	.desc = "Cycles in which 4, 5, or 6 DARQ entries (out of 12) are in use",
	.topic = "marked",
},
{
	.name = "pm_darq_store_xmit",
	.event = "event=0x30064",
	.desc = "The DARQ attempted to transmit a store into an LSAQ or SRQ entry. Includes rejects. Not qualified by thread, so it includes counts for the whole core",
	.topic = "marked",
},
{
	.name = "pm_ipteg_from_l21_mod",
	.event = "event=0x45046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a instruction side request",
	.topic = "marked",
},
{
	.name = "pm_cmplu_stall_paste",
	.event = "event=0x2c016",
	.desc = "Finish stall because the NTF instruction was a paste waiting for response from L2",
	.topic = "marked",
},
{
	.name = "pm_mrk_stcx_fin",
	.event = "event=0x24156",
	.desc = "Number of marked stcx instructions finished. This includes instructions in the speculative path of a branch that may be flushed",
	.topic = "marked",
},
{
	.name = "pm_sync_mrk_probe_nop",
	.event = "event=0x15150",
	.desc = "Marked probeNops which can cause synchronous interrupts",
	.topic = "marked",
},
{
	.name = "pm_mrk_br_mpred_cmpl",
	.event = "event=0x301e4",
	.desc = "Marked Branch Mispredicted",
	.topic = "marked",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_ldhitst_cyc",
	.event = "event=0x1415a",
	.desc = "Duration in cycles to reload from local core's L2 with load hit store conflict due to a marked load",
	.topic = "floating point",
},
{
	.name = "pm_mem_loc_thresh_ifu",
	.event = "event=0x10058",
	.desc = "Local Memory above threshold for IFU speculation control",
	.topic = "floating point",
},
{
	.name = "pm_radix_pwc_l2_pde_from_l2",
	.event = "event=0x2d028",
	.desc = "A Page Directory Entry was reloaded to a level 2 page walk cache from the core's L2 data cache",
	.topic = "floating point",
},
{
	.name = "pm_flush_completion",
	.event = "event=0x30012",
	.desc = "The instruction that was next to complete did not complete because it suffered a flush",
	.topic = "floating point",
},
{
	.name = "pm_mrk_derat_miss_64k",
	.event = "event=0x2d154",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 64K",
	.topic = "floating point",
},
{
	.name = "pm_thresh_not_met",
	.event = "event=0x4016e",
	.desc = "Threshold counter did not meet threshold",
	.topic = "floating point",
},
{
	.name = "pm_br_2path",
	.event = "event=0x20036",
	.desc = "Branches that are not strongly biased",
	.topic = "pmc",
},
{
	.name = "pm_mem_loc_thresh_lsu_high",
	.event = "event=0x40056",
	.desc = "Local memory above threshold for LSU medium",
	.topic = "pmc",
},
{
	.name = "pm_dtlb_miss_4k",
	.event = "event=0x2c056",
	.desc = "Data TLB Miss page size 4k",
	.topic = "pmc",
},
{
	.name = "pm_mrk_dcache_reload_intv",
	.event = "event=0x40118",
	.desc = "Combined Intervention event",
	.topic = "pmc",
},
{
	.name = "pm_mrk_dpteg_from_dl2l3_mod",
	.event = "event=0x4f148",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_thresh_exc_64",
	.event = "event=0x301e8",
	.desc = "Threshold counter exceeded a value of 64",
	.topic = "pmc",
},
{
	.name = "pm_dpteg_from_l3miss",
	.event = "event=0x4e04e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L3 due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_sys_pump_mpred_rty",
	.event = "event=0x40050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "pmc",
},
{
	.name = "pm_mrk_dpteg_from_l2miss",
	.event = "event=0x1f14e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L2 due to a marked data side request.. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_cmplu_stall_bru",
	.event = "event=0x4d018",
	.desc = "Completion stall due to a Branch Unit",
	.topic = "pmc",
},
{
	.name = "pm_4flop_cmpl",
	.event = "event=0x45052",
	.desc = "4 FLOP instruction completed",
	.topic = "pmc",
},
{
	.name = "pm_mrk_data_from_lmem",
	.event = "event=0x3d142",
	.desc = "The processor's data cache was reloaded from the local chip's Memory due to a marked load",
	.topic = "pmc",
},
{
	.name = "pm_cmplu_stall_crypto",
	.event = "event=0x4c01e",
	.desc = "Finish stall because the NTF instruction was routed to the crypto execution pipe and was waiting to finish",
	.topic = "pmc",
},
{
	.name = "pm_freq_down",
	.event = "event=0x3000c",
	.desc = "Power Management: Below Threshold B",
	.topic = "pmc",
},
{
	.name = "pm_mrk_data_from_lmem_cyc",
	.event = "event=0x4d128",
	.desc = "Duration in cycles to reload from the local chip's Memory due to a marked load",
	.topic = "pmc",
},
{
	.name = "pm_8flop_cmpl",
	.event = "event=0x4d054",
	.desc = "8 FLOP instruction completed",
	.topic = "pmc",
},
{
	.name = "pm_tablewalk_cyc",
	.event = "event=0x10026",
	.desc = "Cycles when an instruction tablewalk is active",
	.topic = "pmc",
},
{
	.name = "pm_cmplu_stall_dcache_miss",
	.event = "event=0x2c012",
	.desc = "Finish stall because the NTF instruction was a load that missed the L1 and was waiting for the data to return from the nest",
	.topic = "pmc",
},
{
	.name = "pm_dpteg_from_memory",
	.event = "event=0x2e04c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_mrk_dpteg_from_l3_disp_conflict",
	.event = "event=0x3f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_mrk_dpteg_from_l3",
	.event = "event=0x4f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_tm_trans_run_cyc",
	.event = "event=0x10060",
	.desc = "run cycles in transactional state",
	.topic = "pmc",
},
{
	.name = "pm_dpteg_from_ll4",
	.event = "event=0x1e04c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pmc",
},
{
	.name = "pm_1flop_cmpl",
	.event = "event=0x45050",
	.desc = "one flop (fadd, fmul, fsub, fcmp, fsel, fabs, fnabs, fres, fsqrte, fneg) operation completed",
	.topic = "pmc",
},
{
	.name = "pm_ipteg_from_l31_mod",
	.event = "event=0x25044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_thresh_exc_256",
	.event = "event=0x101e8",
	.desc = "Threshold counter exceed a count of 256",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3miss",
	.event = "event=0x4504e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L3 due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_ntc_issue_held_darq_full",
	.event = "event=0x1006a",
	.desc = "The NTC instruction is being held at dispatch because there are no slots in the DARQ for it",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lsaq_arb",
	.event = "event=0x4e016",
	.desc = "Finish stall because the NTF instruction was a load or store that was held in LSAQ because an older instruction from SRQ or LRQ won arbitration to the LSU pipe when this instruction tried to launch",
	.topic = "frontend",
},
{
	.name = "pm_lsu_srq_full_cyc",
	.event = "event=0x1001a",
	.desc = "Cycles in which the Store Queue is full on all 4 slices. This is event is not per thread. All the threads will see the same count for this core resource",
	.topic = "frontend",
},
{
	.name = "pm_mrk_l2_tm_req_abort",
	.event = "event=0x1e15e",
	.desc = "TM abort",
	.topic = "frontend",
},
{
	.name = "pm_inst_sys_pump_mpred",
	.event = "event=0x34052",
	.desc = "Final Pump Scope (system) mispredicted. Either the original scope was too small (Chip/Group) or the original scope was System and it should have been smaller. Counts for an instruction fetch",
	.topic = "frontend",
},
{
	.name = "pm_mrk_l2_rc_disp",
	.event = "event=0x20114",
	.desc = "Marked Instruction RC dispatched in L2",
	.topic = "frontend",
},
{
	.name = "pm_data_from_l31_eco_mod",
	.event = "event=0x4c044",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to a demand load",
	.topic = "frontend",
},
{
	.name = "pm_data_from_l3_no_conflict",
	.event = "event=0x1c044",
	.desc = "The processor's data cache was reloaded from local core's L3 without conflict due to a demand load",
	.topic = "frontend",
},
{
	.name = "pm_inst_sys_pump_mpred_rty",
	.event = "event=0x44050",
	.desc = "Final Pump Scope (system) ended up larger than Initial Pump Scope (Chip/Group) for an instruction fetch",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_dclaim",
	.event = "event=0x30154",
	.desc = "Marked store had to do a dclaim",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_store_fin_arb",
	.event = "event=0x30014",
	.desc = "Finish stall because the NTF instruction was a store waiting for a slot in the store finish pipe. This means the instruction is ready to finish but there are instructions ahead of it, using the finish pipe",
	.topic = "frontend",
},
{
	.name = "pm_ld_miss_l1",
	.event = "event=0x3e054",
	.desc = "Load Missed L1, counted at execution time (can be greater than loads finished). LMQ merges are not included in this count. i.e. if a load instruction misses on an address that is already allocated on the LMQ, this event will not increment for that load). Note that this count is per slice, so if a load spans multiple slices this event will increment multiple times for a single load",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lsu_flush_next",
	.event = "event=0x2e01a",
	.desc = "Completion stall of one cycle because the LSU requested to flush the next iop in the sequence. It takes 1 cycle for the ISU to process this request before the LSU instruction is allowed to complete",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_stcx",
	.event = "event=0x2d01c",
	.desc = "Finish stall because the NTF instruction was a stcx waiting for response from L2",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lsu",
	.event = "event=0x2c010",
	.desc = "Completion stall by LSU instruction",
	.topic = "frontend",
},
{
	.name = "pm_data_from_l3_mepf",
	.event = "event=0x2c042",
	.desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state due to a demand load",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_mtfpscr",
	.event = "event=0x4e012",
	.desc = "Completion stall because the ISU is updating the register and notifying the Effective Address Table (EAT)",
	.topic = "frontend",
},
{
	.name = "pm_1plus_ppc_cmpl",
	.event = "event=0x100f2",
	.desc = "1 or more ppc insts finished",
	.topic = "frontend",
},
{
	.name = "pm_lsu_reject_lmq_full",
	.event = "event=0x3001c",
	.desc = "LSU Reject due to LMQ full (up to 4 per cycles)",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l31_shr",
	.event = "event=0x15046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_rd_t_intv",
	.event = "event=0x1015e",
	.desc = "Sampled Read got a T intervention",
	.topic = "frontend",
},
{
	.name = "pm_thresh_met",
	.event = "event=0x101ec",
	.desc = "threshold exceeded",
	.topic = "frontend",
},
{
	.name = "pm_pmc4_rewind",
	.event = "event=0x10020",
	.desc = "PMC4 Rewind Event",
	.topic = "frontend",
},
{
	.name = "pm_thresh_exc_1024",
	.event = "event=0x301ea",
	.desc = "Threshold counter exceeded a value of 1024",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lsu_mfspr",
	.event = "event=0x34056",
	.desc = "Finish stall because the NTF instruction was a mfspr instruction targeting an LSU SPR and it was waiting for the register data to be returned",
	.topic = "frontend",
},
{
	.name = "pm_vector_st_cmpl",
	.event = "event=0x44056",
	.desc = "Number of vector store instructions completed",
	.topic = "frontend",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_other",
	.event = "event=0x2c124",
	.desc = "The processor's data cache was reloaded from local core's L2 with dispatch conflict due to a marked load",
	.topic = "frontend",
},
{
	.name = "pm_mrk_data_from_rl2l3_shr_cyc",
	.event = "event=0x4c12a",
	.desc = "Duration in cycles to reload with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "frontend",
},
{
	.name = "pm_dtlb_miss_64k",
	.event = "event=0x3c056",
	.desc = "Data TLB Miss page size 64K",
	.topic = "frontend",
},
{
	.name = "pm_tm_trans_run_inst",
	.event = "event=0x30060",
	.desc = "Run instructions completed in transactional state (gated by the run latch)",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_store_finish",
	.event = "event=0x2c014",
	.desc = "Finish stall because the NTF instruction was a store with all its dependencies met, just waiting to go through the LSU pipe to finish",
	.topic = "frontend",
},
{
	.name = "pm_mrk_data_from_on_chip_cache_cyc",
	.event = "event=0x3515a",
	.desc = "Duration in cycles to reload either shared or modified data from another core's L2/L3 on the same chip due to a marked load",
	.topic = "frontend",
},
{
	.name = "pm_inst_sys_pump_cpred",
	.event = "event=0x34050",
	.desc = "Initial and Final Pump Scope was system pump (prediction=correct) for an instruction fetch",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_claim_rty",
	.event = "event=0x3015e",
	.desc = "Sampled store did a rwitm and got a rty",
	.topic = "frontend",
},
{
	.name = "pm_suspended",
	.event = "event=0",
	.desc = "Counter OFF",
	.topic = "frontend",
},
{
	.name = "pm_pmc4_overflow",
	.event = "event=0x10010",
	.desc = "Overflow from counter 4",
	.topic = "frontend",
},
{
	.name = "pm_dpteg_from_rmem",
	.event = "event=0x3e04a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group ( Remote) due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_dclaim_cyc",
	.event = "event=0x2f152",
	.desc = "cycles L2 RC took for a dclaim",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lrq_other",
	.event = "event=0x10004",
	.desc = "Finish stall due to LRQ miscellaneous reasons, lost arbitration to LMQ slot, bank collisions, set prediction cleanup, set prediction multihit and others",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_rwitm_cyc",
	.event = "event=0x4f150",
	.desc = "cycles L2 RC took for a rwitm",
	.topic = "frontend",
},
{
	.name = "pm_dpteg_from_l3",
	.event = "event=0x4e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "frontend",
},
{
	.name = "pm_tlb_hit",
	.event = "event=0x1f054",
	.desc = "Number of times the TLB had the data required by the instruction. Applies to both HPT and RPT",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_sync_pmu_int",
	.event = "event=0x2c01e",
	.desc = "Cycles in which the NTC instruction is waiting for a synchronous PMU interrupt",
	.topic = "frontend",
},
{
	.name = "pm_iops_cmpl",
	.event = "event=0x24050",
	.desc = "Internal Operations completed",
	.topic = "frontend",
},
{
	.name = "pm_sync_mrk_br_mpred",
	.event = "event=0x1515c",
	.desc = "Marked Branch mispredict that can cause a synchronous interrupt",
	.topic = "frontend",
},
{
	.name = "pm_inst_from_l3miss",
	.event = "event=0x300fa",
	.desc = "Marked instruction was reloaded from a location beyond the local chiplet",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3_no_conflict",
	.event = "event=0x15044",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_sync_mrk_br_link",
	.event = "event=0x15152",
	.desc = "Marked Branch and link branch that can cause a synchronous interrupt",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_tend",
	.event = "event=0x1e050",
	.desc = "Finish stall because the NTF instruction was a tend instruction awaiting response from L2",
	.topic = "frontend",
},
{
	.name = "pm_mrk_ld_miss_exposed_cyc",
	.event = "event=0x1013e",
	.desc = "Marked Load exposed Miss (use edge detect to count #)",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l3_mepf",
	.event = "event=0x25042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_inst_pump_cpred",
	.event = "event=0x14054",
	.desc = "Pump prediction correct. Counts across all types of pumps for an instruction fetch",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_rd_rty",
	.event = "event=0x4015e",
	.desc = "Sampled L2 reads retry count",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_dl2l3_mod",
	.event = "event=0x45048",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_inst_pump_mpred",
	.event = "event=0x44052",
	.desc = "Pump misprediction. Counts across all types of pumps for an instruction fetch",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_store_data",
	.event = "event=0x30026",
	.desc = "Finish stall because the next to finish instruction was a store waiting on data",
	.topic = "frontend",
},
{
	.name = "pm_mrk_derat_miss",
	.event = "event=0x301e6",
	.desc = "Erat Miss (TLB Access) All page sizes",
	.topic = "frontend",
},
{
	.name = "pm_thresh_acc",
	.event = "event=0x24154",
	.desc = "This event increments every time the threshold event counter ticks. Thresholding must be enabled (via MMCRA) and the thresholding start event must occur for this counter to increment. It will stop incrementing when the thresholding stop event occurs or when thresholding is disabled, until the next time a configured thresholding start event occurs",
	.topic = "frontend",
},
{
	.name = "pm_mrk_fab_rsp_rwitm_rty",
	.event = "event=0x2015e",
	.desc = "Sampled store did a rwitm and got a rty",
	.topic = "frontend",
},
{
	.name = "pm_br_taken_cmpl",
	.event = "event=0x200fa",
	.desc = "New event for Branch Taken",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l31_eco_shr",
	.event = "event=0x35044",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's ECO L3 on the same chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_store_pipe_arb",
	.event = "event=0x4c010",
	.desc = "Finish stall because the NTF instruction was a store waiting for the next relaunch opportunity after an internal reject. This means the instruction is ready to relaunch and tried once but lost arbitration",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_st_fwd",
	.event = "event=0x4c01c",
	.desc = "Completion stall due to store forward",
	.topic = "frontend",
},
{
	.name = "pm_mrk_data_from_rl4",
	.event = "event=0x3515c",
	.desc = "The processor's data cache was reloaded from another chip's L4 on the same Node or Group ( Remote) due to a marked load",
	.topic = "frontend",
},
{
	.name = "pm_mrk_data_from_l31_eco_shr",
	.event = "event=0x2d14c",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "frontend",
},
{
	.name = "pm_mrk_larx_fin",
	.event = "event=0x40116",
	.desc = "Larx finished",
	.topic = "frontend",
},
{
	.name = "pm_dtlb_miss_16m",
	.event = "event=0x4c056",
	.desc = "Data TLB Miss page size 16M",
	.topic = "frontend",
},
{
	.name = "pm_cmplu_stall_lsu_fin",
	.event = "event=0x1003a",
	.desc = "Finish stall because the NTF instruction was an LSU op (other than a load or a store) with all its dependencies met and just going through the LSU pipe to finish",
	.topic = "frontend",
},
{
	.name = "pm_mrk_l2_rc_done",
	.event = "event=0x3012a",
	.desc = "Marked RC done",
	.topic = "frontend",
},
{
	.name = "pm_ipteg_from_l31_eco_mod",
	.event = "event=0x45044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a instruction side request",
	.topic = "frontend",
},
{
	.name = "pm_dfu_busy",
	.event = "event=0x4d04c",
	.desc = "Cycles in which all 4 Decimal Floating Point units are busy. The DFU is running at capacity",
	.topic = "pipeline",
},
{
	.name = "pm_ierat_reload",
	.event = "event=0x100f6",
	.desc = "Number of I-ERAT reloads",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_ld_miss_l1",
	.event = "event=0x201e2",
	.desc = "Marked DL1 Demand Miss counted at exec time. Note that this count is per slice, so if a load spans multiple slices this event will increment multiple times for a single load",
	.topic = "pipeline",
},
{
	.name = "pm_pmc3_overflow",
	.event = "event=0x40010",
	.desc = "Overflow from counter 3",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dflong",
	.event = "event=0x1005a",
	.desc = "Finish stall because the NTF instruction was a multi-cycle instruction issued to the Decimal Floating Point execution pipe and waiting to finish. Includes decimal floating point instructions + 128 bit binary floating point instructions. Qualified by multicycle",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_on_chip_cache",
	.event = "event=0x4d140",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on the same chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_dl4",
	.event = "event=0x3f14c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_l2_no_conflict",
	.event = "event=0x1e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_fxu_idle",
	.event = "event=0x24052",
	.desc = "Cycles in which FXU0, FXU1, FXU2, and FXU3 are all idle",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall",
	.event = "event=0x1e054",
	.desc = "Nothing completed and ICT not empty",
	.topic = "pipeline",
},
{
	.name = "pm_inst_cmpl",
	.event = "event=0x2",
	.desc = "Number of PowerPC Instructions that completed",
	.topic = "pipeline",
},
{
	.name = "pm_vsu_dp_fsqrt_fdiv",
	.event = "event=0x3d058",
	.desc = "vector versions of fdiv,fsqrt",
	.topic = "pipeline",
},
{
	.name = "pm_disp_held",
	.event = "event=0x10006",
	.desc = "Dispatch Held",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_derat_miss_16m",
	.event = "event=0x3d154",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 16M",
	.topic = "pipeline",
},
{
	.name = "pm_ext_int",
	.event = "event=0x200f8",
	.desc = "external interrupt",
	.topic = "pipeline",
},
{
	.name = "pm_ict_empty_cyc",
	.event = "event=0x20008",
	.desc = "Cycles in which the ICT is completely empty. No itags are assigned to any thread",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l21_mod",
	.event = "event=0x4f146",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_mem_read",
	.event = "event=0x10056",
	.desc = "Reads from Memory from this thread (includes data/inst/xlate/l1prefetch/inst prefetch). Includes L4",
	.topic = "pipeline",
},
{
	.name = "pm_data_from_dl4",
	.event = "event=0x3c04c",
	.desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to a demand load",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_l21_mod",
	.event = "event=0x4e046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L2 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_ntc_issue_held_arb",
	.event = "event=0x2e016",
	.desc = "The NTC instruction is being held at dispatch because it lost arbitration onto the issue pipe to another instruction (from the same thread or a different thread)",
	.topic = "pipeline",
},
{
	.name = "pm_sync_mrk_fx_divide",
	.event = "event=0x15156",
	.desc = "Marked fixed point divide that can cause a synchronous interrupt",
	.topic = "pipeline",
},
{
	.name = "pm_derat_miss_4k",
	.event = "event=0x1c056",
	.desc = "Data ERAT Miss (Data TLB Access) page size 4K",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l3_mepf",
	.event = "event=0x2f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_pmc5_overflow",
	.event = "event=0x10024",
	.desc = "Overflow from counter 5",
	.topic = "pipeline",
},
{
	.name = "pm_flop_cmpl",
	.event = "event=0x4505e",
	.desc = "Floating Point Operation Finished",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dmiss_l21_l31",
	.event = "event=0x2c018",
	.desc = "Completion stall by Dcache miss which resolved on chip ( excluding local L2/L3)",
	.topic = "pipeline",
},
{
	.name = "pm_ierat_reload_16m",
	.event = "event=0x4006a",
	.desc = "IERAT Reloaded (Miss) for a 16M page",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_ic_l3miss",
	.event = "event=0x4e010",
	.desc = "Ict empty for this thread due to icache misses that were sourced from beyond the local L3. The source could be local/remote/distant memory or another core's cache",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_disp_held_sync",
	.event = "event=0x4d01c",
	.desc = "Dispatch held due to a synchronizing instruction at dispatch",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_ic_miss",
	.event = "event=0x2d01a",
	.desc = "Ict empty for this thread due to Icache Miss",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_derat_miss_1g",
	.event = "event=0x3d152",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 1G. Implies radix translation",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_off_chip_cache",
	.event = "event=0x4f14a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_tlbie_fin",
	.event = "event=0x30058",
	.desc = "tlbie finished",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_cyc",
	.event = "event=0x100f8",
	.desc = "Number of cycles the ICT has no itags assigned to this thread",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_l3_disp_conflict",
	.event = "event=0x3e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l2_no_conflict",
	.event = "event=0x1f140",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_derat_miss_1g",
	.event = "event=0x2c05a",
	.desc = "Data ERAT Miss (Data TLB Access) page size 1G. Implies radix translation",
	.topic = "pipeline",
},
{
	.name = "pm_radix_pwc_l2_pte_from_l2",
	.event = "event=0x1f058",
	.desc = "A Page Table Entry was reloaded to a level 2 page walk cache from the core's L2 data cache. This implies that level 3 and level 4 PWC accesses were not necessary for this translation",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_rl2l3_mod",
	.event = "event=0x1d14a",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_chip_pump_cpred",
	.event = "event=0x10050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "pipeline",
},
{
	.name = "pm_ic_miss_cmpl",
	.event = "event=0x45058",
	.desc = "Non-speculative icache miss, counted at completion",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_derat_miss_4k",
	.event = "event=0x2d150",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 4K",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_br_mpred_icmiss",
	.event = "event=0x34058",
	.desc = "Ict empty for this thread due to Icache Miss and branch mispred",
	.topic = "pipeline",
},
{
	.name = "pm_pmc2_saved",
	.event = "event=0x10022",
	.desc = "PMC2 Rewind Value saved",
	.topic = "pipeline",
},
{
	.name = "pm_hv_cyc",
	.event = "event=0x2000a",
	.desc = "Cycles in which msr_hv is high. Note that this event does not take msr_pr into consideration",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l3_no_conflict",
	.event = "event=0x1f144",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without conflict due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_dtlb_miss",
	.event = "event=0x300fc",
	.desc = "Data PTEG reload",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_derat_miss_2m",
	.event = "event=0x2d152",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 2M. Implies radix translation",
	.topic = "pipeline",
},
{
	.name = "pm_data_from_rl2l3_mod",
	.event = "event=0x2c046",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a demand load",
	.topic = "pipeline",
},
{
	.name = "pm_grp_pump_mpred",
	.event = "event=0x20052",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "pipeline",
},
{
	.name = "pm_radix_pwc_l2_pde_from_l3",
	.event = "event=0x3f05a",
	.desc = "A Page Directory Entry was reloaded to a level 2 page walk cache from the core's L3 data cache",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_rl2l3_shr",
	.event = "event=0x1e04a",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_disp_held_tbegin",
	.event = "event=0x10064",
	.desc = "the NTC instruction is being held at dispatch because it is a tbegin instruction and there is an older tbegin in the pipeline that must complete before the younger tbegin can dispatch",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_rl2l3_mod",
	.event = "event=0x2e046",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_dmem",
	.event = "event=0x4f14c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_l3_mepf",
	.event = "event=0x2e042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 without dispatch conflicts hit on Mepf state. due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dfu",
	.event = "event=0x2d012",
	.desc = "Finish stall because the NTF instruction was issued to the Decimal Floating Point execution pipe and waiting to finish. Includes decimal floating point instructions + 128 bit binary floating point instructions. Not qualified by multicycle",
	.topic = "pipeline",
},
{
	.name = "pm_data_from_dmem",
	.event = "event=0x4c04c",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to a demand load",
	.topic = "pipeline",
},
{
	.name = "pm_pmc4_saved",
	.event = "event=0x30022",
	.desc = "PMC4 Rewind Value saved (matched condition)",
	.topic = "pipeline",
},
{
	.name = "pm_run_cyc",
	.event = "event=0x200f4",
	.desc = "Run_cycles",
	.topic = "pipeline",
},
{
	.name = "pm_1plus_ppc_disp",
	.event = "event=0x400f2",
	.desc = "Cycles at least one Instr Dispatched",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_l21_mod_cyc",
	.event = "event=0x3d148",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's L2 on the same chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_rl2l3_mod",
	.event = "event=0x2f146",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_disp_held",
	.event = "event=0x4e01a",
	.desc = "Cycles in which the NTC instruction is held at dispatch for any reason",
	.topic = "pipeline",
},
{
	.name = "pm_thresh_exc_2048",
	.event = "event=0x401ec",
	.desc = "Threshold counter exceeded a value of 2048",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_rl2l3_shr",
	.event = "event=0x35150",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_ic_l3",
	.event = "event=0x3e052",
	.desc = "Ict empty for this thread due to icache misses that were sourced from the local L3",
	.topic = "pipeline",
},
{
	.name = "pm_ntc_fin",
	.event = "event=0x2405a",
	.desc = "Cycles in which the oldest instruction in the pipeline (NTC) finishes. This event is used to account for cycles in which work is being completed in the CPI stack",
	.topic = "pipeline",
},
{
	.name = "pm_pump_mpred",
	.event = "event=0x40052",
	.desc = "Pump misprediction. Counts across all types of pumps for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "pipeline",
},
{
	.name = "pm_tm_aborts",
	.event = "event=0x30056",
	.desc = "Number of TM transactions aborted",
	.topic = "pipeline",
},
{
	.name = "pm_inst_from_memory",
	.event = "event=0x2404c",
	.desc = "The processor's Instruction cache was reloaded from a memory location including L4 from local remote or distant due to an instruction fetch (not prefetch)",
	.topic = "pipeline",
},
{
	.name = "pm_derat_miss_2m",
	.event = "event=0x1c05a",
	.desc = "Data ERAT Miss (Data TLB Access) page size 2M. Implies radix translation",
	.topic = "pipeline",
},
{
	.name = "pm_pmc6_overflow",
	.event = "event=0x30024",
	.desc = "Overflow from counter 6",
	.topic = "pipeline",
},
{
	.name = "pm_bru_fin",
	.event = "event=0x10068",
	.desc = "Branch Instruction Finished",
	.topic = "pipeline",
},
{
	.name = "pm_pmc2_rewind",
	.event = "event=0x30020",
	.desc = "PMC2 Rewind Event (did not match condition)",
	.topic = "pipeline",
},
{
	.name = "pm_dummy2_remove_me",
	.event = "event=0x40064",
	.desc = "Space holder for LS_PC_RELOAD_RA",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_dl2l3_shr",
	.event = "event=0x3f148",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_ict_noslot_br_mpred",
	.event = "event=0x4d01e",
	.desc = "Ict empty for this thread due to branch mispred",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_on_chip_cache",
	.event = "event=0x1f148",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a marked data side request.. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_dpteg_from_l21_shr",
	.event = "event=0x3e046",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l31_mod",
	.event = "event=0x2f144",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's L3 on the same chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_derat_miss_16g",
	.event = "event=0x4c15c",
	.desc = "Marked Data ERAT Miss (Data TLB Access) page size 16G",
	.topic = "pipeline",
},
{
	.name = "pm_inst_grp_pump_mpred_rty",
	.event = "event=0x14052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for an instruction fetch",
	.topic = "pipeline",
},
{
	.name = "pm_dslb_miss",
	.event = "event=0xd0a8",
	.desc = "gate_and(sd_pc_c0_comp_valid AND sd_pc_c0_comp_thread(0:1)=tid,sd_pc_c0_comp_ppc_count(0:3)) + gate_and(sd_pc_c1_comp_valid AND sd_pc_c1_comp_thread(0:1)=tid,sd_pc_c1_comp_ppc_count(0:3))",
	.topic = "pipeline",
},
{
	.name = "pm_mem_co",
	.event = "event=0x4c058",
	.desc = "Memory castouts from this thread",
	.topic = "pipeline",
},
{
	.name = "pm_fxu_fin",
	.event = "event=0x40004",
	.desc = "The fixed point unit Unit finished an instruction. Instructions that finish may not necessary complete",
	.topic = "pipeline",
},
{
	.name = "pm_derat_miss_64k",
	.event = "event=0x2c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 64K",
	.topic = "pipeline",
},
{
	.name = "pm_ic_demand_cyc",
	.event = "event=0x10018",
	.desc = "Icache miss demand cycles",
	.topic = "pipeline",
},
{
	.name = "pm_derat_miss_16m",
	.event = "event=0x3c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 16M",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_l21_shr",
	.event = "event=0x2d14e",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L2 on the same chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_dplong",
	.event = "event=0x3405c",
	.desc = "Finish stall because the NTF instruction was a scalar multi-cycle instruction issued to the Double Precision execution pipe and waiting to finish. Includes binary floating point instructions in 32 and 64 bit binary floating point format. Qualified by NOT vector AND multicycle",
	.topic = "pipeline",
},
{
	.name = "pm_2flop_cmpl",
	.event = "event=0x4d052",
	.desc = "DP vector version of fmul, fsub, fcmp, fsel, fabs, fnabs, fres ,fsqrte, fneg ",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_l2",
	.event = "event=0x1f142",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_dummy1_remove_me",
	.event = "event=0x40062",
	.desc = "Space holder for L2_PC_PM_MK_LDST_SCOPE_PRED_STATUS",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_erat_miss",
	.event = "event=0x4c012",
	.desc = "Finish stall because the NTF instruction was a load or store that suffered a translation miss",
	.topic = "pipeline",
},
{
	.name = "pm_vsu_non_flop_cmpl",
	.event = "event=0x4d050",
	.desc = "Non FLOP operation completed",
	.topic = "pipeline",
},
{
	.name = "pm_tm_tx_pass_run_cyc",
	.event = "event=0x2e012",
	.desc = "cycles spent in successful transactions",
	.topic = "pipeline",
},
{
	.name = "pm_vsu_fsqrt_fdiv",
	.event = "event=0x4d04e",
	.desc = "four flops operation (fdiv,fsqrt) Scalar Instructions only",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_l2_mepf",
	.event = "event=0x4c120",
	.desc = "The processor's data cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_ld_l3miss_pend_cyc",
	.event = "event=0x10062",
	.desc = "Cycles L3 miss was pending for this thread",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_dpteg_from_memory",
	.event = "event=0x2f14c",
	.desc = "A Page Table Entry was loaded into the TLB from a memory location including L4 from local remote or distant due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "pipeline",
},
{
	.name = "pm_inst_chip_pump_cpred",
	.event = "event=0x14050",
	.desc = "Initial and Final Pump Scope was chip pump (prediction=correct) for an instruction fetch",
	.topic = "pipeline",
},
{
	.name = "pm_fxu_busy",
	.event = "event=0x2000e",
	.desc = "Cycles in which all 4 FXUs are busy. The FXU is running at capacity",
	.topic = "pipeline",
},
{
	.name = "pm_tlb_miss",
	.event = "event=0x20066",
	.desc = "TLB Miss (I + D)",
	.topic = "pipeline",
},
{
	.name = "pm_pump_cpred",
	.event = "event=0x10054",
	.desc = "Pump prediction correct. Counts across all types of pumps for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_l31_shr",
	.event = "event=0x4d124",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another core's L3 on the same chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_flush",
	.event = "event=0x400f8",
	.desc = "Flush (any type)",
	.topic = "pipeline",
},
{
	.name = "pm_cmplu_stall_emq_full",
	.event = "event=0x30004",
	.desc = "Finish stall because the next to finish instruction suffered an ERAT miss and the EMQ was full",
	.topic = "pipeline",
},
{
	.name = "pm_mrk_data_from_l21_shr_cyc",
	.event = "event=0x1d154",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's L2 on the same chip due to a marked load",
	.topic = "pipeline",
},
{
	.name = "pm_isu1_iss_hold_all",
	.event = "event=0x3084",
	.desc = "All ISU rejects",
	.topic = "other",
},
{
	.name = "pm_snoop_tlbie",
	.event = "event=0xf880",
	.desc = "TLBIE snoop",
	.topic = "other",
},
{
	.name = "pm_ic_demand_req",
	.event = "event=0x4088",
	.desc = "Demand Instruction fetch request",
	.topic = "other",
},
{
	.name = "pm_tm_tresume",
	.event = "event=0x20a4",
	.desc = "TM resume instruction completed",
	.topic = "other",
},
{
	.name = "pm_srq_empty_cyc",
	.event = "event=0x40008",
	.desc = "Cycles in which the SRQ has at least one (out of four) empty slice",
	.topic = "other",
},
{
	.name = "pm_ierat_reload_4k",
	.event = "event=0x20064",
	.desc = "IERAT reloaded (after a miss) for 4K pages",
	.topic = "other",
},
{
	.name = "pm_l3_p2_lco_rty",
	.event = "event=0x260b4",
	.desc = "L3 initiated LCO received retry on port 2 (can try 4 times)",
	.topic = "other",
},
{
	.name = "pm_disp_held_issq_full",
	.event = "event=0x20006",
	.desc = "Dispatch held due to Issue q full. Includes issue queue and branch queue",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3miss",
	.event = "event=0x201e4",
	.desc = "The processor's data cache was reloaded from a location other than the local core's L3 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l31_eco_mod",
	.event = "event=0x4e044",
	.desc = "A Page Table Entry was loaded into the TLB with Modified (M) data from another core's ECO L3 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_br_mpred_taken_cr",
	.event = "event=0x40b8",
	.desc = "A Conditional Branch that resolved to taken was mispredicted as not taken (due to the BHT Direction Prediction)",
	.topic = "other",
},
{
	.name = "pm_dc_dealloc_no_conf",
	.event = "event=0xf8ac",
	.desc = "A demand load referenced a line in an active fuzzy prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software.Fuzzy stream confirm (out of order effects, or pf cant keep up)",
	.topic = "other",
},
{
	.name = "pm_ls0_dc_collisions",
	.event = "event=0xd090",
	.desc = "Read-write data cache collisions",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_0_1_cyc",
	.event = "event=0x40bc",
	.desc = "Cycles thread running at priority level 0 or 1",
	.topic = "other",
},
{
	.name = "pm_flush_hb_restore_cyc",
	.event = "event=0x2084",
	.desc = "Cycles in which no new instructions can be dispatched to the ICT after a flush.  History buffer recovery",
	.topic = "other",
},
{
	.name = "pm_radix_pwc_miss",
	.event = "event=0x4f054",
	.desc = "A radix translation attempt missed in the TLB and all levels of page walk cache",
	.topic = "other",
},
{
	.name = "pm_l2_dc_inv",
	.event = "event=0x26882",
	.desc = "D-cache invalidates sent over the reload bus to the core",
	.topic = "other",
},
{
	.name = "pm_inst_from_lmem",
	.event = "event=0x24048",
	.desc = "The processor's Instruction cache was reloaded from the local chip's Memory due to an instruction fetch (not prefetch)",
	.topic = "other",
},
{
	.name = "pm_lsu0_lrq_s0_valid_cyc",
	.event = "event=0xd8b4",
	.desc = "Slot 0 of LRQ valid",
	.topic = "other",
},
{
	.name = "pm_tm_passed",
	.event = "event=0x2e052",
	.desc = "Number of TM transactions that passed",
	.topic = "other",
},
{
	.name = "pm_lsu0_store_reject",
	.event = "event=0xf088",
	.desc = "All internal store rejects cause the instruction to go back to the SRQ and go to sleep until woken up to try again after the condition has been met",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_wrong_low",
	.event = "event=0x360b2",
	.desc = "Initial scope=group (GS or NNS) but data from outside group (far or rem). Prediction too Low",
	.topic = "other",
},
{
	.name = "pm_tm_cam_overflow",
	.event = "event=0x168a6",
	.desc = "L3 TM cam overflow during L2 co of SC",
	.topic = "other",
},
{
	.name = "pm_tend_pend_cyc",
	.event = "event=0xe8b0",
	.desc = "TEND latency per thread",
	.topic = "other",
},
{
	.name = "pm_ibuf_full_cyc",
	.event = "event=0x4884",
	.desc = "Cycles No room in ibuff",
	.topic = "other",
},
{
	.name = "pm_lsu2_ldmx_fin",
	.event = "event=0xd08c",
	.desc = "New P9 instruction LDMX. The definition of this new PMU event is (from the ldmx RFC02491):  The thread has executed an ldmx instruction that accessed a doubleword that contains an effective address within an enabled section of the Load Monitored region.  This event, therefore, should not occur if the FSCR has disabled the load monitored facility (FSCR[52]) or disabled the EBB facility (FSCR[56])",
	.topic = "other",
},
{
	.name = "pm_tb_bit_trans",
	.event = "event=0x300f8",
	.desc = "timebase event",
	.topic = "other",
},
{
	.name = "pm_data_from_l2_disp_conflict_ldhitst",
	.event = "event=0x3c040",
	.desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to a demand load",
	.topic = "other",
},
{
	.name = "pm_ls0_pte_tablewalk_cyc",
	.event = "event=0xe0bc",
	.desc = "Cycles when a tablewalk is pending on this thread on table 0",
	.topic = "other",
},
{
	.name = "pm_isu3_iss_hold_all",
	.event = "event=0x3884",
	.desc = "All ISU rejects",
	.topic = "other",
},
{
	.name = "pm_rd_forming_sc",
	.event = "event=0x460a6",
	.desc = "Read forming SC",
	.topic = "other",
},
{
	.name = "pm_l3_pf_off_chip_mem",
	.event = "event=0x468a0",
	.desc = "L3 PF from Off chip memory",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_data",
	.event = "event=0x268aa",
	.desc = "LCO sent with data port 1",
	.topic = "other",
},
{
	.name = "pm_lsu1_tm_l1_hit",
	.event = "event=0xe894",
	.desc = "Load tm hit in L1",
	.topic = "other",
},
{
	.name = "pm_ic_invalidate",
	.event = "event=0x5888",
	.desc = "Ic line invalidated",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_tlbie",
	.event = "event=0x2890",
	.desc = "Dispatch Hold: Due to TLBIE",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_thrd",
	.event = "event=0x1001c",
	.desc = "Completion Stalled because the thread was blocked",
	.topic = "other",
},
{
	.name = "pm_snp_tm_hit_t",
	.event = "event=0x368a6",
	.desc = "Snp TM sthit T/Tn/Te",
	.topic = "other",
},
{
	.name = "pm_data_tablewalk_cyc",
	.event = "event=0x3001a",
	.desc = "Data Tablewalk Cycles.  Could be 1 or 2 active tablewalks. Includes data prefetches",
	.topic = "other",
},
{
	.name = "pm_ls3_dc_collisions",
	.event = "event=0xd894",
	.desc = "Read-write data cache collisions",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_mod_cyc",
	.event = "event=0x35158",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_lsu3_l1_cam_cancel",
	.event = "event=0xf894",
	.desc = "ls3 l1 tm cam cancel",
	.topic = "other",
},
{
	.name = "pm_flush_disp_tlbie",
	.event = "event=0x2888",
	.desc = "Dispatch Flush: TLBIE",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dmem_cyc",
	.event = "event=0x4e11e",
	.desc = "Duration in cycles to reload from another chip's memory on the same Node or Group (Distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_cyc",
	.event = "event=0x14156",
	.desc = "Duration in cycles to reload from local core's L2 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_rd_clearing_sc",
	.event = "event=0x468a6",
	.desc = "Read clearing SC",
	.topic = "other",
},
{
	.name = "pm_l3_p1_node_pump",
	.event = "event=0x168b0",
	.desc = "L3 PF sent with nodal scope port 1, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_lsu0_1_lrqf_full_cyc",
	.event = "event=0xd0bc",
	.desc = "Counts the number of cycles the LRQF is full.  LRQF is the queue that holds loads between finish and completion.  If it fills up, instructions stay in LRQ until completion, potentially backing up the LRQ",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_ldhitst",
	.event = "event=0x2d148",
	.desc = "The processor's data cache was reloaded from local core's L2 with load hit store conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l3_p3_co_rty",
	.event = "event=0x468ae",
	.desc = "L3 CO received retry port 3 (memory only), every retry counted",
	.topic = "other",
},
{
	.name = "pm_sn_hit",
	.event = "event=0x460a8",
	.desc = "Any port snooper hit L3.  Up to 4 can happen in a cycle but we only count 1",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_mem",
	.event = "event=0x360aa",
	.desc = "L3 CO to memory port 0 with or without data",
	.topic = "other",
},
{
	.name = "pm_dc_pref_hw_alloc",
	.event = "event=0xf0a4",
	.desc = "Prefetch stream allocated by the hardware prefetch mechanism",
	.topic = "other",
},
{
	.name = "pm_srq_sync_cyc",
	.event = "event=0xd0ac",
	.desc = "A sync is in the S2Q (edge detect to count)",
	.topic = "other",
},
{
	.name = "pm_mrk_inst_from_l3miss",
	.event = "event=0x401e6",
	.desc = "Marked instruction was reloaded from a location beyond the local chiplet",
	.topic = "other",
},
{
	.name = "pm_l2_ic_inv",
	.event = "event=0x26082",
	.desc = "I-cache Invalidates sent over the realod bus to the core",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_relaunch_miss",
	.event = "event=0xc8ac",
	.desc = "If a load that has already returned data and has to relaunch for any reason then gets a miss (erat, setp, data cache), it will often be flushed at relaunch time because the data might be inconsistent",
	.topic = "other",
},
{
	.name = "pm_l3_ld_hit",
	.event = "event=0x260a4",
	.desc = "L3 Hits for demand LDs",
	.topic = "other",
},
{
	.name = "pm_data_store",
	.event = "event=0xf0a0",
	.desc = "All ops that drain from s2q to L2 containing data",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_rmem",
	.event = "event=0x1d148",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group ( Remote) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l2_loc_guess_correct",
	.event = "event=0x16088",
	.desc = "L2 guess local (LNS) and guess was correct (ie data local)",
	.topic = "other",
},
{
	.name = "pm_l3_hit",
	.event = "event=0x160a4",
	.desc = "L3 Hits (L2 miss hitting L3, including data/instrn/xlate)",
	.topic = "other",
},
{
	.name = "pm_lsu0_tm_l1_miss",
	.event = "event=0xe09c",
	.desc = "Load tm L1 miss",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_rty",
	.event = "event=0x168b4",
	.desc = "L3 initiated LCO received retry on port 1 (can try 4 times)",
	.topic = "other",
},
{
	.name = "pm_l3_rd_usage",
	.event = "event=0x268ac",
	.desc = "Rotating sample of 16 RD actives",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_mepf_cyc",
	.event = "event=0x1415c",
	.desc = "Duration in cycles to reload from local core's L3 without dispatch conflicts hit on Mepf state due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l1_sw_pref",
	.event = "event=0xe880",
	.desc = "Software L1 Prefetches, including SW Transient Prefetches",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_bal",
	.event = "event=0x288c",
	.desc = "Dispatch/CLB Hold: Balance Flush",
	.topic = "other",
},
{
	.name = "pm_mrk_l1_reload_valid",
	.event = "event=0x101ea",
	.desc = "Marked demand reload",
	.topic = "other",
},
{
	.name = "pm_mrk_ld_miss_l1_cyc",
	.event = "event=0x1d156",
	.desc = "Marked ld latency",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_dmiss_l3miss",
	.event = "event=0x4c01a",
	.desc = "Completion stall due to cache miss resolving missed the L3",
	.topic = "other",
},
{
	.name = "pm_run_cyc_smt4_mode",
	.event = "event=0x2006c",
	.desc = "Cycles in which this thread's run latch is set and the core is in SMT4 mode",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_off_chip_cache_cyc",
	.event = "event=0x1d14e",
	.desc = "Duration in cycles to reload either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_darq1_10_12_entries",
	.event = "event=0x20058",
	.desc = "Cycles in which 10 or  more DARQ1 entries (out of 12) are in use",
	.topic = "other",
},
{
	.name = "pm_snp_tm_hit_m",
	.event = "event=0x360a6",
	.desc = "Snp TM st hit M/Mu",
	.topic = "other",
},
{
	.name = "pm_link_stack_invalid_ptr",
	.event = "event=0x5898",
	.desc = "It is most often caused by certain types of flush where the pointer is not available. Can result in the data in the link stack becoming unusable",
	.topic = "other",
},
{
	.name = "pm_l2_chip_pump",
	.event = "event=0x46088",
	.desc = "RC requests that were local (aka chip) pump attempts",
	.topic = "other",
},
{
	.name = "pm_tm_tsuspend",
	.event = "event=0x28a0",
	.desc = "TM suspend instruction completed",
	.topic = "other",
},
{
	.name = "pm_l1_pref",
	.event = "event=0x20054",
	.desc = "A data line was written to the L1 due to a hardware or software prefetch",
	.topic = "other",
},
{
	.name = "pm_lsu1_store_reject",
	.event = "event=0xf888",
	.desc = "All internal store rejects cause the instruction to go back to the SRQ and go to sleep until woken up to try again after the condition has been met",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_disp_conflict",
	.event = "event=0x1d144",
	.desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_run_inst_cmpl",
	.event = "event=0x400fa",
	.desc = "Run_Instructions",
	.topic = "other",
},
{
	.name = "pm_sync_mrk_l3miss",
	.event = "event=0x15154",
	.desc = "Marked L3 misses that can throw a synchronous interrupt",
	.topic = "other",
},
{
	.name = "pm_ls0_tm_disallow",
	.event = "event=0xe0b4",
	.desc = "A TM-ineligible instruction tries to execute inside a transaction and the LSU disallows it",
	.topic = "other",
},
{
	.name = "pm_dside_mru_touch",
	.event = "event=0x26884",
	.desc = "D-side L2 MRU touch sent to L2",
	.topic = "other",
},
{
	.name = "pm_mrk_st_cmpl_int",
	.event = "event=0x30134",
	.desc = "marked store finished with intervention",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_sao",
	.event = "event=0xc0b8",
	.desc = "A load-hit-load condition with Strong Address Ordering will have address compare disabled and flush",
	.topic = "other",
},
{
	.name = "pm_eat_force_mispred",
	.event = "event=0x50a8",
	.desc = "XL-form branch was mispredicted due to the predicted target address missing from EAT.  The EAT forces a mispredict in this case since there is no predicated target to validate.  This is a rare case that may occur when the EAT is full and a branch is issued",
	.topic = "other",
},
{
	.name = "pm_l3_p2_co_rty",
	.event = "event=0x460ae",
	.desc = "L3 CO received retry port 2 (memory only), every retry counted",
	.topic = "other",
},
{
	.name = "pm_btac_good_result",
	.event = "event=0x58b0",
	.desc = "BTAC predicts a taken branch and the BHT agrees, and the target address is correct",
	.topic = "other",
},
{
	.name = "pm_data_from_ll4",
	.event = "event=0x1c04c",
	.desc = "The processor's data cache was reloaded from the local chip's L4 cache due to a demand load",
	.topic = "other",
},
{
	.name = "pm_tm_st_conf",
	.event = "event=0x3608e",
	.desc = "TM Store (fav or non-fav) ran into conflict (failed)",
	.topic = "other",
},
{
	.name = "pm_non_data_store",
	.event = "event=0xf8a0",
	.desc = "All ops that drain from s2q to L2 and contain no data",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l21_shr",
	.event = "event=0x3f146",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L2 on the same chip due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_br_uncond",
	.event = "event=0x40a0",
	.desc = "Unconditional Branch Completed. HW branch prediction was not used for this branch. This can be an I-form branch, a B-form branch with BO-field set to branch always, or a B-form branch which was covenrted to a Resolve",
	.topic = "other",
},
{
	.name = "pm_dc_pref_fuzzy_conf",
	.event = "event=0xf8a8",
	.desc = "A demand load referenced a line in an active fuzzy prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software.Fuzzy stream confirm (out of order effects, or pf cant keep up)",
	.topic = "other",
},
{
	.name = "pm_dc_pref_sw_alloc",
	.event = "event=0xf8a4",
	.desc = "Prefetch stream allocated by software prefetching",
	.topic = "other",
},
{
	.name = "pm_lsu2_tm_l1_miss",
	.event = "event=0xe0a0",
	.desc = "Load tm L1 miss",
	.topic = "other",
},
{
	.name = "pm_ls1_ld_vector_fin",
	.event = "event=0xc880",
	.desc = "",
	.topic = "other",
},
{
	.name = "pm_tm_outer_tend",
	.event = "event=0x2894",
	.desc = "Completion time outer tend",
	.topic = "other",
},
{
	.name = "pm_xlate_hpt_mode",
	.event = "event=0xf098",
	.desc = "LSU reports every cycle the thread is in HPT translation mode (as opposed to radix mode)",
	.topic = "other",
},
{
	.name = "pm_ld_miss_l1_fin",
	.event = "event=0x2c04e",
	.desc = "Number of load instructions that finished with an L1 miss. Note that even if a load spans multiple slices this event will increment only once per load op",
	.topic = "other",
},
{
	.name = "pm_mrk_lsu_derat_miss",
	.event = "event=0x30162",
	.desc = "Marked derat reload (miss) for any page size",
	.topic = "other",
},
{
	.name = "pm_data_from_rl2l3_shr",
	.event = "event=0x1c04a",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on the same Node or Group (Remote), as this chip due to a demand load",
	.topic = "other",
},
{
	.name = "pm_l3_p1_grp_pump",
	.event = "event=0x268b0",
	.desc = "L3 PF sent with grp scope port 1, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_srq_full",
	.event = "event=0x30016",
	.desc = "Finish stall because the NTF instruction was a store that was held in LSAQ because the SRQ was full",
	.topic = "other",
},
{
	.name = "pm_br_pred_ta",
	.event = "event=0x40b4",
	.desc = "Conditional Branch Completed that had its target address predicted. Only XL-form branches set this event.  This equal the sum of CCACHE, LSTACK, and PCACHE",
	.topic = "other",
},
{
	.name = "pm_br_mpred_ccache",
	.event = "event=0x40ac",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Count Cache Target Prediction",
	.topic = "other",
},
{
	.name = "pm_l2_rty_ld",
	.event = "event=0x3688a",
	.desc = "RC retries on PB for any load from core (excludes DCBFs)",
	.topic = "other",
},
{
	.name = "pm_lsu0_erat_hit",
	.event = "event=0xe08c",
	.desc = "Primary ERAT hit.  There is no secondary ERAT",
	.topic = "other",
},
{
	.name = "pm_ls2_erat_miss_pref",
	.event = "event=0xe088",
	.desc = "LS0 Erat miss due to prefetch",
	.topic = "other",
},
{
	.name = "pm_dc_pref_conf",
	.event = "event=0xf0a8",
	.desc = "A demand load referenced a line in an active prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software. Includes forwards and backwards streams",
	.topic = "other",
},
{
	.name = "pm_l2_loc_guess_wrong",
	.event = "event=0x16888",
	.desc = "L2 guess local (LNS) and guess was not correct (ie data not on chip)",
	.topic = "other",
},
{
	.name = "pm_tma_req_l2",
	.event = "event=0xe0a4",
	.desc = "addrs only req to L2 only on the first one,Indication that Load footprint is not expanding",
	.topic = "other",
},
{
	.name = "pm_data_from_l3_disp_conflict",
	.event = "event=0x3c042",
	.desc = "The processor's data cache was reloaded from local core's L3 with dispatch conflict due to a demand load",
	.topic = "other",
},
{
	.name = "pm_l3_p1_lco_no_data",
	.event = "event=0x168aa",
	.desc = "Dataless L3 LCO sent port 1",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_disp_conflict_other_cyc",
	.event = "event=0x3d140",
	.desc = "Duration in cycles to reload from local core's L2 with dispatch conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_ls1_launch_held_pref",
	.event = "event=0xc89c",
	.desc = "Number of times a load or store instruction was unable to launch/relaunch because a high priority prefetch used that relaunch cycle",
	.topic = "other",
},
{
	.name = "pm_ic_reload_private",
	.event = "event=0x4894",
	.desc = "Reloading line was brought in private for a specific thread.  Most lines are brought in shared for all eight threads.  If RA does not match then invalidates and then brings it shared to other thread. In P7 line brought in private , then line was invalidat",
	.topic = "other",
},
{
	.name = "pm_tm_ld_caused_fail",
	.event = "event=0x1688e",
	.desc = "Non-TM Load caused any thread to fail",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp_fail_other",
	.event = "event=0x26084",
	.desc = "All I-or-D side load dispatch attempts for this thread that failed due to reason other than address collision (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_mrk_l1_icache_miss",
	.event = "event=0x101e4",
	.desc = "sampled Instruction suffered an icache Miss",
	.topic = "other",
},
{
	.name = "pm_tm_nested_tbegin",
	.event = "event=0x20a0",
	.desc = "Completion Tm nested tbegin",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_mem",
	.event = "event=0x368aa",
	.desc = "L3 CO to memory port 1 with or without data",
	.topic = "other",
},
{
	.name = "pm_lsu3_false_lhs",
	.event = "event=0xc8a4",
	.desc = "False LHS match detected",
	.topic = "other",
},
{
	.name = "pm_l3_ld_pref",
	.event = "event=0xf0b0",
	.desc = "L3 load prefetch, sourced from a hardware or software stream, was sent to the nest",
	.topic = "other",
},
{
	.name = "pm_pmc3_saved",
	.event = "event=0x4d012",
	.desc = "PMC3 Rewind Value saved",
	.topic = "other",
},
{
	.name = "pm_ls3_erat_miss_pref",
	.event = "event=0xe888",
	.desc = "LS1 Erat miss due to prefetch",
	.topic = "other",
},
{
	.name = "pm_l3_rd0_busy",
	.event = "event=0x368b4",
	.desc = "Lifetime, sample of RD machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l2_disp_all_l2miss",
	.event = "event=0x46080",
	.desc = "All successful Ld/St dispatches for this thread that were an L2 miss (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_l3_pf_miss_l3",
	.event = "event=0x160a0",
	.desc = "L3 PF missed in L3",
	.topic = "other",
},
{
	.name = "pm_l1_demand_write",
	.event = "event=0x408c",
	.desc = "Instruction Demand sectors written into IL1",
	.topic = "other",
},
{
	.name = "pm_sn_invl",
	.event = "event=0x368a8",
	.desc = "Any port snooper detects a store to a line in the Sx state and invalidates the line.  Up to 4 can happen in a cycle but we only count 1",
	.topic = "other",
},
{
	.name = "pm_l3_loc_guess_correct",
	.event = "event=0x160b2",
	.desc = "initial scope=node/chip (LNS) and data from local node (local) (pred successful) - always PFs only",
	.topic = "other",
},
{
	.name = "pm_decode_fusion_const_gen",
	.event = "event=0x48b4",
	.desc = "32-bit constant generation",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l21_mod",
	.event = "event=0x4d146",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L2 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_s2q_full",
	.event = "event=0xe080",
	.desc = "Cycles during which the S2Q is full",
	.topic = "other",
},
{
	.name = "pm_l3_p3_lco_rty",
	.event = "event=0x268b4",
	.desc = "L3 initiated LCO received retry on port 3 (can try 4 times)",
	.topic = "other",
},
{
	.name = "pm_lsu0_lmq_s0_valid",
	.event = "event=0xd8b8",
	.desc = "Slot 0 of LMQ valid",
	.topic = "other",
},
{
	.name = "pm_tm_nested_tend",
	.event = "event=0x2098",
	.desc = "Completion time nested tend",
	.topic = "other",
},
{
	.name = "pm_l3_pf_off_chip_cache",
	.event = "event=0x368a0",
	.desc = "L3 PF from Off chip cache",
	.topic = "other",
},
{
	.name = "pm_taken_br_mpred_cmpl",
	.event = "event=0x20056",
	.desc = "Total number of taken branches that were incorrectly predicted as not-taken. This event counts branches completed and does not include speculative instructions",
	.topic = "other",
},
{
	.name = "pm_l2_sys_pump",
	.event = "event=0x4688a",
	.desc = "RC requests that were system pump attempts",
	.topic = "other",
},
{
	.name = "pm_lsu2_erat_hit",
	.event = "event=0xe090",
	.desc = "Primary ERAT hit.  There is no secondary ERAT",
	.topic = "other",
},
{
	.name = "pm_inst_imc_match_cmpl",
	.event = "event=0x4001c",
	.desc = "IMC Match Count",
	.topic = "other",
},
{
	.name = "pm_br_pred_lstack",
	.event = "event=0x40a8",
	.desc = "Conditional Branch Completed  that used the Link Stack for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_l3_ci_miss",
	.event = "event=0x268a2",
	.desc = "L3 castins miss (total count)",
	.topic = "other",
},
{
	.name = "pm_tm_non_fav_tbegin",
	.event = "event=0x289c",
	.desc = "Dispatch time non favored tbegin",
	.topic = "other",
},
{
	.name = "pm_lsu2_store_reject",
	.event = "event=0xf08c",
	.desc = "All internal store rejects cause the instruction to go back to the SRQ and go to sleep until woken up to try again after the condition has been met",
	.topic = "other",
},
{
	.name = "pm_l3_pf_on_chip_cache",
	.event = "event=0x360a0",
	.desc = "L3 PF from On chip cache",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2miss_cyc",
	.event = "event=0x35152",
	.desc = "Duration in cycles to reload from a location other than the local core's L2 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l3_sn_usage",
	.event = "event=0x160ac",
	.desc = "Rotating sample of 16 snoop valids",
	.topic = "other",
},
{
	.name = "pm_rc0_busy",
	.event = "event=0x1608c",
	.desc = "RC mach 0 Busy. Used by PMU to sample ave RC lifetime (mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_l2_ld_disp",
	.event = "event=0x36082",
	.desc = "All successful I-or-D side load dispatches for this thread (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_l3_sw_pref",
	.event = "event=0xf8b0",
	.desc = "L3 load prefetch, sourced from a software prefetch stream, was sent to the nest",
	.topic = "other",
},
{
	.name = "pm_tablewalk_cyc_pref",
	.event = "event=0xf884",
	.desc = "tablewalk qualified for pte  prefetches",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_eco_mod",
	.event = "event=0x4d144",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp_fail_addr",
	.event = "event=0x16884",
	.desc = "All I-od-D side load dispatch attempts for this thread that failed due to address collision with RC/CO/SN/SQ machine (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_l3_pf_on_chip_mem",
	.event = "event=0x460a0",
	.desc = "L3 PF from On chip memory",
	.topic = "other",
},
{
	.name = "pm_pte_prefetch",
	.event = "event=0xf084",
	.desc = "PTE prefetches",
	.topic = "other",
},
{
	.name = "pm_radix_pwc_l1_pde_from_l2",
	.event = "event=0x2d026",
	.desc = "A Page Directory Entry was reloaded to a level 1 page walk cache from the core's L2 data cache",
	.topic = "other",
},
{
	.name = "pm_br_mpred_pcache",
	.event = "event=0x48b0",
	.desc = "Conditional Branch Completed that was Mispredicted due to pattern cache prediction",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2",
	.event = "event=0x2c126",
	.desc = "The processor's data cache was reloaded from local core's L2 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_tm_fail_tlbie",
	.event = "event=0xe0ac",
	.desc = "Transaction failed because there was a TLBIE hit in the bloom filter",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_data",
	.event = "event=0x260aa",
	.desc = "LCO sent with data port 0",
	.topic = "other",
},
{
	.name = "pm_ic_pref_req",
	.event = "event=0x4888",
	.desc = "Instruction prefetch requests",
	.topic = "other",
},
{
	.name = "pm_ic_pref_write",
	.event = "event=0x488c",
	.desc = "Instruction prefetch written into IL1",
	.topic = "other",
},
{
	.name = "pm_xlate_miss",
	.event = "event=0xf89c",
	.desc = "The LSU requested a line from L2 for translation.  It may be satisfied from any source beyond L2.  Includes speculative instructions",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_no_conflict_cyc",
	.event = "event=0x14158",
	.desc = "Duration in cycles to reload from local core's L2 without conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_shr_cyc",
	.event = "event=0x35156",
	.desc = "Duration in cycles to reload with Shared (S) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_tm_rst_sc",
	.event = "event=0x268a6",
	.desc = "TM-snp rst RM SC",
	.topic = "other",
},
{
	.name = "pm_l3_trans_pf",
	.event = "event=0x468a4",
	.desc = "L3 Transient prefetch received from L2",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_l2",
	.event = "event=0x4094",
	.desc = "L2 Squashed a demand or prefetch request",
	.topic = "other",
},
{
	.name = "pm_br_mpred_lstack",
	.event = "event=0x48ac",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Link Stack Target Prediction",
	.topic = "other",
},
{
	.name = "pm_lsu1_erat_hit",
	.event = "event=0xe88c",
	.desc = "Primary ERAT hit.  There is no secondary ERAT",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_wrk_arnd",
	.event = "event=0xc0b4",
	.desc = "LSU workaround flush.  These flushes are setup with programmable scan only latches to perform various actions when the flush macro receives a trigger from the dbg macros. These actions include things like flushing the next op encountered for a particular thread or flushing the next op that is NTC op that is encountered on a particular slice. The kind of flush that the workaround is setup to perform is highly variable",
	.topic = "other",
},
{
	.name = "pm_partial_st_fin",
	.event = "event=0x34054",
	.desc = "Any store finished by an LSU slice",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_6_7_cyc",
	.event = "event=0x5880",
	.desc = "Cycles thread running at priority level 6 or 7",
	.topic = "other",
},
{
	.name = "pm_ic_demand_l2_br_redirect",
	.event = "event=0x4898",
	.desc = "L2 I cache demand request due to branch Mispredict ( 15 cycle path)",
	.topic = "other",
},
{
	.name = "pm_bank_conflict",
	.event = "event=0x4880",
	.desc = "Read blocked due to interleave conflict.  The ifar logic will detect an interleave conflict and kill the data that was read that cycle",
	.topic = "other",
},
{
	.name = "pm_l3_p0_sys_pump",
	.event = "event=0x360b0",
	.desc = "L3 PF sent with sys scope port 0, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_ierat_reload_64k",
	.event = "event=0x3006a",
	.desc = "IERAT Reloaded (Miss) for a 64k page",
	.topic = "other",
},
{
	.name = "pm_lsu2_3_lrqf_full_cyc",
	.event = "event=0xd8bc",
	.desc = "Counts the number of cycles the LRQF is full.  LRQF is the queue that holds loads between finish and completion.  If it fills up, instructions stay in LRQ until completion, potentially backing up the LRQ",
	.topic = "other",
},
{
	.name = "pm_l2_sn_m_rd_done",
	.event = "event=0x46086",
	.desc = "SNP dispatched for a read and was M (true M)",
	.topic = "other",
},
{
	.name = "pm_mrk_fab_rsp_bkill",
	.event = "event=0x40154",
	.desc = "Marked store had to do a bkill",
	.topic = "other",
},
{
	.name = "pm_lsu2_l1_cam_cancel",
	.event = "event=0xf094",
	.desc = "ls2 l1 tm cam cancel",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_lrq_full",
	.event = "event=0x2d014",
	.desc = "Finish stall because the NTF instruction was a load that was held in LSAQ (load-store address queue) because the LRQ (load-reorder queue) was full",
	.topic = "other",
},
{
	.name = "pm_l3_co_mepf",
	.event = "event=0x3e05e",
	.desc = "L3 CO of line in Mep state (includes casthrough to memory).  The Mepf state indicates that a line was brought in to satisfy an L3 prefetch request",
	.topic = "other",
},
{
	.name = "pm_l3_lat_ci_hit",
	.event = "event=0x460a2",
	.desc = "L3 Lateral Castins Hit",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dl2l3_mod",
	.event = "event=0x3d14e",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mult_mrk",
	.event = "event=0x3d15e",
	.desc = "mult marked instr",
	.topic = "other",
},
{
	.name = "pm_eat_full_cyc",
	.event = "event=0x4084",
	.desc = "Cycles No room in EAT",
	.topic = "other",
},
{
	.name = "pm_link_stack_wrong_add_pred",
	.event = "event=0x5098",
	.desc = "Link stack predicts wrong address, because of link stack design limitation or software violating the coding conventions",
	.topic = "other",
},
{
	.name = "pm_data_grp_pump_cpred",
	.event = "event=0x2c050",
	.desc = "Initial and Final Pump Scope was group pump (prediction=correct) for a demand load",
	.topic = "other",
},
{
	.name = "pm_lsu2_false_lhs",
	.event = "event=0xc0a4",
	.desc = "False LHS match detected",
	.topic = "other",
},
{
	.name = "pm_link_stack_correct",
	.event = "event=0x58a0",
	.desc = "Link stack predicts right address",
	.topic = "other",
},
{
	.name = "pm_dtlb_miss_1g",
	.event = "event=0x4c05a",
	.desc = "Data TLB reload (after a miss) page size 1G. Implies radix translation was used",
	.topic = "other",
},
{
	.name = "pm_l2_sn_sx_i_done",
	.event = "event=0x36886",
	.desc = "SNP dispatched and went from Sx to Ix",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_off_chip_cache",
	.event = "event=0x4e04a",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dl4_cyc",
	.event = "event=0x2c12c",
	.desc = "Duration in cycles to reload from another chip's L4 on a different Node or Group (Distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_tm_ld_conf",
	.event = "event=0x2608e",
	.desc = "TM Load (fav or non-fav) ran into conflict (failed)",
	.topic = "other",
},
{
	.name = "pm_inst_from_l1",
	.event = "event=0x4080",
	.desc = "Instruction fetches from L1.  L1 instruction hit",
	.topic = "other",
},
{
	.name = "pm_lsu3_tm_l1_hit",
	.event = "event=0xe898",
	.desc = "Load tm hit in L1",
	.topic = "other",
},
{
	.name = "pm_l3_co_mem",
	.event = "event=0x260a0",
	.desc = "L3 CO to memory OR of port 0 and 1 (lossy = may undercount if two cresp come in the same cyc)",
	.topic = "other",
},
{
	.name = "pm_l2_castout_mod",
	.event = "event=0x16082",
	.desc = "L2 Castouts - Modified (M,Mu,Me)",
	.topic = "other",
},
{
	.name = "pm_ls0_launch_held_pref",
	.event = "event=0xc09c",
	.desc = "Number of times a load or store instruction was unable to launch/relaunch because a high priority prefetch used that relaunch cycle",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_larx_stcx",
	.event = "event=0xc8b8",
	.desc = "A larx is flushed because an older larx has an LMQ reservation for the same thread.  A stcx is flushed because an older stcx is in the LMQ.  The flush happens when the older larx/stcx relaunches",
	.topic = "other",
},
{
	.name = "pm_non_tm_rst_sc",
	.event = "event=0x260a6",
	.desc = "Non-TM snp rst TM SC",
	.topic = "other",
},
{
	.name = "pm_l2_rty_st",
	.event = "event=0x3608a",
	.desc = "RC retries on PB for any store from core (excludes DCBFs)",
	.topic = "other",
},
{
	.name = "pm_inst_from_l2_mepf",
	.event = "event=0x24040",
	.desc = "The processor's Instruction cache was reloaded from local core's L2 hit without dispatch conflicts on Mepf state. due to an instruction fetch (not prefetch)",
	.topic = "other",
},
{
	.name = "pm_tm_fav_tbegin",
	.event = "event=0x209c",
	.desc = "Dispatch time Favored tbegin",
	.topic = "other",
},
{
	.name = "pm_ict_noslot_disp_held_issq",
	.event = "event=0x2d01e",
	.desc = "Ict empty for this thread due to dispatch hold on this thread due to Issue q full, BRQ full, XVCF Full, Count cache, Link, Tar full",
	.topic = "other",
},
{
	.name = "pm_flush_mpred",
	.event = "event=0x50a4",
	.desc = "Branch mispredict flushes.  Includes target and address misprecition",
	.topic = "other",
},
{
	.name = "pm_shl_created",
	.event = "event=0x508c",
	.desc = "Store-Hit-Load Table Entry Created",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_ll4",
	.event = "event=0x1504c",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's L4 cache due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_l3_ld_miss",
	.event = "event=0x268a4",
	.desc = "L3 Misses for demand LDs",
	.topic = "other",
},
{
	.name = "pm_l2_grp_guess_correct",
	.event = "event=0x26088",
	.desc = "L2 guess grp (GS or NNS) and guess was correct (data intra-group AND ^on-chip)",
	.topic = "other",
},
{
	.name = "pm_lsu0_ldmx_fin",
	.event = "event=0xd088",
	.desc = "New P9 instruction LDMX. The definition of this new PMU event is (from the ldmx RFC02491):  The thread has executed an ldmx instruction that accessed a doubleword that contains an effective address within an enabled section of the Load Monitored region.  This event, therefore, should not occur if the FSCR has disabled the load monitored facility (FSCR[52]) or disabled the EBB facility (FSCR[56])",
	.topic = "other",
},
{
	.name = "pm_ls1_tm_disallow",
	.event = "event=0xe8b4",
	.desc = "A TM-ineligible instruction tries to execute inside a transaction and the LSU disallows it",
	.topic = "other",
},
{
	.name = "pm_rc_usage",
	.event = "event=0x1688c",
	.desc = "Continuous 16 cycle (2to1) window where this signals rotates thru sampling each RC machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_radix_pwc_l4_pte_from_l3miss",
	.event = "event=0x3f054",
	.desc = "A Page Table Entry was reloaded to a level 4 page walk cache from beyond the core's L3 data cache. This is the deepest level of PWC possible for a translation. The source could be local/remote/distant memory or another core's cache",
	.topic = "other",
},
{
	.name = "pm_iside_disp_fail_addr",
	.event = "event=0x2608a",
	.desc = "All I-side dispatch attempts for this thread that failed due to a addr collision with another machine (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_tage_correct_taken_cmpl",
	.event = "event=0x50b4",
	.desc = "The TAGE overrode BHT direction prediction and it was correct.  Counted at completion for taken branches only",
	.topic = "other",
},
{
	.name = "pm_disp_clb_held_sb",
	.event = "event=0x2090",
	.desc = "Dispatch/CLB Hold: Scoreboard",
	.topic = "other",
},
{
	.name = "pm_tm_fail_non_tx_conflict",
	.event = "event=0xe0b0",
	.desc = "Non transactional conflict from LSU, gets reported to TEXASR",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_memory",
	.event = "event=0x201e0",
	.desc = "The processor's data cache was reloaded from a memory location including L4 from local remote or distant due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l3_l2_co_miss",
	.event = "event=0x368a2",
	.desc = "L2 CO miss",
	.topic = "other",
},
{
	.name = "pm_co0_busy",
	.event = "event=0x3608c",
	.desc = "CO mach 0 Busy. Used by PMU to sample ave CO lifetime (mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_disp_conflict_cyc",
	.event = "event=0x2c122",
	.desc = "Duration in cycles to reload from local core's L3 with dispatch conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_cyc",
	.event = "event=0x35154",
	.desc = "Duration in cycles to reload from local core's L3 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_mod_cyc",
	.event = "event=0x1d140",
	.desc = "Duration in cycles to reload with Modified (M) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_inst_from_off_chip_cache",
	.event = "event=0x4404a",
	.desc = "The processor's Instruction cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to an instruction fetch (not prefetch)",
	.topic = "other",
},
{
	.name = "pm_tm_fail_self",
	.event = "event=0x28ac",
	.desc = "TM aborted because a self-induced conflict occurred in Suspended state, due to one of the following: a store to a storage location that was previously accessed transactionally; a dcbf, dcbi, or icbi specify- ing a block that was previously accessed transactionally; a dcbst specifying a block that was previously written transactionally; or a tlbie that specifies a translation that was pre- viously used transactionally",
	.topic = "other",
},
{
	.name = "pm_scalar_flop_cmpl",
	.event = "event=0x45056",
	.desc = "Scalar flop operation completed",
	.topic = "other",
},
{
	.name = "pm_l2_ld_miss_128b",
	.event = "event=0x16092",
	.desc = "All successful D-side load dispatches that were an L2 miss (NOT Sx,Tx,Mx) for this thread and the RC calculated the request should be for 128B (i.e., M=0)",
	.topic = "other",
},
{
	.name = "pm_stcx_fin",
	.event = "event=0x2e014",
	.desc = "Number of stcx instructions finished. This includes instructions in the speculative path of a branch that may be flushed",
	.topic = "other",
},
{
	.name = "pm_ls2_tm_disallow",
	.event = "event=0xe0b8",
	.desc = "A TM-ineligible instruction tries to execute inside a transaction and the LSU disallows it",
	.topic = "other",
},
{
	.name = "pm_tm_outer_tbegin",
	.event = "event=0x2094",
	.desc = "Completion time outer tbegin",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_rty",
	.event = "event=0x160b4",
	.desc = "L3 initiated LCO received retry on port 0 (can try 4 times)",
	.topic = "other",
},
{
	.name = "pm_dside_other_64b_l2memacc",
	.event = "event=0x36892",
	.desc = "Valid when first beat of data comes in for an D-side fetch where data came EXCLUSIVELY from memory that was for hpc_read64, (RC had to fetch other 64B of a line from MC) i.e., number of times RC had to go to memory to get 'missing' 64B",
	.topic = "other",
},
{
	.name = "pm_tm_fail_footprint_overflow",
	.event = "event=0x20a8",
	.desc = "TM aborted because the tracking limit for transactional storage accesses was exceeded.. Asynchronous",
	.topic = "other",
},
{
	.name = "pm_ict_noslot_disp_held_hb_full",
	.event = "event=0x30018",
	.desc = "Ict empty for this thread due to dispatch holds because the History Buffer was full. Could be GPR/VSR/VMR/FPR/CR/XVF; CR; XVF (XER/VSCR/FPSCR)",
	.topic = "other",
},
{
	.name = "pm_l3_l2_co_hit",
	.event = "event=0x360a2",
	.desc = "L2 CO hits",
	.topic = "other",
},
{
	.name = "pm_dside_l2memacc",
	.event = "event=0x36092",
	.desc = "Valid when first beat of data comes in for an D-side fetch where data came EXCLUSIVELY from memory (excluding hpcread64 accesses), i.e., total memory accesses by RCs",
	.topic = "other",
},
{
	.name = "pm_mrk_br_2path",
	.event = "event=0x10138",
	.desc = "marked branches which are not strongly biased",
	.topic = "other",
},
{
	.name = "pm_isync",
	.event = "event=0x2884",
	.desc = "Isync completion count per thread",
	.topic = "other",
},
{
	.name = "pm_l2_castout_shr",
	.event = "event=0x16882",
	.desc = "L2 Castouts - Shared (Tx,Sx)",
	.topic = "other",
},
{
	.name = "pm_l2_ld_miss_64b",
	.event = "event=0x26092",
	.desc = "All successful D-side load dispatches that were an L2 miss (NOT Sx,Tx,Mx) for this thread and the RC calculated the request should be for 64B(i.e., M=1)",
	.topic = "other",
},
{
	.name = "pm_l2_ld_miss",
	.event = "event=0x26080",
	.desc = "All successful D-Side Load dispatches that were an L2 miss for this thread",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dmem",
	.event = "event=0x3d14c",
	.desc = "The processor's data cache was reloaded from another chip's memory on the same Node or Group (Distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_any_thrd_run_cyc",
	.event = "event=0x100fa",
	.desc = "Cycles in which at least one thread has the run latch set",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_rmem_cyc",
	.event = "event=0x2c12a",
	.desc = "Duration in cycles to reload from another chip's memory on the same Node or Group ( Remote) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_lmem",
	.event = "event=0x25048",
	.desc = "A Page Table Entry was loaded into the TLB from the local chip's Memory due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_islb_miss",
	.event = "event=0xd8a8",
	.desc = "Instruction SLB Miss - Total of all segment sizes",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_rty",
	.event = "event=0x368ae",
	.desc = "L3 CO received retry port 1 (memory only), every retry counted",
	.topic = "other",
},
{
	.name = "pm_l3_ci_hit",
	.event = "event=0x260a2",
	.desc = "L3 Castins Hit (total count)",
	.topic = "other",
},
{
	.name = "pm_vector_ld_cmpl",
	.event = "event=0x44054",
	.desc = "Number of vector load instructions completed",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_nested_tbegin",
	.event = "event=0x1e05c",
	.desc = "Completion stall because the ISU is updating the TEXASR to keep track of the nested tbegin. This is a short delay, and it includes ROT",
	.topic = "other",
},
{
	.name = "pm_ls2_ld_vector_fin",
	.event = "event=0xc084",
	.desc = "",
	.topic = "other",
},
{
	.name = "pm_st_caused_fail",
	.event = "event=0x1608e",
	.desc = "Non-TM Store caused any thread to fail",
	.topic = "other",
},
{
	.name = "pm_isu0_iss_hold_all",
	.event = "event=0x3080",
	.desc = "All ISU rejects",
	.topic = "other",
},
{
	.name = "pm_sync_mrk_l2miss",
	.event = "event=0x1515a",
	.desc = "Marked L2 Miss that can throw a synchronous interrupt",
	.topic = "other",
},
{
	.name = "pm_l2_st_miss_64b",
	.event = "event=0x26892",
	.desc = "All successful D-side store dispatches that were an L2 miss (NOT Sx,Tx,Mx) for this thread and the RC calculated the request should be for 64B (i.e., M=1)",
	.topic = "other",
},
{
	.name = "pm_co_usage",
	.event = "event=0x2688c",
	.desc = "Continuous 16 cycle (2to1) window where this signals rotates thru sampling each CO machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_br_mpred_taken_ta",
	.event = "event=0x48b8",
	.desc = "Conditional Branch Completed that was Mispredicted due to the Target Address Prediction from the Count Cache or Link Stack.  Only XL-form branches that resolved Taken set this event",
	.topic = "other",
},
{
	.name = "pm_btac_bad_result",
	.event = "event=0x50b0",
	.desc = "BTAC thinks branch will be taken but it is either predicted not-taken by the BHT, or the target address is wrong (less common).  In both cases, a redirect will happen",
	.topic = "other",
},
{
	.name = "pm_lsu1_ldmx_fin",
	.event = "event=0xd888",
	.desc = "New P9 instruction LDMX. The definition of this new PMU event is (from the ldmx RFC02491):  The thread has executed an ldmx instruction that accessed a doubleword that contains an effective address within an enabled section of the Load Monitored region.  This event, therefore, should not occur if the FSCR has disabled the load monitored facility (FSCR[52]) or disabled the EBB facility (FSCR[56])",
	.topic = "other",
},
{
	.name = "pm_tage_correct",
	.event = "event=0x58b4",
	.desc = "The TAGE overrode BHT direction prediction and it was correct.   Includes taken and not taken and is counted at execution time",
	.topic = "other",
},
{
	.name = "pm_sn_usage",
	.event = "event=0x3688c",
	.desc = "Continuous 16 cycle (2to1) window where this signals rotates thru sampling each SN machine busy. PMU uses this wave to then do 16 cyc count to sample total number of machs running",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp_fail_other",
	.event = "event=0x46084",
	.desc = "All D-side store dispatch attempts for this thread that failed due to reason other than address collision",
	.topic = "other",
},
{
	.name = "pm_dc_pref_strided_conf",
	.event = "event=0xf0ac",
	.desc = "A demand load referenced a line in an active strided prefetch stream. The stream could have been allocated through the hardware prefetch mechanism or through software",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp",
	.event = "event=0x36084",
	.desc = "All D-side store dispatch attempts for this thread",
	.topic = "other",
},
{
	.name = "pm_fma_cmpl",
	.event = "event=0x45054",
	.desc = "two flops operation completed (fmadd, fnmadd, fmsub, fnmsub) Scalar instructions only. ",
	.topic = "other",
},
{
	.name = "pm_thresh_exc_512",
	.event = "event=0x201e8",
	.desc = "Threshold counter exceeded a value of 512",
	.topic = "other",
},
{
	.name = "pm_l2_inst",
	.event = "event=0x36080",
	.desc = "All successful I-side dispatches for this thread   (excludes i_l2mru_tch reqs)",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_dl4",
	.event = "event=0x3504c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on a different Node or Group (Distant) due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ls1_dc_collisions",
	.event = "event=0xd890",
	.desc = "Read-write data cache collisions",
	.topic = "other",
},
{
	.name = "pm_iside_disp",
	.event = "event=0x1688a",
	.desc = "All I-side dispatch attempts for this thread (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_l3_p1_co_l31",
	.event = "event=0x468aa",
	.desc = "L3 CO to L3.1 (LCO) port 1 with or without data",
	.topic = "other",
},
{
	.name = "pm_disp_held_tbegin",
	.event = "event=0x28b0",
	.desc = "This outer tbegin transaction cannot be dispatched until the previous tend instruction completes",
	.topic = "other",
},
{
	.name = "pm_lsu3_tm_l1_miss",
	.event = "event=0xe8a0",
	.desc = "Load tm L1 miss",
	.topic = "other",
},
{
	.name = "pm_inst_grp_pump_mpred",
	.event = "event=0x2c05e",
	.desc = "Final Pump Scope (Group) ended up either larger or smaller than Initial Pump Scope for an instruction fetch (demand only)",
	.topic = "other",
},
{
	.name = "pm_stcx_success_cmpl",
	.event = "event=0xc8bc",
	.desc = "Number of stcx instructions that completed successfully",
	.topic = "other",
},
{
	.name = "pm_lsu2_tm_l1_hit",
	.event = "event=0xe098",
	.desc = "Load tm hit in L1",
	.topic = "other",
},
{
	.name = "pm_inst_from_l31_eco_mod",
	.event = "event=0x44044",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's ECO L3 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
},
{
	.name = "pm_co_disp_fail",
	.event = "event=0x16886",
	.desc = "CO dispatch failed due to all CO machines being busy",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_no_conflict",
	.event = "event=0x3d146",
	.desc = "The processor's data cache was reloaded from local core's L3 without conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l2_st_miss_128b",
	.event = "event=0x16892",
	.desc = "All successful D-side store dispatches that were an L2 miss (NOT Sx,Tx,Mx) for this thread and the RC calculated the request should be for 128B (i.e., M=0)",
	.topic = "other",
},
{
	.name = "pm_iside_l2memacc",
	.event = "event=0x26890",
	.desc = "Valid when first beat of data comes in for an I-side fetch where data came from memory",
	.topic = "other",
},
{
	.name = "pm_ls2_dc_collisions",
	.event = "event=0xd094",
	.desc = "Read-write data cache collisions",
	.topic = "other",
},
{
	.name = "pm_mem_rwitm",
	.event = "event=0x3c05e",
	.desc = "Memory Read With Intent to Modify for this thread",
	.topic = "other",
},
{
	.name = "pm_lsu_stcx",
	.event = "event=0xc090",
	.desc = "STCX sent to nest, i.e. total",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_no_conflict",
	.event = "event=0x2c120",
	.desc = "The processor's data cache was reloaded from local core's L2 without conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l2_rc_st_done",
	.event = "event=0x36086",
	.desc = "RC did store to line that was Tx or Sx",
	.topic = "other",
},
{
	.name = "pm_tm_fail_tx_conflict",
	.event = "event=0xe8ac",
	.desc = "Transactional conflict from LSU, gets reported to TEXASR",
	.topic = "other",
},
{
	.name = "pm_decode_fusion_ld_st_disp",
	.event = "event=0x48a8",
	.desc = "32-bit displacement D-form and 16-bit displacement X-form",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2_mepf_cyc",
	.event = "event=0x3d144",
	.desc = "Duration in cycles to reload from local core's L2 hit without dispatch conflicts on Mepf state. due to a marked load",
	.topic = "other",
},
{
	.name = "pm_inst_from_l21_mod",
	.event = "event=0x44046",
	.desc = "The processor's Instruction cache was reloaded with Modified (M) data from another core's L2 on the same chip due to an instruction fetch (not prefetch)",
	.topic = "other",
},
{
	.name = "pm_br_pred_taken_cr",
	.event = "event=0x40b0",
	.desc = "Conditional Branch that had its direction predicted. I-form branches do not set this event.  In addition, B-form branches which do not use the BHT do not set this event - these are branches with BO-field set to 'always taken' and branches",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l2_no_conflict",
	.event = "event=0x15040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 without conflict due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_l3_disp_conflict",
	.event = "event=0x35042",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L3 with dispatch conflict due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_xlate_radix_mode",
	.event = "event=0xf898",
	.desc = "LSU reports every cycle the thread is in radix translation mode (as opposed to HPT mode)",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_mepf",
	.event = "event=0x2d142",
	.desc = "The processor's data cache was reloaded from local core's L3 without dispatch conflicts hit on Mepf state. due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l3_p0_node_pump",
	.event = "event=0x160b0",
	.desc = "L3 PF sent with nodal scope port 0, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_lsu3_ldmx_fin",
	.event = "event=0xd88c",
	.desc = "New P9 instruction LDMX. The definition of this new PMU event is (from the ldmx RFC02491):  The thread has executed an ldmx instruction that accessed a doubleword that contains an effective address within an enabled section of the Load Monitored region.  This event, therefore, should not occur if the FSCR has disabled the load monitored facility (FSCR[52]) or disabled the EBB facility (FSCR[56])",
	.topic = "other",
},
{
	.name = "pm_l2_ld_hit",
	.event = "event=0x36882",
	.desc = "All successful I-or-D side load dispatches for this thread that were L2 hits (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_l3_ci_usage",
	.event = "event=0x168ac",
	.desc = "Rotating sample of 16 CI or CO actives",
	.topic = "other",
},
{
	.name = "pm_mrk_fxu_fin",
	.event = "event=0x20134",
	.desc = "fxu marked instr finish",
	.topic = "other",
},
{
	.name = "pm_tm_cap_overflow",
	.event = "event=0x4608e",
	.desc = "TM Footprint Capacity Overflow",
	.topic = "other",
},
{
	.name = "pm_radix_pwc_l2_pte_from_l3miss",
	.event = "event=0x4f05c",
	.desc = "A Page Table Entry was reloaded to a level 2 page walk cache from beyond the core's L3 data cache. This implies that level 3 and level 4 PWC accesses were not necessary for this translation. The source could be local/remote/distant memory or another core's cache",
	.topic = "other",
},
{
	.name = "pm_probe_nop_disp",
	.event = "event=0x40014",
	.desc = "ProbeNops dispatched",
	.topic = "other",
},
{
	.name = "pm_decode_hold_ict_full",
	.event = "event=0x58a8",
	.desc = "Counts the number of cycles in which the IFU was not able to decode and transmit one or more instructions because all itags were in use.  This means the ICT is full for this thread",
	.topic = "other",
},
{
	.name = "pm_grp_pump_mpred_rty",
	.event = "event=0x10052",
	.desc = "Final Pump Scope (Group) ended up larger than Initial Pump Scope (Chip) for all data types excluding data prefetch (demand load,inst prefetch,inst fetch,xlate)",
	.topic = "other",
},
{
	.name = "pm_back_br_cmpl",
	.event = "event=0x2505e",
	.desc = "Branch instruction completed with a target address less than current instruction address",
	.topic = "other",
},
{
	.name = "pm_iside_disp_fail_other",
	.event = "event=0x2688a",
	.desc = "All I-side dispatch attempts for this thread that failed due to a reason other than addrs collision (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_ntc_all_fin",
	.event = "event=0x2001a",
	.desc = "Cycles after instruction finished to instruction completed",
	.topic = "other",
},
{
	.name = "pm_isq_0_8_entries",
	.event = "event=0x3005a",
	.desc = "Cycles in which 8 or less Issue Queue entries are in use. This is a shared event, not per thread",
	.topic = "other",
},
{
	.name = "pm_mrk_back_br_cmpl",
	.event = "event=0x3515e",
	.desc = "Marked branch instruction completed with a target address less than current instruction address",
	.topic = "other",
},
{
	.name = "pm_lsu1_l1_cam_cancel",
	.event = "event=0xf890",
	.desc = "ls1 l1 tm cam cancel",
	.topic = "other",
},
{
	.name = "pm_l3_p3_pf_rty",
	.event = "event=0x268ae",
	.desc = "L3 PF received retry port 3, every retry counted",
	.topic = "other",
},
{
	.name = "pm_ls1_erat_miss_pref",
	.event = "event=0xe884",
	.desc = "LS1 Erat miss due to prefetch",
	.topic = "other",
},
{
	.name = "pm_lsu1_tm_l1_miss",
	.event = "event=0xe89c",
	.desc = "Load tm L1 miss",
	.topic = "other",
},
{
	.name = "pm_tm_fail_conf_non_tm",
	.event = "event=0x28a8",
	.desc = "TM aborted because a conflict occurred with a non-transactional access by another processor",
	.topic = "other",
},
{
	.name = "pm_l1pf_l2memacc",
	.event = "event=0x16890",
	.desc = "Valid when first beat of data comes in for an L1PF where data came from memory",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_dmem",
	.event = "event=0x4504c",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's memory on the same Node or Group (Distant) due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_lmq_merge",
	.event = "event=0x1002e",
	.desc = "A demand miss collides with a prefetch for the same line",
	.topic = "other",
},
{
	.name = "pm_l3_wi0_busy",
	.event = "event=0x160b6",
	.desc = "Rotating sample of 8 WI valid (duplicate)",
	.topic = "other",
},
{
	.name = "pm_l3_co0_busy",
	.event = "event=0x368ac",
	.desc = "Lifetime, sample of CO machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l2_mepf",
	.event = "event=0x2e040",
	.desc = "A Page Table Entry was loaded into the TLB from local core's L2 hit without dispatch conflicts on Mepf state. due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dl4",
	.event = "event=0x1d152",
	.desc = "The processor's data cache was reloaded from another chip's L4 on a different Node or Group (Distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_iside_mru_touch",
	.event = "event=0x46880",
	.desc = "I-side L2 MRU touch sent to L2 for this thread",
	.topic = "other",
},
{
	.name = "pm_dtlb_miss_2m",
	.event = "event=0x1c05c",
	.desc = "Data TLB reload (after a miss) page size 2M. Implies radix translation was used",
	.topic = "other",
},
{
	.name = "pm_tage_override_wrong",
	.event = "event=0x50b8",
	.desc = "The TAGE overrode BHT direction prediction but it was incorrect.  Counted at completion for taken branches only",
	.topic = "other",
},
{
	.name = "pm_l3_p0_pf_rty",
	.event = "event=0x160ae",
	.desc = "L3 PF received retry port 0, every retry counted",
	.topic = "other",
},
{
	.name = "pm_l3_loc_guess_wrong",
	.event = "event=0x268b2",
	.desc = "Initial scope=node (LNS) but data from out side local node (near or far or rem). Prediction too Low",
	.topic = "other",
},
{
	.name = "pm_l2_sys_guess_correct",
	.event = "event=0x36088",
	.desc = "L2 guess system (VGS or RNS) and guess was correct (ie data beyond-group)",
	.topic = "other",
},
{
	.name = "pm_l3_p2_pf_rty",
	.event = "event=0x260ae",
	.desc = "L3 PF received retry port 2, every retry counted",
	.topic = "other",
},
{
	.name = "pm_co_tm_sc_footprint",
	.event = "event=0x26086",
	.desc = "L2 did a cleanifdirty CO to the L3 (ie created an SC line in the L3) OR L2 TM_store hit dirty HPC line and L3 indicated SC line formed in L3 on RDR bus",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_any_sync",
	.event = "event=0x1e05a",
	.desc = "Cycles in which the NTC sync instruction (isync, lwsync or hwsync) is not allowed to complete",
	.topic = "other",
},
{
	.name = "pm_lsu0_l1_cam_cancel",
	.event = "event=0xf090",
	.desc = "ls0 l1 tm cam cancel",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_ci",
	.event = "event=0xc0a8",
	.desc = "Load was not issued to LSU as a cache inhibited (non-cacheable) load but it was later determined to be cache inhibited",
	.topic = "other",
},
{
	.name = "pm_tm_fail_conf_tm",
	.event = "event=0x20ac",
	.desc = "TM aborted because a conflict occurred with another transaction",
	.topic = "other",
},
{
	.name = "pm_shl_st_dep_created",
	.event = "event=0x588c",
	.desc = "Store-Hit-Load Table Read Hit with entry Enabled",
	.topic = "other",
},
{
	.name = "pm_l2_st_hit",
	.event = "event=0x46882",
	.desc = "All successful D-side store dispatches for this thread that were L2 hits",
	.topic = "other",
},
{
	.name = "pm_l3_sn0_busy",
	.event = "event=0x360ac",
	.desc = "Lifetime, sample of snooper machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_bfu_busy",
	.event = "event=0x3005c",
	.desc = "Cycles in which all 4 Binary Floating Point units are busy. The BFU is running at capacity",
	.topic = "other",
},
{
	.name = "pm_br_pred_pcache",
	.event = "event=0x48a0",
	.desc = "Conditional branch completed that used pattern cache prediction",
	.topic = "other",
},
{
	.name = "pm_l2_st_miss",
	.event = "event=0x26880",
	.desc = "All successful D-Side Store dispatches that were an L2 miss for this thread",
	.topic = "other",
},
{
	.name = "pm_ipteg_from_dl2l3_shr",
	.event = "event=0x35048",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a instruction side request",
	.topic = "other",
},
{
	.name = "pm_l3_pf_hit_l3",
	.event = "event=0x260a8",
	.desc = "L3 PF hit in L3 (abandoned)",
	.topic = "other",
},
{
	.name = "pm_l3_pf0_busy",
	.event = "event=0x360b4",
	.desc = "Lifetime, sample of PF machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_ue",
	.event = "event=0xc0b0",
	.desc = "Correctable ECC error on reload data, reported at critical data forward time",
	.topic = "other",
},
{
	.name = "pm_mrk_ic_miss",
	.event = "event=0x4013a",
	.desc = "Marked instruction experienced I cache miss",
	.topic = "other",
},
{
	.name = "pm_flush_disp_sb",
	.event = "event=0x2088",
	.desc = "Dispatch Flush: Scoreboard",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l2miss",
	.event = "event=0x401e8",
	.desc = "The processor's data cache was reloaded from a location other than the local core's L2 due to a marked load",
	.topic = "other",
},
{
	.name = "pm_tm_st_caused_fail",
	.event = "event=0x3688e",
	.desc = "TM Store (fav or non-fav) caused another thread to fail",
	.topic = "other",
},
{
	.name = "pm_l3_sys_guess_wrong",
	.event = "event=0x460b2",
	.desc = "Initial scope=system (VGS or RNS) but data from local or near. Prediction too high",
	.topic = "other",
},
{
	.name = "pm_tage_override_wrong_spec",
	.event = "event=0x58b8",
	.desc = "The TAGE overrode BHT direction prediction and it was correct.   Includes taken and not taken and is counted at execution time",
	.topic = "other",
},
{
	.name = "pm_lsu3_erat_hit",
	.event = "event=0xe890",
	.desc = "Primary ERAT hit.  There is no secondary ERAT",
	.topic = "other",
},
{
	.name = "pm_tm_tabort_treclaim",
	.event = "event=0x2898",
	.desc = "Completion time tabortnoncd, tabortcd, treclaim",
	.topic = "other",
},
{
	.name = "pm_derat_miss_16g",
	.event = "event=0x4c054",
	.desc = "Data ERAT Miss (Data TLB Access) page size 16G",
	.topic = "other",
},
{
	.name = "pm_l3_co_l31",
	.event = "event=0x268a0",
	.desc = "L3 CO to L3.1 OR of port 0 and 1 (lossy = may undercount if two cresps come in the same cyc)",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_4_5_cyc",
	.event = "event=0x5080",
	.desc = "Cycles thread running at priority level 4 or 5",
	.topic = "other",
},
{
	.name = "pm_vsu_fin",
	.event = "event=0x2505c",
	.desc = "VSU instruction finished. Up to 4 per cycle",
	.topic = "other",
},
{
	.name = "pm_br_pred_ccache",
	.event = "event=0x40a4",
	.desc = "Conditional Branch Completed that used the Count Cache for Target Prediction",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_rl4",
	.event = "event=0x2e04a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dl2l3_mod_cyc",
	.event = "event=0x4d12e",
	.desc = "Duration in cycles to reload with Modified (M) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_lhl_shl",
	.event = "event=0xc8b4",
	.desc = "The instruction was flushed because of a sequential load/store consistency.  If a load or store hits on an older load that has either been snooped (for loads) or has stale data (for stores)",
	.topic = "other",
},
{
	.name = "pm_flush_lsu",
	.event = "event=0x58a4",
	.desc = "LSU flushes.  Includes all lsu flushes",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_dl2l3_shr",
	.event = "event=0x1d150",
	.desc = "The processor's data cache was reloaded with Shared (S) data from another chip's L2 or L3 on a different Node or Group (Distant), as this chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_lsu1_false_lhs",
	.event = "event=0xc8a0",
	.desc = "False LHS match detected",
	.topic = "other",
},
{
	.name = "pm_thrd_prio_2_3_cyc",
	.event = "event=0x48bc",
	.desc = "Cycles thread running at priority level 2 or 3",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_wrong_high",
	.event = "event=0x368b2",
	.desc = "Initial scope=group (GS or NNS) but data from local node. Prediction too high",
	.topic = "other",
},
{
	.name = "pm_ls1_pte_tablewalk_cyc",
	.event = "event=0xe8bc",
	.desc = "Cycles when a tablewalk is pending on this thread on table 1",
	.topic = "other",
},
{
	.name = "pm_mrk_fab_rsp_bkill_cyc",
	.event = "event=0x1f152",
	.desc = "cycles L2 RC took for a bkill",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l3_no_conflict_cyc",
	.event = "event=0x4c124",
	.desc = "Duration in cycles to reload from local core's L3 without conflict due to a marked load",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_rl4",
	.event = "event=0x2f14a",
	.desc = "A Page Table Entry was loaded into the TLB from another chip's L4 on the same Node or Group ( Remote) due to a marked data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_l2_grp_guess_wrong",
	.event = "event=0x26888",
	.desc = "L2 guess grp (GS or NNS) and guess was not correct (ie data on-chip OR beyond-group)",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_emsh",
	.event = "event=0xc0ac",
	.desc = "An ERAT miss was detected after a set-p hit. Erat tracker indicates fail due to tlbmiss and the instruction gets flushed because the instruction was working on the wrong address",
	.topic = "other",
},
{
	.name = "pm_l3_sys_guess_correct",
	.event = "event=0x260b2",
	.desc = "Initial scope=system (VGS or RNS) and data from outside group (far or rem)(pred successful)",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_memory_cyc",
	.event = "event=0x1d146",
	.desc = "Duration in cycles to reload from a memory location including L4 from local remote or distant due to a marked load",
	.topic = "other",
},
{
	.name = "pm_lsu0_tm_l1_hit",
	.event = "event=0xe094",
	.desc = "Load tm hit in L1",
	.topic = "other",
},
{
	.name = "pm_l2_group_pump",
	.event = "event=0x46888",
	.desc = "RC requests that were on group (aka nodel) pump attempts",
	.topic = "other",
},
{
	.name = "pm_l2_ld",
	.event = "event=0x16080",
	.desc = "All successful D-side Load dispatches for this thread (L2 miss + L2 hits)",
	.topic = "other",
},
{
	.name = "pm_math_flop_cmpl",
	.event = "event=0x4505c",
	.desc = "Math flop instruction completed",
	.topic = "other",
},
{
	.name = "pm_ls0_ld_vector_fin",
	.event = "event=0xc080",
	.desc = "",
	.topic = "other",
},
{
	.name = "pm_l3_p1_sys_pump",
	.event = "event=0x368b0",
	.desc = "L3 PF sent with sys scope port 1, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_mrk_dpteg_from_l31_shr",
	.event = "event=0x1f146",
	.desc = "A Page Table Entry was loaded into the TLB with Shared (S) data from another core's L3 on the same chip due to a marked data side request.. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_thrd_all_run_cyc",
	.event = "event=0x2000c",
	.desc = "Cycles in which all the threads have the run latch set",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_other",
	.event = "event=0xc0bc",
	.desc = "Other LSU flushes including: Sync (sync ack from L2 caused search of LRQ for oldest snooped load, This will either signal a Precise Flush of the oldest snooped loa or a Flush Next PPC); Data Valid Flush Next (several cases of this, one example is store and reload are lined up such that a store-hit-reload scenario exists and the CDF has already launched and has gotten bad/stale data); Bad Data Valid Flush Next (might be a few cases of this, one example is a larxa (D$ hit) return data and dval but can't allocate to LMQ (LMQ full or other reason). Already gave dval but can't watch it for snoop_hit_larx. Need to take the “bad dval” back and flush all younger ops)",
	.topic = "other",
},
{
	.name = "pm_ic_miss_icbi",
	.event = "event=0x5094",
	.desc = "threaded version, IC Misses where we got EA dir hit but no sector valids were on. ICBI took line out",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_atomic",
	.event = "event=0xc8a8",
	.desc = "Quad-word loads (lq) are considered atomic because they always span at least 2 slices.  If a snoop or store from another thread changes the data the load is accessing between the 2 or 3 pieces of the lq instruction, the lq will be flushed",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_l2miss",
	.event = "event=0x1e04e",
	.desc = "A Page Table Entry was loaded into the TLB from a location other than the local core's L2 due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_br_cmpl",
	.event = "event=0x4d05e",
	.desc = "Any Branch instruction completed",
	.topic = "other",
},
{
	.name = "pm_l3_p0_grp_pump",
	.event = "event=0x260b0",
	.desc = "L3 PF sent with grp scope port 0, counts even retried requests",
	.topic = "other",
},
{
	.name = "pm_mrk_vsu_fin",
	.event = "event=0x30132",
	.desc = "VSU marked instr finish",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_off_chip_cache",
	.event = "event=0x2d120",
	.desc = "The processor's data cache was reloaded either shared or modified data from another core's L2/L3 on a different chip (remote or distant) due to a marked load",
	.topic = "other",
},
{
	.name = "pm_dpteg_from_on_chip_cache",
	.event = "event=0x1e048",
	.desc = "A Page Table Entry was loaded into the TLB either shared or modified data from another core's L2/L3 on the same chip due to a data side request. When using Radix Page Translation, this count excludes PDE reloads. Only PTE reloads are included",
	.topic = "other",
},
{
	.name = "pm_l2_sn_m_wr_done",
	.event = "event=0x16086",
	.desc = "SNP dispatched for a write and was M (true M); for DMA cacheinj this will pulse if rty/push is required (won't pulse if cacheinj is accepted)",
	.topic = "other",
},
{
	.name = "pm_br_corect_pred_taken_cmpl",
	.event = "event=0x489c",
	.desc = "Conditional Branch Completed in which the HW correctly predicted the direction as taken.  Counted at completion time",
	.topic = "other",
},
{
	.name = "pm_mrk_dfu_fin",
	.event = "event=0x20132",
	.desc = "Decimal Unit marked Instruction Finish",
	.topic = "other",
},
{
	.name = "pm_tm_sc_co",
	.event = "event=0x160a6",
	.desc = "L3 castout TM SC line",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_lhs",
	.event = "event=0xc8b0",
	.desc = "Effective Address alias flush : no EA match but Real Address match.  If the data has not yet been returned for this load, the instruction will just be rejected, but if it has returned data, it will be flushed",
	.topic = "other",
},
{
	.name = "pm_l2_rcld_disp",
	.event = "event=0x16084",
	.desc = "All I-or-D side load dispatch attempts for this thread (excludes i_l2mru_tch_reqs)",
	.topic = "other",
},
{
	.name = "pm_mrk_st_drain_to_l2disp_cyc",
	.event = "event=0x3f150",
	.desc = "cycles to drain st from core to L2",
	.topic = "other",
},
{
	.name = "pm_l3_miss",
	.event = "event=0x168a4",
	.desc = "L3 Misses (L2 miss also missing L3, including data/instrn/xlate)",
	.topic = "other",
},
{
	.name = "pm_lsu_stcx_fail",
	.event = "event=0xf080",
	.desc = "",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_dmiss_lmem",
	.event = "event=0x30038",
	.desc = "Completion stall due to cache miss that resolves in local memory",
	.topic = "other",
},
{
	.name = "pm_mrk_tend_fail",
	.event = "event=0x28a4",
	.desc = "Nested or not nested tend failed for a marked tend instruction",
	.topic = "other",
},
{
	.name = "pm_ld_ref_l1",
	.event = "event=0x100fc",
	.desc = "All L1 D cache load references counted at finish, gated by reject",
	.topic = "other",
},
{
	.name = "pm_lsu0_false_lhs",
	.event = "event=0xc0a0",
	.desc = "False LHS match detected",
	.topic = "other",
},
{
	.name = "pm_sn_miss",
	.event = "event=0x468a8",
	.desc = "Any port snooper L3 miss or collision.  Up to 4 can happen in a cycle but we only count 1",
	.topic = "other",
},
{
	.name = "pm_l2_sys_guess_wrong",
	.event = "event=0x36888",
	.desc = "L2 guess system (VGS or RNS) and guess was not correct (ie data ^beyond-group)",
	.topic = "other",
},
{
	.name = "pm_ee_off_ext_int",
	.event = "event=0x2080",
	.desc = "CyclesMSR[EE] is off and external interrupts are active",
	.topic = "other",
},
{
	.name = "pm_ls3_tm_disallow",
	.event = "event=0xe8b8",
	.desc = "A TM-ineligible instruction tries to execute inside a transaction and the LSU disallows it",
	.topic = "other",
},
{
	.name = "pm_tm_fav_caused_fail",
	.event = "event=0x2688e",
	.desc = "TM Load (fav) caused another thread to fail",
	.topic = "other",
},
{
	.name = "pm_sn0_busy",
	.event = "event=0x16090",
	.desc = "SN mach 0 Busy. Used by PMU to sample ave SN lifetime (mach0 used as sample point)",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_rty",
	.event = "event=0x360ae",
	.desc = "L3 CO received retry port 0 (memory only), every retry counted",
	.topic = "other",
},
{
	.name = "pm_l3_wi_usage",
	.event = "event=0x168a8",
	.desc = "Lifetime, sample of Write Inject machine 0 valid",
	.topic = "other",
},
{
	.name = "pm_l3_lat_ci_miss",
	.event = "event=0x468a2",
	.desc = "L3 Lateral Castins Miss",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_page",
	.event = "event=0x4090",
	.desc = "Prefetch Canceled due to page boundary",
	.topic = "other",
},
{
	.name = "pm_l3_p0_co_l31",
	.event = "event=0x460aa",
	.desc = "L3 CO to L3.1 (LCO) port 0 with or without data",
	.topic = "other",
},
{
	.name = "pm_flush_disp",
	.event = "event=0x2880",
	.desc = "Dispatch flush",
	.topic = "other",
},
{
	.name = "pm_l3_p1_pf_rty",
	.event = "event=0x168ae",
	.desc = "L3 PF received retry port 1, every retry counted",
	.topic = "other",
},
{
	.name = "pm_l2_st_disp",
	.event = "event=0x46082",
	.desc = "All successful D-side store dispatches for this thread (L2 miss + L2 hits)",
	.topic = "other",
},
{
	.name = "pm_l2_inst_miss",
	.event = "event=0x36880",
	.desc = "All successful I-side dispatches that were an L2 miss for this thread (excludes i_l2mru_tch reqs)",
	.topic = "other",
},
{
	.name = "pm_ls0_erat_miss_pref",
	.event = "event=0xe084",
	.desc = "LS0 Erat miss due to prefetch",
	.topic = "other",
},
{
	.name = "pm_br_pred",
	.event = "event=0x409c",
	.desc = "Conditional Branch Executed in which the HW predicted the Direction or Target.  Includes taken and not taken and is counted at execution time",
	.topic = "other",
},
{
	.name = "pm_mrk_data_from_l31_mod",
	.event = "event=0x2d144",
	.desc = "The processor's data cache was reloaded with Modified (M) data from another core's L3 on the same chip due to a marked load",
	.topic = "other",
},
{
	.name = "pm_l3_co_lco",
	.event = "event=0x360a4",
	.desc = "Total L3 COs occurred on LCO L3.1 (good cresp, may end up in mem on a retry)",
	.topic = "other",
},
{
	.name = "pm_ic_pref_cancel_hit",
	.event = "event=0x4890",
	.desc = "Prefetch Canceled due to icache hit",
	.topic = "other",
},
{
	.name = "pm_rd_hit_pf",
	.event = "event=0x268a8",
	.desc = "RD machine hit L3 PF machine",
	.topic = "other",
},
{
	.name = "pm_l2_st",
	.event = "event=0x16880",
	.desc = "All successful D-side store dispatches for this thread (L2 miss + L2 hits)",
	.topic = "other",
},
{
	.name = "pm_ic_demand_l2_bht_redirect",
	.event = "event=0x4098",
	.desc = "L2 I cache demand request due to BHT redirect, branch redirect ( 2 bubbles 3 cycles)",
	.topic = "other",
},
{
	.name = "pm_lsu0_srq_s0_valid_cyc",
	.event = "event=0xd0b4",
	.desc = "Slot 0 of SRQ valid",
	.topic = "other",
},
{
	.name = "pm_l3_p0_lco_no_data",
	.event = "event=0x160aa",
	.desc = "Dataless L3 LCO sent port 0",
	.topic = "other",
},
{
	.name = "pm_clb_held",
	.event = "event=0x208c",
	.desc = "CLB (control logic block - indicates quadword fetch block) Hold: Any Reason",
	.topic = "other",
},
{
	.name = "pm_lsu3_store_reject",
	.event = "event=0xf88c",
	.desc = "All internal store rejects cause the instruction to go back to the SRQ and go to sleep until woken up to try again after the condition has been met",
	.topic = "other",
},
{
	.name = "pm_inst_disp",
	.event = "event=0x200f2",
	.desc = "# PPC Dispatched",
	.topic = "other",
},
{
	.name = "pm_tm_outer_tbegin_disp",
	.event = "event=0x4e05e",
	.desc = "Number of outer tbegin instructions dispatched. The dispatch unit determines whether the tbegin instruction is outer or nested. This is a speculative count, which includes flushed instructions",
	.topic = "other",
},
{
	.name = "pm_cmplu_stall_exec_unit",
	.event = "event=0x2d018",
	.desc = "Completion stall due to execution units (FXU/VSU/CRU)",
	.topic = "other",
},
{
	.name = "pm_lsu_flush_next",
	.event = "event=0x20b0",
	.desc = "LSU flush next reported at flush time.  Sometimes these also come with an exception",
	.topic = "other",
},
{
	.name = "pm_isu2_iss_hold_all",
	.event = "event=0x3880",
	.desc = "All ISU rejects",
	.topic = "other",
},
{
	.name = "pm_ls3_ld_vector_fin",
	.event = "event=0xc884",
	.desc = "",
	.topic = "other",
},
{
	.name = "pm_l3_co",
	.event = "event=0x360a8",
	.desc = "L3 castout occurring (does not include casthrough or log writes (cinj/dmaw))",
	.topic = "other",
},
{
	.name = "pm_l3_cinj",
	.event = "event=0x368a4",
	.desc = "L3 castin of cache inject",
	.topic = "other",
},
{
	.name = "pm_lsu_ncst",
	.event = "event=0xc890",
	.desc = "Asserts when a i=1 store op is sent to the nest. No record of issue pipe (LS0/LS1) is maintained so this is for both pipes. Probably don't need separate LS0 and LS1",
	.topic = "other",
},
{
	.name = "pm_lsu_lmq_full_cyc",
	.event = "event=0xd0b8",
	.desc = "Counts the number of cycles the LMQ is full",
	.topic = "other",
},
{
	.name = "pm_l3_grp_guess_correct",
	.event = "event=0x168b2",
	.desc = "Initial scope=group (GS or NNS) and data from same group (near) (pred successful)",
	.topic = "other",
},
{
	.name = "pm_stop_fetch_pending_cyc",
	.event = "event=0x48a4",
	.desc = "Fetching is stopped due to an incoming instruction that will result in a flush",
	.topic = "other",
},
{
	.name = "pm_l2_rcst_disp_fail_addr",
	.event = "event=0x36884",
	.desc = "All D-side store dispatch attempts for this thread that failed due to address collision with RC/CO/SN/SQ",
	.topic = "other",
},
{
	.name = "pm_l3_pf_usage",
	.event = "event=0x260ac",
	.desc = "Rotating sample of 32 PF actives",
	.topic = "other",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_events_map pmu_events_map[] = {
{
	.cpuid = "004[bcd][[:xdigit:]]{4}",
	.version = "1",
	.type = "core",
	.table = pme_power8
},
{
	.cpuid = "004e[[:xdigit:]]{4}",
	.version = "1",
	.type = "core",
	.table = pme_power9
},
{
	.cpuid = 0,
	.version = 0,
	.type = 0,
	.table = 0,
},
};
